-- Kirigami RocketLauncher Package

-- August 2012 Joomla template release

-- http://www.rockettheme.com

--

-- --------------------------------------------------------

--
-- Table structure for table `#__assets`
--

DROP TABLE IF EXISTS `#__assets`;
CREATE TABLE IF NOT EXISTS `#__assets` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set parent.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `level` int(10) unsigned NOT NULL COMMENT 'The cached level in the nested tree.',
  `name` varchar(50) NOT NULL COMMENT 'The unique name for the asset.\n',
  `title` varchar(100) NOT NULL COMMENT 'The descriptive title for the asset.',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_asset_name` (`name`),
  KEY `idx_lft_rgt` (`lft`,`rgt`),
  KEY `idx_parent_id` (`parent_id`)
);

--
-- Dumping data for table `#__assets`
--

INSERT INTO `#__assets` (`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`) VALUES
(1, 0, 1, 203, 0, 'root.1', 'Root Asset', '{"core.login.site":{"6":1,"2":1},"core.login.admin":{"6":1},"core.login.offline":{"6":1},"core.admin":{"8":1},"core.manage":{"7":1},"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
(2, 1, 1, 2, 1, 'com_admin', 'com_admin', '{}'),
(3, 1, 3, 6, 1, 'com_banners', 'com_banners', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(4, 1, 7, 8, 1, 'com_cache', 'com_cache', '{"core.admin":{"7":1},"core.manage":{"7":1}}'),
(5, 1, 9, 10, 1, 'com_checkin', 'com_checkin', '{"core.admin":{"7":1},"core.manage":{"7":1}}'),
(6, 1, 11, 12, 1, 'com_config', 'com_config', '{}'),
(7, 1, 13, 18, 1, 'com_contact', 'com_contact', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(8, 1, 19, 140, 1, 'com_content', 'com_content', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1},"core.delete":[],"core.edit":{"4":1},"core.edit.state":{"5":1},"core.edit.own":[]}'),
(9, 1, 141, 142, 1, 'com_cpanel', 'com_cpanel', '{}'),
(10, 1, 143, 144, 1, 'com_installer', 'com_installer', '{"core.admin":[],"core.manage":{"7":0},"core.delete":{"7":0},"core.edit.state":{"7":0}}'),
(11, 1, 145, 146, 1, 'com_languages', 'com_languages', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(12, 1, 147, 148, 1, 'com_login', 'com_login', '{}'),
(13, 1, 149, 150, 1, 'com_mailto', 'com_mailto', '{}'),
(14, 1, 151, 152, 1, 'com_massmail', 'com_massmail', '{}'),
(15, 1, 153, 154, 1, 'com_media', 'com_media', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1},"core.delete":{"5":1}}'),
(16, 1, 155, 156, 1, 'com_menus', 'com_menus', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(17, 1, 157, 158, 1, 'com_messages', 'com_messages', '{"core.admin":{"7":1},"core.manage":{"7":1}}'),
(18, 1, 159, 160, 1, 'com_modules', 'com_modules', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(19, 1, 161, 164, 1, 'com_newsfeeds', 'com_newsfeeds', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(20, 1, 165, 166, 1, 'com_plugins', 'com_plugins', '{"core.admin":{"7":1},"core.manage":[],"core.edit":[],"core.edit.state":[]}'),
(21, 1, 167, 168, 1, 'com_redirect', 'com_redirect', '{"core.admin":{"7":1},"core.manage":[]}'),
(22, 1, 169, 170, 1, 'com_search', 'com_search', '{"core.admin":{"7":1},"core.manage":{"6":1}}'),
(23, 1, 171, 172, 1, 'com_templates', 'com_templates', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(24, 1, 173, 176, 1, 'com_users', 'com_users', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(25, 1, 177, 182, 1, 'com_weblinks', 'com_weblinks', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1},"core.delete":[],"core.edit":{"4":1},"core.edit.state":{"5":1},"core.edit.own":[]}'),
(26, 1, 183, 184, 1, 'com_wrapper', 'com_wrapper', '{}'),
(27, 8, 20, 21, 2, 'com_content.category.2', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(28, 3, 4, 5, 2, 'com_banners.category.3', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(29, 7, 14, 15, 2, 'com_contact.category.4', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(30, 19, 162, 163, 2, 'com_newsfeeds.category.5', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(31, 25, 178, 179, 2, 'com_weblinks.category.6', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(32, 24, 174, 175, 1, 'com_users.notes.category.7', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(33, 1, 185, 186, 1, 'com_finder', 'com_finder', '{"core.admin":{"7":1},"core.manage":{"6":1}}'),
(34, 1, 187, 188, 1, 'com_joomlaupdate', 'com_joomlaupdate', '{"core.admin":[],"core.manage":[],"core.delete":[],"core.edit.state":[]}'),
(35, 8, 22, 47, 2, 'com_content.category.8', 'Demo Articles', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(36, 8, 48, 65, 2, 'com_content.category.9', 'Sample Content', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(37, 35, 23, 24, 3, 'com_content.article.1', 'Template Features', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(38, 35, 25, 26, 3, 'com_content.article.2', 'Module Positions', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(39, 35, 27, 28, 3, 'com_content.article.3', 'Module Variations', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(40, 35, 29, 30, 3, 'com_content.article.4', 'Template Typography', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(41, 35, 31, 32, 3, 'com_content.article.5', 'Menu Options', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(42, 35, 33, 34, 3, 'com_content.article.6', 'Integrated Extensions', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(43, 35, 35, 36, 3, 'com_content.article.7', 'Tutorials and Guides', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(44, 35, 37, 38, 3, 'com_content.article.8', 'Installation Instructions', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(45, 35, 39, 40, 3, 'com_content.article.9', 'Logo Editing', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(46, 35, 41, 42, 3, 'com_content.article.10', 'Preset Styles', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(47, 35, 43, 44, 3, 'com_content.article.11', 'About Joomla!', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(48, 35, 45, 46, 3, 'com_content.article.12', 'Top News of the Week', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(50, 36, 49, 50, 3, 'com_content.article.14', 'Donec Nunc Magna Posuere', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(51, 36, 51, 52, 3, 'com_content.article.15', 'Lorem Ipsum Dolor Sit Amet', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(52, 36, 53, 54, 3, 'com_content.article.16', 'Vestibulum Dapibus Est Nulla', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(53, 36, 55, 56, 3, 'com_content.article.17', 'Nec Libero Laoreet Faucibus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(54, 36, 57, 58, 3, 'com_content.article.18', 'Sed Imperdiet Ligula Nisi', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(55, 36, 59, 60, 3, 'com_content.article.19', 'Massa Diam Tristique Urna', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(56, 36, 61, 62, 3, 'com_content.article.20', 'Sapien Eros Consectetur Dolor', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(57, 36, 63, 64, 3, 'com_content.article.21', 'Maecenas Varius Neque Nec', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(58, 1, 189, 190, 1, 'com_gantry', 'gantry', '{}'),
(59, 1, 191, 192, 1, 'com_roksprocket', 'roksprocket', '{}'),
(60, 1, 193, 194, 1, 'com_rokgallery', 'rokgallery', '{}'),
(61, 25, 180, 181, 2, 'com_weblinks.category.10', 'RocketTheme', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(62, 7, 16, 17, 2, 'com_contact.category.11', 'RocketTheme', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(63, 8, 66, 75, 2, 'com_content.category.12', 'RokSprocket Tabs', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(64, 63, 67, 68, 3, 'com_content.article.22', 'RokSprocket Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(65, 63, 69, 70, 3, 'com_content.article.23', 'Menu System', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(66, 63, 71, 72, 3, 'com_content.article.24', 'Integrated Extensions', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(67, 8, 76, 109, 2, 'com_content.category.13', 'RokSprocket Mosaic', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(68, 67, 77, 78, 3, 'com_content.article.25', 'About Kirigami', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(69, 67, 79, 80, 3, 'com_content.article.26', 'Mosaic Layout', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(70, 67, 81, 82, 3, 'com_content.article.27', 'Core Framework', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(71, 67, 83, 84, 3, 'com_content.article.28', 'Responsive', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(72, 67, 85, 86, 3, 'com_content.article.29', 'Multi Styles', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(73, 67, 87, 88, 3, 'com_content.article.30', 'Typography', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(74, 67, 89, 90, 3, 'com_content.article.31', '78 Positions', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(75, 67, 91, 92, 3, 'com_content.article.32', 'Logo Picker', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(76, 67, 93, 94, 3, 'com_content.article.33', 'RokSprocket', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(77, 67, 95, 96, 3, 'com_content.article.34', 'Tutorials', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(78, 67, 97, 98, 3, 'com_content.article.35', 'Module Variants', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(79, 67, 99, 100, 3, 'com_content.article.36', 'RokGallery', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(80, 67, 101, 102, 3, 'com_content.article.37', 'RokBooster', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(81, 8, 110, 125, 2, 'com_content.category.14', 'RokSprocket Lists', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(82, 8, 126, 139, 2, 'com_content.category.15', 'RokSprocket Headlines', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(83, 82, 127, 128, 3, 'com_content.article.38', 'Content Typography', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(84, 82, 129, 130, 3, 'com_content.article.39', 'Customize the Logo', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(85, 82, 131, 132, 3, 'com_content.article.40', 'Fusion and Split Menu', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(86, 82, 133, 134, 3, 'com_content.article.41', 'Responsive Layout', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(87, 82, 135, 136, 3, 'com_content.article.42', 'RokGallery', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(88, 82, 137, 138, 3, 'com_content.article.43', 'RokSprocket Extension', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(89, 81, 111, 112, 3, 'com_content.article.44', 'Grid System', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(90, 81, 113, 114, 3, 'com_content.article.45', 'Stunning Interface', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(91, 81, 115, 116, 3, 'com_content.article.46', 'Integrated Features', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(92, 81, 117, 118, 3, 'com_content.article.47', 'Extensible AJAX', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(93, 81, 119, 120, 3, 'com_content.article.48', 'Custom Preset', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(94, 81, 121, 122, 3, 'com_content.article.49', 'Per Menu Support', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(95, 81, 123, 124, 3, 'com_content.article.50', 'and Many More...', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(96, 1, 195, 196, 1, 'com_rokcandy.category.16', 'Basic', ''),
(97, 1, 197, 198, 1, 'com_rokcandy.category.17', 'Typography', ''),
(98, 1, 199, 200, 1, 'com_rokcandy.category.18', 'Uncategorised', ''),
(99, 1, 201, 202, 1, 'com_rokcandy', 'rokcandy', '{}'),
(100, 67, 103, 104, 3, 'com_content.article.51', 'Fusion Menu', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(101, 67, 105, 106, 3, 'com_content.article.52', 'SplitMenu', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(102, 67, 107, 108, 3, 'com_content.article.53', 'K2 Styling', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(103, 63, 73, 74, 3, 'com_content.article.54', 'Styling', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}');

-- --------------------------------------------------------

--
-- Table structure for table `#__associations`
--

DROP TABLE IF EXISTS `#__associations`;
CREATE TABLE IF NOT EXISTS `#__associations` (
  `id` varchar(50) NOT NULL COMMENT 'A reference to the associated item.',
  `context` varchar(50) NOT NULL COMMENT 'The context of the associated item.',
  `key` char(32) NOT NULL COMMENT 'The key for the association computed from an md5 on associated ids.',
  PRIMARY KEY (`context`,`id`),
  KEY `idx_key` (`key`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__banners`
--

DROP TABLE IF EXISTS `#__banners`;
CREATE TABLE IF NOT EXISTS `#__banners` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `type` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `imptotal` int(11) NOT NULL DEFAULT '0',
  `impmade` int(11) NOT NULL DEFAULT '0',
  `clicks` int(11) NOT NULL DEFAULT '0',
  `clickurl` varchar(200) NOT NULL DEFAULT '',
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `description` text NOT NULL,
  `custombannercode` varchar(2048) NOT NULL,
  `sticky` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `params` text NOT NULL,
  `own_prefix` tinyint(1) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `reset` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `language` char(7) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `idx_state` (`state`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`),
  KEY `idx_banner_catid` (`catid`),
  KEY `idx_language` (`language`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__banner_clients`
--

DROP TABLE IF EXISTS `#__banner_clients`;
CREATE TABLE IF NOT EXISTS `#__banner_clients` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `contact` varchar(255) NOT NULL DEFAULT '',
  `email` varchar(255) NOT NULL DEFAULT '',
  `extrainfo` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `metakey` text NOT NULL,
  `own_prefix` tinyint(4) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__banner_tracks`
--

DROP TABLE IF EXISTS `#__banner_tracks`;
CREATE TABLE IF NOT EXISTS `#__banner_tracks` (
  `track_date` datetime NOT NULL,
  `track_type` int(10) unsigned NOT NULL,
  `banner_id` int(10) unsigned NOT NULL,
  `count` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`track_date`,`track_type`,`banner_id`),
  KEY `idx_track_date` (`track_date`),
  KEY `idx_track_type` (`track_type`),
  KEY `idx_banner_id` (`banner_id`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__categories`
--

DROP TABLE IF EXISTS `#__categories`;
CREATE TABLE IF NOT EXISTS `#__categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) unsigned NOT NULL DEFAULT '0',
  `path` varchar(255) NOT NULL DEFAULT '',
  `extension` varchar(50) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` mediumtext NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `metadesc` varchar(1024) NOT NULL COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) NOT NULL COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `cat_idx` (`extension`,`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_path` (`path`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_language` (`language`)
);

--
-- Dumping data for table `#__categories`
--

INSERT INTO `#__categories` (`id`, `asset_id`, `parent_id`, `lft`, `rgt`, `level`, `path`, `extension`, `title`, `alias`, `note`, `description`, `published`, `checked_out`, `checked_out_time`, `access`, `params`, `metadesc`, `metakey`, `metadata`, `created_user_id`, `created_time`, `modified_user_id`, `modified_time`, `hits`, `language`) VALUES
(1, 0, 0, 0, 35, 0, '', 'system', 'ROOT', 'root', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{}', '', '', '', 535, '2009-10-18 16:07:09', 0, '0000-00-00 00:00:00', 0, '*'),
(2, 27, 1, 1, 2, 1, 'uncategorised', 'com_content', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 535, '2010-06-28 13:26:37', 0, '0000-00-00 00:00:00', 0, '*'),
(3, 28, 1, 3, 4, 1, 'uncategorised', 'com_banners', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":"","foobar":""}', '', '', '{"page_title":"","author":"","robots":""}', 535, '2010-06-28 13:27:35', 0, '0000-00-00 00:00:00', 0, '*'),
(4, 29, 1, 5, 6, 1, 'uncategorised', 'com_contact', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 535, '2010-06-28 13:27:57', 0, '0000-00-00 00:00:00', 0, '*'),
(5, 30, 1, 7, 8, 1, 'uncategorised', 'com_newsfeeds', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 535, '2010-06-28 13:28:15', 0, '0000-00-00 00:00:00', 0, '*'),
(6, 31, 1, 9, 10, 1, 'uncategorised', 'com_weblinks', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 535, '2010-06-28 13:28:33', 0, '0000-00-00 00:00:00', 0, '*'),
(7, 32, 1, 11, 12, 1, 'uncategorised', 'com_users.notes', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 535, '2010-06-28 13:28:33', 0, '0000-00-00 00:00:00', 0, '*'),
(8, 35, 1, 13, 14, 1, 'demo-articles', 'com_content', 'Demo Articles', 'demo-articles', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 535, '2012-07-05 07:16:12', 0, '0000-00-00 00:00:00', 0, '*'),
(9, 36, 1, 15, 16, 1, 'sample-content', 'com_content', 'Sample Content', 'sample-content', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 535, '2012-07-05 07:16:36', 0, '0000-00-00 00:00:00', 0, '*'),
(10, 61, 1, 17, 18, 1, 'rockettheme', 'com_weblinks', 'RocketTheme', 'rockettheme', '', '<div class="rt-image rt-floatleft">\r\n	<img alt="RocketTheme WebLinks" src="images/rocketlauncher/weblinks/rockettheme.png" />\r\n</div>\r\n\r\n<p>RocketTheme provides Premium Professional Themes and Templates for OpenSource Platforms: Joomla, Wordpress, phpBB3, Magento &amp; More</p>\r\n\r\n<p>The RocketTheme Template Club features exclusive access to professional templates to help transform your site &amp; set you apart from the competition.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 535, '2012-07-09 11:41:38', 535, '2012-07-25 19:47:30', 0, '*'),
(11, 62, 1, 19, 20, 1, 'rockettheme', 'com_contact', 'RocketTheme', 'rockettheme', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 535, '2012-07-09 11:45:07', 0, '0000-00-00 00:00:00', 0, '*'),
(12, 63, 1, 21, 22, 1, 'roksprocket-tabs', 'com_content', 'RokSprocket Tabs', 'roksprocket-tabs', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 535, '2012-07-09 13:28:11', 0, '0000-00-00 00:00:00', 0, '*'),
(13, 67, 1, 23, 24, 1, 'roksprocket-mosaic', 'com_content', 'RokSprocket Mosaic', 'roksprocket-mosaic', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 535, '2012-07-09 16:14:14', 0, '0000-00-00 00:00:00', 0, '*'),
(14, 81, 1, 25, 26, 1, 'roksprocket-lists', 'com_content', 'RokSprocket Lists', 'roksprocket-lists', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 535, '2012-07-09 16:39:02', 0, '0000-00-00 00:00:00', 0, '*'),
(15, 82, 1, 27, 28, 1, 'roksprocket-headlines', 'com_content', 'RokSprocket Headlines', 'roksprocket-headlines', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 535, '2012-07-09 16:43:09', 0, '0000-00-00 00:00:00', 0, '*'),
(16, 96, 1, 29, 30, 1, 'basic', 'com_rokcandy', 'Basic', 'basic', '', '', 1, 0, '0000-00-00 00:00:00', 1, '', '', '', '', 535, '2012-07-10 18:21:11', 0, '0000-00-00 00:00:00', 0, ''),
(17, 97, 1, 31, 32, 1, 'typography', 'com_rokcandy', 'Typography', 'typography', '', '', 1, 0, '0000-00-00 00:00:00', 1, '', '', '', '', 535, '2012-07-10 18:21:11', 0, '0000-00-00 00:00:00', 0, ''),
(18, 98, 1, 33, 34, 1, 'uncategorised', 'com_rokcandy', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '', '', '', '', 535, '2012-07-10 18:21:11', 0, '0000-00-00 00:00:00', 0, '');

-- --------------------------------------------------------

--
-- Table structure for table `#__contact_details`
--

DROP TABLE IF EXISTS `#__contact_details`;
CREATE TABLE IF NOT EXISTS `#__contact_details` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `con_position` varchar(255) DEFAULT NULL,
  `address` text,
  `suburb` varchar(100) DEFAULT NULL,
  `state` varchar(100) DEFAULT NULL,
  `country` varchar(100) DEFAULT NULL,
  `postcode` varchar(100) DEFAULT NULL,
  `telephone` varchar(255) DEFAULT NULL,
  `fax` varchar(255) DEFAULT NULL,
  `misc` mediumtext,
  `image` varchar(255) DEFAULT NULL,
  `imagepos` varchar(20) DEFAULT NULL,
  `email_to` varchar(255) DEFAULT NULL,
  `default_con` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `catid` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `mobile` varchar(255) NOT NULL DEFAULT '',
  `webpage` varchar(255) NOT NULL DEFAULT '',
  `sortname1` varchar(255) NOT NULL,
  `sortname2` varchar(255) NOT NULL,
  `sortname3` varchar(255) NOT NULL,
  `language` char(7) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
);

--
-- Dumping data for table `#__contact_details`
--

INSERT INTO `#__contact_details` (`id`, `name`, `alias`, `con_position`, `address`, `suburb`, `state`, `country`, `postcode`, `telephone`, `fax`, `misc`, `image`, `imagepos`, `email_to`, `default_con`, `published`, `checked_out`, `checked_out_time`, `ordering`, `params`, `user_id`, `catid`, `access`, `mobile`, `webpage`, `sortname1`, `sortname2`, `sortname3`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`) VALUES
(1, 'Kirigami', 'kirigami', 'August 2012 Template Demo', '123 Kirigami Boulevard', 'Seattle', 'WA', 'United States of America', '00000', '+1-555-555-555', '+1-555-555-555', 'August 2012 Template Demo', 'images/rocketlauncher/contact-us/kirigami-contact.jpg', NULL, 'admin@demo.rockettheme.com', 0, 1, 0, '0000-00-00 00:00:00', 1, '{"show_contact_category":"","show_contact_list":"","presentation_style":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"","linka_name":"","linka":null,"linkb_name":"","linkb":null,"linkc_name":"","linkc":null,"linkd_name":"","linkd":null,"linke_name":"","linke":"","contact_layout":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":""}', 0, 11, 1, '+1-555-555-555', 'http://demo.rockettheme.com/?template=kirigami', '', '', '', '*', '2012-07-09 11:47:54', 535, '', '2012-07-23 15:56:48', 535, '', '', '{"robots":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00');

-- --------------------------------------------------------

--
-- Table structure for table `#__content`
--

DROP TABLE IF EXISTS `#__content`;
CREATE TABLE IF NOT EXISTS `#__content` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `title` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `title_alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '' COMMENT 'Deprecated in Joomla! 3.0',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `sectionid` int(10) unsigned NOT NULL DEFAULT '0',
  `mask` int(10) unsigned NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` text NOT NULL,
  `urls` text NOT NULL,
  `attribs` varchar(5120) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `parentid` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `language` char(7) NOT NULL COMMENT 'The language code for the article.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
);

--
-- Dumping data for table `#__content`
--

INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(1, 37, 'Template Features', 'template-features', '', '<div class="rt-center">\r\n  <span class="promo3">The next generation layout and structure compliments the beautiful and intricate design of the template in conjunction with its many features and integrated extensions</span>\r\n</div>\r\n\r\n<br />\r\n\r\n<div class="rt-image rt-center largemargintop largemarginbottom">\r\n  <img src="images/rocketlauncher/features/features-template-preview.png" alt="image" />\r\n</div>\r\n\r\n<br />\r\n\r\n<div class="rt-center largemargintop largemarginbottom">\r\n  <span class="promo2">Inside <strong>Kirigami</strong> Template</span><br />\r\n  <span class="promo3">Everything You Need to Build Your Stunning Website</span>\r\n</div>\r\n\r\n<br />\r\n\r\n<div class="rt-demo-block rt-demo-width-33 rt-center">\r\n  <div class="rt-demo-spacer">\r\n    <div class="rt-image">\r\n      <img src="images/rocketlauncher/features/feature-1.jpg" alt="image" />\r\n      <h3><a href="index.php?option=com_content&amp;view=article&amp;id=10&amp;Itemid=111" target="_blank"><span>Preset Styles</span></a></h3>\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-33 rt-center">\r\n  <div class="rt-demo-spacer">\r\n    <div class="rt-image">\r\n      <img src="images/rocketlauncher/features/feature-2.jpg" alt="image" />\r\n      <h3><a href="index.php?option=com_content&amp;view=article&amp;id=2&amp;Itemid=103" target="_blank"><span>Modules Position</span></a></h3>\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-33 rt-center">\r\n  <div class="rt-demo-spacer">\r\n    <div class="rt-image">\r\n      <img src="images/rocketlauncher/features/feature-3.jpg" alt="image" />\r\n      <h3><a href="index.php?option=com_content&amp;view=article&amp;id=3&amp;Itemid=104" target="_blank"><span>Module Variations</span></a></h3>\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-33 rt-center">\r\n  <div class="rt-demo-spacer">\r\n    <div class="rt-image">\r\n      <img src="images/rocketlauncher/features/feature-4.jpg" alt="image" />\r\n      <h3><a href="index.php?option=com_content&amp;view=article&amp;id=5&amp;Itemid=106" target="_blank"><span>Mega Menu</span></a></h3>\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-33 rt-center">\r\n  <div class="rt-demo-spacer">\r\n    <div class="rt-image">\r\n      <img src="images/rocketlauncher/features/feature-5.jpg" alt="image" />\r\n      <h3><a href="index.php?option=com_content&amp;view=article&amp;id=4&amp;Itemid=105" target="_blank"><span>Typography</span></a></h3>\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-33 rt-center">\r\n  <div class="rt-demo-spacer">\r\n    <div class="rt-image">\r\n      <img src="images/rocketlauncher/features/feature-6.jpg" alt="image" />\r\n      <h3><a href="index.php?option=com_content&amp;view=article&amp;id=6&amp;Itemid=107" target="_blank"><span>Integrated Extensions</span></a></h3>\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-33 rt-center">\r\n  <div class="rt-demo-spacer">\r\n    <div class="rt-image">\r\n      <img src="images/rocketlauncher/features/feature-7.jpg" alt="image" />\r\n      <h3><a href="index.php?option=com_content&amp;view=article&amp;id=9&amp;Itemid=110" target="_blank"><span>Logo Picker</span></a></h3>\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-33 rt-center">\r\n  <div class="rt-demo-spacer">\r\n    <div class="rt-image">\r\n      <img src="images/rocketlauncher/features/feature-8.jpg" alt="image" />\r\n      <h3><a href="index.php?option=com_content&amp;view=article&amp;id=6&amp;Itemid=107" target="_blank"><span>K2 (3rd Party)</span></a></h3>\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-33 rt-center">\r\n  <div class="rt-demo-spacer">\r\n    <div class="rt-image">\r\n      <img src="images/rocketlauncher/features/feature-9.jpg" alt="image" />\r\n      <h3><a href="index.php?option=com_content&amp;view=article&amp;id=11&amp;Itemid=112" target="_blank"><span>Joomla Stuff</span></a></h3>\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<div class="clear"></div><br />\r\n\r\n<div class="rt-center largemargintop largemarginbottom">\r\n  <span class="promo2"><strong>Gantry</strong> Framework</span><br />\r\n  <span class="promo3">Powerful Framework that Makes Building Websites Easier</span>\r\n</div>\r\n\r\n<br />\r\n\r\n<div class="rt-demo-block rt-demo-width-25">\r\n  <div class="rt-demo-spacer">\r\n    <ul class="list-icon info largemargintop">\r\n      <li class="largemarginbottom"><strong>Compact Grid System</strong><br />CSS grid framework to construct content by providing commonly used dimensions</li>\r\n      <li class="largemarginbottom"><strong>Stunning Admin Interface</strong><br />Gantry provides a uniquely intuitive interface to control all aspects of the design</li>\r\n      <li class="largemarginbottom"><strong>Multi-Page Configuration</strong><br />Assign different template configurations for one or several menu items/pages</li>\r\n    </ul>\r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-50">\r\n  <div class="rt-demo-spacer">\r\n    <div class="rt-image rt-center">\r\n      <img src="images/rocketlauncher/features/feature-admin-panel.png" alt="image" />\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-25">\r\n  <div class="rt-demo-spacer">\r\n      <ul class="list-icon info largemargintop">\r\n        <li class="largemarginbottom"><strong>Source-Ordered 4 Columns</strong><br />With up to 3 total sidebars, you can achieve highly complex mainbody layout scenarios</li>\r\n        <li class="largemarginbottom"><strong>Integrated Gantry Features</strong><br />Many built-in features such as font-sizer, Google Analytics, To-Top Smooth Slider, etc</li>\r\n        <li class="largemarginbottom"><strong>Grid RTL Support</strong><br />Built in RTL support which will automatically order the layout to support RTL</li>\r\n      </ul>\r\n  </div>\r\n</div>\r\n\r\n<div class="clear"></div><br />\r\n\r\n<div class="rt-center largemargintop largemarginbottom">\r\n  <span class="promo2"><strong>Interested</strong>? Want to try <strong>Kirigami</strong>?</span><br />\r\n  <a class="readon medmargintop" href="http://www.rockettheme.com/joomla-templates/kirigami" target="_blank"><span class="promo2"><span class="icon-download-alt"></span>Download</span></a>\r\n</div>\r\n\r\n<div class="clear"></div><br />', '', 1, 0, 0, 8, '2012-07-05 07:18:12', 535, '', '2012-07-31 12:25:31', 535, 0, '0000-00-00 00:00:00', '2012-07-05 07:18:12', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 54, 0, 12, '', '', 1, 615, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(2, 38, 'Module Positions', 'module-positions', '', '<p class="notice">If no modules are published to a position, the entire area or row will not appear/collapse.</p>\r\n\r\n<div class="rt-image">\r\n  <img src="images/rocketlauncher/module-positions/positions-diagram.jpg" alt="Module Positions" />\r\n</div>\r\n\r\n<div class="clear largemarginbottom">&nbsp;</div>\r\n\r\n<div class="rt-center medpaddingtop smallpaddingbottom"><a class="readon"  href="http://www.gantry-framework.org/documentation/joomla/configure/layouts"><span>Documentation: Gantry Framework Layouts</span></a></div>\r\n', '', 1, 0, 0, 8, '2012-07-05 07:18:58', 535, '', '2012-07-25 19:10:13', 535, 0, '0000-00-00 00:00:00', '2012-07-05 07:18:58', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 3, 0, 11, '', '', 1, 163, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(3, 39, 'Module Variations', 'module-variations', '', '<p>There are <strong>10 stylistic module class suffixes</strong>, these add a unique style variation to the module: <strong>box1-4</strong>, <strong>title1-4</strong>, <strong>basictitle</strong> and <strong>basic</strong>; and 25 structural suffixes, these affect the layout and metrics of the module.</p>\r\n', '', 1, 0, 0, 8, '2012-07-05 07:19:40', 535, '', '2012-07-25 19:00:52', 535, 0, '0000-00-00 00:00:00', '2012-07-05 07:19:40', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 2, 0, 10, '', '', 1, 169, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(4, 40, 'Template Typography', 'template-typography', '', '<h4>Creating Beautiful Content With Simple Code</h4>\r\n\r\n<p>Typography is a fundamental part of a template, providing you with the tools to characterise your content and bring it to life. There is a vast array of typography available with the template, as is with our previous releases, from list styles, notice blocks and a diverse number of other elements. </p>\r\n\r\n<p class="notice">If you are using the TinyMCE editor for HTML typography, go to <strong>Extensions &rarr; Plugin Manager &rarr; TinyMCE 2.0 &rarr; Set Code Clean-up on Save to Never</strong>.</p>\r\n\r\n<div class="rt-demo-block rt-demo-width-50">\r\n  <div class="rt-demo-spacer">\r\n    <h2>&lt;h1&gt; Heading Styles</h2>\r\n    \r\n    <h1>H1. Heading 1</h1>\r\n    <div class="clear"></div>\r\n    <h2>H2. Heading 2</h2>\r\n    <h3>H3. Heading 3</h3>\r\n    <h4>H4. Heading 4</h4>\r\n    <h5>H5. Heading 5</h5>\r\n    <h1 class="rt-pagetitle">H1. Page Title</h1>\r\n    <div class="clear"></div>\r\n    <h1 class="title nomarginbottom">H1. Content Title</h1>\r\n  </div>  \r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-50">\r\n  <div class="rt-demo-spacer">\r\n    <h2>&lt;ul&gt; List Styles</h2>\r\n    \r\n    <ul>\r\n      <li><em>This is an example of a standard list style.</em> Lorem ipsum dolor sit amet, consecetur adipiscing elit. Donec sit amet nibh.</li>\r\n      <li><em>This is an example of a standard list style.</em> Lorem ipsum dolor sit amet, consecetur adipiscing elit. Donec sit amet nibh.</li>\r\n      <li><em>This is an example of a standard list style.</em> Lorem ipsum dolor sit amet, consecetur adipiscing elit. Donec sit amet nibh.</li>\r\n      <li><em>This is an example of a standard list style.</em> Lorem ipsum dolor sit amet, consecetur adipiscing elit. Donec sit amet nibh.</li>    \r\n      <li><em>This is an example of a standard list style.</em> Lorem ipsum dolor sit amet, consecetur adipiscing elit. Donec sit amet nibh.</li>        \r\n    </ul>\r\n  </div>\r\n</div>\r\n\r\n<div class="clear largemarginbottom">&nbsp;</div><br />\r\n\r\n<div class="rt-demo-block rt-demo-width-50">\r\n  <div class="rt-demo-spacer">  \r\n    <h2>&lt;p&gt; DropCap Styles</h2>\r\n    \r\n    <p class="dropcap">Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibu. Pellentesque vel enim urna, sit amet blandit ipsum. Maecenas quis sem sit amet nunc pretium mattis. Sed dapibus semper est, sed pretium erat.</p>\r\n    \r\n    <p>Use the following format: <strong>&lt;p class="dropcap"&gt;...&lt;/p&gt; (HTML)</strong> or <strong>&#91;dropcap class="dropcap"&#93;...&#91;/dropcap&#93; (ROKCANDY)</strong>. You can use any letter, symbol or number.</p>\r\n    \r\n    <p class="dropcap2">Praesent rutrum sapien ac felis. Use this format: <strong>&lt;p class="dropcap2"&gt;...&lt;/p&gt; (HTML)</strong> or <strong>&#91;dropcap class="dropcap2"&#93; ... &#91;/dropcap&#93; (ROKCANDY)</strong></p>\r\n    \r\n    <p class="dropcap3">Praesent rutrum sapien ac felis. Use this format: <strong>&lt;p class="dropcap3"&gt;...&lt;/p&gt; (HTML)</strong> or <strong>&#91;dropcap class="dropcap3"&#93; ... &#91;/dropcap&#93; (ROKCANDY)</strong></p>\r\n    \r\n    <p class="dropcap4">Praesent rutrum sapien ac felis. Use this format: <strong>&lt;p class="dropcap4"&gt;...&lt;/p&gt; (HTML)</strong> or <strong>&#91;dropcap class="dropcap4"&#93; ... &#91;/dropcap&#93; (ROKCANDY)</strong></p>\r\n    \r\n    <p class="dropcap5 nomarginbottom">Praesent rutrum sapien ac felis. Use this format: <strong>&lt;p class="dropcap5"&gt;...&lt;/p&gt; (HTML)</strong> or <strong>&#91;dropcap class="dropcap5"&#93; ... &#91;/dropcap&#93; (ROKCANDY)</strong></p>\r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-50">\r\n  <div class="rt-demo-spacer"> \r\n    <h2>&lt;blockquote&gt;  Styles</h2>\r\n    \r\n    <blockquote><p>To replicate, use the following formatting: <strong>&lt;blockquote&gt;&lt;p&gt;....&lt;/p&gt;&lt;/blockquote&gt; (HTML)</strong> or <strong>&#91;blockquote class="default"&#93;...&#91;/blockquote&#93; (ROKCANDY)</strong>.</p></blockquote>\r\n    <br />\r\n    <blockquote class="alignleft"><p>Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis.</p></blockquote>\r\n    \r\n    <p>To replicate, use the following formatting: <strong>&lt;blockquote class=&quot;alignleft&quot;&gt;&lt;p&gt;....&lt;/p&gt;&lt;/blockquote&gt; (HTML)</strong> or <strong>&#91;blockquote class="alignleft"&#93;...&#91;/blockquote&#93; (ROKCANDY)</strong>.</p>\r\n    \r\n    <p>Lorem ipsum dolor sit amet, consecetur adipiscing elit. Mauris metus tortor.</p>\r\n    <br />\r\n    <blockquote class="alignright nomarginbottom"><p>Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis.</p></blockquote>\r\n    \r\n    <p>To replicate, use the following formatting: <strong>&lt;blockquote class=&quot;alignright&quot;&gt;&lt;p&gt;....&lt;/p&gt;&lt;/blockquote&gt; (HTML)</strong> or <strong>&#91;blockquote class="alignright"&#93;...&#91;/blockquote&#93; (ROKCANDY)</strong>.</p>\r\n    \r\n    <p class="nomarginbottom">Lorem ipsum dolor sit amet, consecetur adipiscing elit. Mauris metus tortor.</p>\r\n  </div>\r\n</div>\r\n\r\n<div class="clear largemarginbottom">&nbsp;</div><br />\r\n\r\n<div class="rt-demo-block rt-demo-width-50">\r\n  <div class="rt-demo-spacer"> \r\n    <h2>&lt;pre&gt; Code Styles</h2>\r\n    \r\n<pre class="lines">This is a sample <strong>&lt;pre class=&quot;lines&quot;&gt;...&lt;/pre&gt; (HTML)</strong> or,\r\n<strong>&#91;pre2 class="{lines}"&#93; ... &#91;/pre2&#93; (ROKCANDY)</strong> tag:\r\n\r\ndiv.modulebox-black div.bx1 {\r\n  background: url(../images/box_bl.png) 0 100% repeat;\r\n}\r\n\r\ndiv.modulebox-black div.bx2 {\r\n  background: url(../images/box_tr.png) 100% 0 repeat;\r\n}\r\n</pre>\r\n  \r\n<pre class="nomarginbottom">This is a sample <strong>&lt;pre&gt;...&lt;/pre&gt; (HTML)</strong> or,\r\n<strong>&#91;pre class="{lines}"&#93; ... &#91;/pre&#93; (ROKCANDY)</strong> tag:\r\n\r\ndiv.modulebox-black div.bx1 {\r\n  background: url(../images/box_bl.png) 0 100% repeat;\r\n}\r\n\r\ndiv.modulebox-black div.bx2 {\r\n  background: url(../images/box_tr.png) 100% 0 repeat;\r\n}\r\n</pre>\r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-50">\r\n  <div class="rt-demo-spacer"> \r\n    <h2>&lt;p&gt; Notice Styles</h2>\r\n    \r\n    <p class="approved">This is a <a href="javascript:void(0);">sample</a> of the <em>Approved</em> style. To replicate, use the following syntax: <em>&lt;p class="approved"&gt;....&lt;/p&gt;</em> (HTML) or <em>&#91;notice class="approved"&#93; <em class="normal">...</em> &#91;/notice&#93;</em> (ROKCANDY).</p>\r\n    \r\n    <p class="attention">This is a <a href="javascript:void(0);">sample</a> of the <em>Attention</em> style. To replicate, use the following syntax: <em>&lt;p class="attention"&gt;....&lt;/p&gt;</em> (HTML) or <em>&#91;notice class="attention"&#93; <em class="normal">...</em> &#91;/notice&#93;</em> (ROKCANDY).</p>\r\n    \r\n    <p class="notice">This is a <a href="javascript:void(0);">sample</a> of the <em>Notice</em> style. To replicate, use the following syntax: <em>&lt;p class="notice"&gt;....&lt;/p&gt;</em> (HTML) or <em>&#91;notice class="notice"&#93; <em class="normal">...</em> &#91;/notice&#93;</em> (ROKCANDY).</p>\r\n    \r\n    <p class="alert nomarginbottom">This is a <a href="javascript:void(0);">sample</a> of the <em>Alert</em> style. To replicate, use the following syntax: <em>&lt;p class="alert"&gt;....&lt;/p&gt;</em> (HTML) or <em>&#91;notice class="alert"&#93; <em class="normal">...</em> &#91;/notice&#93;</em> (ROKCANDY).</p>\r\n  </div>\r\n</div>\r\n\r\n<div class="clear largemarginbottom">&nbsp;</div><br />\r\n\r\n<div class="rt-demo-block rt-demo-width-50">\r\n  <div class="rt-demo-spacer"> \r\n    <h2>&lt;span&gt; Text Icon</h2>\r\n    <p>To replicate, the following format: <strong>&lt;span class="text-icon iconname"&gt;...&lt;/span&gt; (HTML)</strong> or <strong>&#91;icon class=&quot;icon name&quot;&#93;...&#91;/icon&#93; (ROKCANDY)</strong>. The class names are listed below, such as "<strong>text-icon email</strong>".</p>\r\n    \r\n    <div class="rt-demo-block rt-demo-width-50">\r\n      <div class="rt-demo-spacer">\r\n        <span class="text-icon email">Text with an email icon</span><br /><br />\r\n        <span class="text-icon phone">Text with a phone icon</span><br /><br />\r\n        <span class="text-icon quote">Text with a quote icon</span><br /><br />\r\n        <span class="text-icon cart">Text with a cart icon</span><br /><br />\r\n        <span class="text-icon rss">Text with a rss icon</span><br /><br />\r\n        <span class="text-icon tags">Text with a tags icon</span><br /><br />\r\n        <span class="text-icon write">Text with a write icon</span><br /><br />\r\n        <span class="text-icon info">Text with an info icon</span><br /><br />\r\n        <span class="text-icon sound">Text with a sound icon</span><br /><br />\r\n        <span class="text-icon rightarrow">Text with a rightarrow icon</span><br /><br />\r\n        <span class="text-icon leftarrow">Text with a leftarrow icon</span><br /><br />\r\n        <span class="text-icon circlearrow">Text with a circlearrow icon</span><br /><br />\r\n        <span class="text-icon downarrow">Text with a downarrow icon</span><br /><br />\r\n        <span class="text-icon uparrow">Text with an uparrow icon</span>\r\n      </div>\r\n    </div>\r\n    <div class="rt-demo-block rt-demo-width-50">\r\n      <div class="rt-demo-spacer">\r\n        <span class="text-icon person">Text with a person icon</span><br /><br />\r\n        <span class="text-icon calendar">Text with a calendar icon</span><br /><br />\r\n        <span class="text-icon doc">Text with a doc icon</span><br /><br />\r\n        <span class="text-icon bulb">Text with a bulb icon</span><br /><br />\r\n        <span class="text-icon twitter">Text with a twitter icon</span><br /><br />\r\n        <span class="text-icon youtube">Text with a youtube icon</span><br /><br />\r\n        <span class="text-icon skype">Text with a skype icon</span><br /><br />\r\n        <span class="text-icon facebook">Text with a facebook icon</span><br /><br />\r\n        <span class="text-icon like">Text with a like icon</span><br /><br />\r\n        <span class="text-icon video">Text with a video icon</span><br /><br />\r\n        <span class="text-icon dropbox">Text with a dropbox icon</span><br /><br />\r\n        <span class="text-icon vimeo">Text with a vimeo icon</span><br /><br />\r\n        <span class="text-icon paypal">Text with a paypal icon</span>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-50">\r\n  <div class="rt-demo-spacer">\r\n    <h2>&lt;em&gt; Emphasis Styles</h2>\r\n    \r\n    <p>This is a emphasis tag that allows you to <em class="italic">highlight words or phrases</em>. Use the following format: <strong>&lt;em class=&quot;italic&quot;&gt;...&lt;/em&gt; (HTML)</strong> or <strong>&#91;emphasis&#93;...&#91;/emphasis&#93; (ROKCANDY)</strong></p>\r\n    \r\n    <p>This is a emphasis tag that allows you to <em class="bold">highlight words or phrases</em>. Use the following format: <strong>&lt;em class=&quot;bold&quot;&gt;...&lt;/em&gt; (HTML)</strong> or <strong>&#91;emphasisbold&#93;...&#91;/emphasisbold&#93; (ROKCANDY)</strong></p>\r\n    \r\n    <p>This is a emphasis tag that allows you to <em class="bold2">highlight words or phrases</em>. Use the following format: <strong>&lt;em class=&quot;bold2&quot;&gt;...&lt;/em&gt; (HTML)</strong> or <strong>&#91;emphasisbold2&#93;...&#91;/emphasisbold2&#93; (ROKCANDY)</strong></p>\r\n    \r\n    <p>This is a emphasis tag that allows you to <em class="highlight">highlight words or phrases</em>. Use the following format: <strong>&lt;em class=&quot;highlight&quot;&gt;...&lt;/em&gt; (HTML)</strong> or <strong>&#91;highlight class=&quot;default&quot;&#93;...&#91;/highlight&#93; (ROKCANDY)</strong></p>\r\n    \r\n    <p>This is a emphasis tag that allows you to <em class="highlight white">highlight words or phrases</em>. Use the following format: <strong>&lt;em class=&quot;highlight white&quot;&gt;...&lt;/em&gt; (HTML)</strong> or <strong>&#91;highlight class=&quot;white&quot;&#93;...&#91;/highlight&#93; (ROKCANDY)</strong></p>\r\n    \r\n    <p>This is a emphasis tag that allows you to <em class="highlight black">highlight words or phrases</em>. Use the following format: <strong>&lt;em class=&quot;highlight black&quot;&gt;...&lt;/em&gt; (HTML)</strong> or <strong>&#91;highlight class=&quot;black&quot;&#93;...&#91;/highlight&#93; (ROKCANDY)</strong></p>\r\n    \r\n    <p>This is a emphasis tag that allows you to <em class="highlight green">highlight words or phrases</em>. Use the following format: <strong>&lt;em class=&quot;highlight green&quot;&gt;...&lt;/em&gt; (HTML)</strong> or <strong>&#91;highlight class=&quot;green&quot;&#93;...&#91;/highlight&#93; (ROKCANDY)</strong></p>\r\n    \r\n    <p>This is a emphasis tag that allows you to <em class="highlight yellow">highlight words or phrases</em>. Use the following format: <strong>&lt;em class=&quot;highlight yellow&quot;&gt;...&lt;/em&gt; (HTML)</strong> or <strong>&#91;highlight class=&quot;yellow&quot;&#93;...&#91;/highlight&#93; (ROKCANDY)</strong></p>\r\n    \r\n    <p>This is a emphasis tag that allows you to <em class="highlight blue">highlight words or phrases</em>. Use the following format: <strong>&lt;em class=&quot;highlight blue&quot;&gt;...&lt;/em&gt; (HTML)</strong> or <strong>&#91;highlight class=&quot;blue&quot;&#93;...&#91;/highlight&#93; (ROKCANDY)</strong></p>\r\n    \r\n    <p class="nomarginbottom">This is a emphasis tag that allows you to <em class="highlight red">highlight words or phrases</em>. Use the following format: <strong>&lt;em class=&quot;highlight red&quot;&gt;...&lt;/em&gt; (HTML)</strong> or <strong>&#91;highlight class=&quot;red&quot;&#93;...&#91;/highlight&#93; (ROKCANDY)</strong></p>\r\n  </div>\r\n</div>\r\n\r\n<div class="clear largemarginbottom">&nbsp;</div><br />\r\n\r\n<div class="rt-demo-spacer">\r\n  <h2>Font Awesome Icons</h2>\r\n\r\n  <p>Font Awesome is a pictographic language of web-related actions which delivers 220 icons. The Font Awesome webfont, CSS, and LESS files are licensed under CC BY 3.0 and you can find the full examples of usage at <a href="http://fortawesome.github.com/Font-Awesome" target="_blank">Font Awesome - http://fortawesome.github.com/Font-Awesome</a></p>\r\n\r\n  <p>To replicate, use the following format: <strong>&lt;span class="<em>icon-name</em>"&gt;&lt;/span&gt;</strong> or <strong>&#91;span class=&quot;<em>icon-name</em>&quot;&#93;...&#91;/span&#93; (ROKCANDY)</strong>. The icons name are listed below, such as "<strong>icon-signal</strong>".</p>\r\n\r\n  <div class="rt-demo-block rt-demo-width-25">\r\n    <div class="rt-demo-spacer">\r\n      <span class="icon-adjust">Text using <strong>icon-adjust</strong></span><br /><br />\r\n      <span class="icon-asterisk">Text using <strong>icon-asterisk</strong></span><br /><br />\r\n      <span class="icon-calendar">Text using <strong>icon-calendar</strong></span><br /><br />\r\n    </div>\r\n  </div>\r\n\r\n  <div class="rt-demo-block rt-demo-width-25">\r\n    <div class="rt-demo-spacer">\r\n      <span class="icon-flag">Text using <strong>icon-flag</strong></span><br /><br />\r\n      <span class="icon-external-link">Text using <strong>icon-external-link</strong></span><br /><br />\r\n      <span class="icon-gift">Text using <strong>icon-gift</strong></span><br /><br />\r\n    </div>\r\n  </div>\r\n\r\n  <div class="rt-demo-block rt-demo-width-25">\r\n    <div class="rt-demo-spacer">\r\n      <span class="icon-print">Text using <strong>icon-print</strong></span><br /><br />\r\n      <span class="icon-group">Text using <strong>icon-group</strong></span><br /><br />\r\n      <span class="icon-signal">Text using <strong>icon-signal</strong></span><br /><br />\r\n    </div>\r\n  </div>\r\n\r\n  <div class="rt-demo-block rt-demo-width-25">\r\n    <div class="rt-demo-spacer">\r\n      <span class="icon-shopping-cart">Text using <strong>icon-shopping-cart</strong></span><br /><br />\r\n      <span class="icon-leaf">Text using <strong>icon-leaf</strong></span><br /><br />\r\n      <span class="icon-download-alt">Text using <strong>icon-download-alt</strong></span><br /><br />\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<div class="clear largemarginbottom">&nbsp;</div><br />\r\n\r\n<div class="rt-demo-spacer">\r\n  <h2>&lt;ul&gt; List Styles (Icons)</h2>\r\n\r\n  <p>To replicate, use the following format: <strong>&lt;ul class="list-icon icon_name"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong> or <strong>&#91;list class="list-icon icon_name"&#93;&#91;li&#93;....&#91;/li&#93;&#91;li....&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>. The icon names are listed below, such as "<strong>cart</strong>".</p>\r\n\r\n  <div class="rt-demo-block rt-demo-width-25">\r\n    <div class="rt-demo-spacer">\r\n      <ul class="list-icon email">\r\n        <li>A list item using the <strong>list-icon email</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon email</strong> class.</li>  </ul>\r\n      <br />\r\n      <ul class="list-icon phone">\r\n        <li>A list item using the <strong>list-icon phone</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon phone</strong> class.</li>\r\n      </ul>\r\n      <br />\r\n      <ul class="list-icon quote">\r\n        <li>A list item using the <strong>list-icon quote</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon quote</strong> class.</li>  </ul>\r\n      <br />\r\n      <ul class="list-icon twitter">\r\n        <li>A list item using the <strong>list-icon twitter</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon twitter</strong> class.</li>\r\n      </ul>\r\n      <br />\r\n      <ul class="list-icon youtube">\r\n        <li>A list item using the <strong>list-icon youtube</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon youtube</strong> class.</li>\r\n      </ul>\r\n      <br />\r\n      <ul class="list-icon facebook">\r\n        <li>A list item using the <strong>list-icon facebook</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon facebook</strong> class.</li>  </ul>\r\n      <br />\r\n      <ul class="list-icon cart nomarginbottom">\r\n        <li>A list item using the <strong>list-icon cart</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon cart</strong> class.</li>  </ul>\r\n    </div>\r\n  </div>\r\n  <div class="rt-demo-block rt-demo-width-25">\r\n    <div class="rt-demo-spacer">\r\n      <ul class="list-icon tags">\r\n        <li>A list item using the <strong>list-icon tags</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon tags</strong> class.</li>  </ul>\r\n      <br />\r\n      <ul class="list-icon write">\r\n        <li>A list item using the <strong>list-icon write</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon write</strong> class.</li>  </ul>\r\n      <br />\r\n      <ul class="list-icon info">\r\n        <li>A list item using the <strong>list-icon info</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon info</strong> class.</li>  </ul>\r\n      <br />\r\n      <ul class="list-icon sound">\r\n        <li>A list item using the <strong>list-icon sound</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon sound</strong> class.</li>  </ul>\r\n      <br />\r\n      <ul class="list-icon rightarrow">\r\n        <li>A list item using the <strong>list-icon rightarrow</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon rightarrow</strong> class.</li>\r\n      </ul>\r\n      <br />\r\n      <ul class="list-icon skype">\r\n        <li>A list item using the <strong>list-icon skype</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon skype</strong> class.</li>\r\n      </ul>\r\n      <br />\r\n      <ul class="list-icon rss nomarginbottom">\r\n        <li>A list item using the <strong>list-icon rss</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon rss</strong> class.</li>\r\n      </ul>\r\n    </div>  \r\n  </div>\r\n  <div class="rt-demo-block rt-demo-width-25">\r\n    <div class="rt-demo-spacer">\r\n      <ul class="list-icon leftarrow">\r\n        <li>A list item using the <strong>list-icon leftarrow</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon leftarrow</strong> class.</li>\r\n      </ul>\r\n      <br />\r\n      <ul class="list-icon circlearrow">\r\n        <li>A list item using the <strong>list-icon circlearrow</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon circlearrow</strong> class.</li>\r\n      </ul>\r\n      <br />\r\n      <ul class="list-icon dropbox">\r\n        <li>A list item using the <strong>list-icon dropbox</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon dropbox</strong> class.</li>\r\n      </ul>\r\n      <br />\r\n      <ul class="list-icon vimeo">\r\n        <li>A list item using the <strong>list-icon vimeo</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon vimeo</strong> class.</li>\r\n      </ul>\r\n      <br />\r\n      <ul class="list-icon downarrow">\r\n        <li>A list item using the <strong>list-icon downarrow</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon downarrow</strong> class.</li>\r\n      </ul>\r\n      <br />\r\n      <ul class="list-icon video">\r\n        <li>A list item using the <strong>list-icon video</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon video</strong> class.</li>\r\n      </ul>\r\n      <br />\r\n      <ul class="list-icon like nomarginbottom">\r\n        <li>A list item using the <strong>list-icon like</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon like</strong> class.</li>\r\n      </ul>\r\n    </div>\r\n  </div>\r\n  <div class="rt-demo-block rt-demo-width-25">\r\n    <div class="rt-demo-spacer">\r\n      <ul class="list-icon uparrow">\r\n        <li>A list item using the <strong>list-icon uparrow</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon uparrow</strong> class.</li>\r\n      </ul>\r\n      <br />\r\n      <ul class="list-icon person">\r\n        <li>A list item using the <strong>list-icon person</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon person</strong> class.</li>\r\n      </ul>\r\n      <br />\r\n      <ul class="list-icon calendar">\r\n        <li>A list item using the <strong>list-icon calendar</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon calendar</strong> class.</li>\r\n      </ul>\r\n      <br />\r\n      <ul class="list-icon bulb">\r\n        <li>A list item using the <strong>list-icon bulb</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon bulb</strong> class.</li>\r\n      </ul>\r\n      <br />\r\n      <ul class="list-icon paypal">\r\n        <li>A list item using the <strong>list-icon paypal</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon paypal</strong> class.</li>\r\n      </ul>\r\n      <br />\r\n      <ul class="list-icon doc nomarginbottom">\r\n        <li>A list item using the <strong>list-icon doc</strong> class.</li>\r\n        <li>A list item using the <strong>list-icon doc</strong> class.</li>\r\n      </ul>\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<div class="clear largemarginbottom">&nbsp;</div><br />\r\n<div class="rt-demo-spacer">\r\n  <h2>&lt;ul&gt; List Styles (CSS3)</h2>\r\n\r\n  <p>These list styles are based on the latest CSS3 techniques and are designed to work in modern browsers (will not display properly in IE6-IE8).</p>\r\n\r\n  <p>To replicate, use the following format: <strong>&lt;ul class="class name"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong> or <strong>&#91;list class=&quot;class name&quot;&#93;&#91;li&#93;....&#91;/li&#93;&#91;li....&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>. The class names are listed below, such as "<strong>checkmark red</strong>".</p>\r\n\r\n  <div class="rt-demo-block rt-demo-width-25">\r\n    <div class="rt-demo-spacer">\r\n      <ul class="checkmark">\r\n        <li>checkmark</li>\r\n        <li>checkmark</li>\r\n      </ul>\r\n      \r\n      <ul class="circle-checkmark">\r\n        <li>circle-checkmark</li>\r\n        <li>circle-checkmark</li>\r\n      </ul>\r\n      \r\n      <ul class="square-checkmark">\r\n        <li>square-checkmark</li>\r\n        <li>square-checkmark</li>\r\n      </ul>\r\n      \r\n      <ul class="checkmark green">\r\n        <li>checkmark green</li>\r\n        <li>checkmark green</li>\r\n      </ul>\r\n      \r\n      <ul class="checkmark yellow">\r\n        <li>checkmark yellow</li>\r\n        <li>checkmark yellow</li>\r\n      </ul>\r\n      \r\n      <ul class="checkmark red nomarginbottom">\r\n        <li>checkmark red</li>\r\n        <li>checkmark red</li>\r\n      </ul>\r\n    </div>\r\n  </div>\r\n  <div class="rt-demo-block rt-demo-width-25">\r\n    <div class="rt-demo-spacer">\r\n      <ul class="checkmark blue">\r\n        <li>checkmark blue</li>\r\n        <li>checkmark blue</li>\r\n      </ul>\r\n      \r\n      <ul class="checkmark white">\r\n        <li>checkmark white</li>\r\n        <li>checkmark white</li>\r\n      </ul>\r\n      \r\n      <ul class="triangle-small">\r\n        <li>triangle-small</li>\r\n        <li>triangle-small</li>\r\n      </ul>\r\n      \r\n      <ul class="triangle">\r\n        <li>triangle</li>\r\n        <li>triangle</li>\r\n      </ul>\r\n      \r\n      <ul class="triangle-large">\r\n        <li>triangle-large</li>\r\n        <li>triangle-large</li>\r\n      </ul>\r\n      \r\n      <ul class="triangle green nomarginbottom">\r\n        <li>triangle green</li>\r\n        <li>triangle green</li>\r\n      </ul>\r\n    </div>\r\n  </div>\r\n  <div class="rt-demo-block rt-demo-width-25">\r\n    <div class="rt-demo-spacer">\r\n      <ul class="triangle yellow">\r\n        <li>triangle yellow</li>\r\n        <li>triangle yellow</li>\r\n      </ul>\r\n      \r\n      <ul class="triangle red">\r\n        <li>triangle red</li>\r\n        <li>triangle red</li>\r\n      </ul>\r\n      \r\n      <ul class="triangle blue">\r\n        <li>triangle blue</li>\r\n        <li>triangle blue</li>\r\n      </ul>\r\n      \r\n      <ul class="triangle white">\r\n        <li>triangle white</li>\r\n        <li>triangle white</li>\r\n      </ul>\r\n      \r\n      <ul class="circle-small">\r\n        <li>circle-small</li>\r\n        <li>circle-small</li>\r\n      </ul>\r\n      \r\n      <ul class="circle nomarginbottom">\r\n        <li>circle</li>\r\n        <li>circle</li>\r\n      </ul>\r\n    </div>\r\n  </div>\r\n  <div class="rt-demo-block rt-demo-width-25">\r\n    <div class="rt-demo-spacer">\r\n      <ul class="circle-large">\r\n        <li>circle-large</li>\r\n        <li>circle-large</li>\r\n      </ul>\r\n      \r\n      <ul class="circle green">\r\n        <li>circle green</li>\r\n        <li>circle green</li>\r\n      </ul>\r\n      \r\n      <ul class="circle yellow">\r\n        <li>circle yellow</li>\r\n        <li>circle yellow</li>\r\n      </ul>\r\n      \r\n      <ul class="circle red">\r\n        <li>circle red</li>\r\n        <li>circle red</li>\r\n      </ul>\r\n      \r\n      <ul class="circle blue">\r\n        <li>circle blue</li>\r\n        <li>circle blue</li>\r\n      </ul>\r\n      \r\n      <ul class="circle white nomarginbottom">\r\n        <li>circle white</li>\r\n        <li>circle white</li>\r\n      </ul>\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<div class="clear largemarginbottom">&nbsp;</div><br />\r\n\r\n<div class="rt-demo-spacer">\r\n  <h2>&lt;span&gt; Inset Styles</h2>\r\n\r\n  <p>\r\n    Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.\r\n    <span class="inset-right nomarginbottom"><span class="inset-right-title">Inset Right Title</span>You will need to use the following formatting: <strong>&lt;span class=&quot;inset-right&quot;&gt; &lt;span class=&quot;inset-right-title&quot;&gt; .... &lt;/span&gt; <em class="normal"> ... some content ... </em>&lt;/strong&gt; (HTML)</strong> or <strong>&#91;inset side="right" title="Inset Right Title"&#93; ... some content ...&#91;/inset&#93; (ROKCANDY)</strong></span>\r\n    Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh.\r\n  </p>\r\n\r\n  <p>\r\n    Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.\r\n    <span class="inset-left nomarginbottom"><span class="inset-left-title">Inset Left Title</span>You will need to use the following formatting: <strong>&lt;span class=&quot;inset-left&quot;&gt; &lt;span class=&quot;inset-left-title&quot;&gt; .... &lt;/span&gt; <em class="normal"> ... some content ... </em>&lt;/strong&gt; (HTML)</strong> or <strong>&#91;inset side="left" title="Inset Left Title"&#93; ... some content ...&#91;/inset&#93; (ROKCANDY)</strong></span>\r\n    Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh.</p>\r\n\r\n  <p>Sed euismod magna a nibh. Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque.</p>\r\n  <p class="nomarginbottom">Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.\r\n  </p>\r\n</div>\r\n\r\n<div class="clear"></div>', '', 1, 0, 0, 8, '2012-07-05 07:20:06', 535, '', '2012-07-31 16:49:20', 535, 0, '0000-00-00 00:00:00', '2012-07-05 07:20:06', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 10, 0, 9, '', '', 1, 90, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(5, 41, 'Menu Options', 'menu-options', '', '<p class="alert">RokNavMenu is the core of all the powerful Kirigami menu system. Please ensure you are using the latest version of RokNavMenu, available <a href="http://www.rockettheme.com/extensions-joomla/roknavmenu" target="_blank">here</a>.</p>\r\n\r\n<h2>Fusion with MegaMenu</h2>\r\n\r\n<p><strong>Fusion Menu</strong> is a menu theme of the <strong>RokNavMenu</strong> extension, the addon that drives all RocketTheme template menus. It is primarily a javascript enhanced CSS dropdown menu, that combines standard suckerfish type functionality with animations, transitions and other advanced effects powered by Mootools.</p>\r\n\r\n<div class="rt-image">\r\n  <img src="images/rocketlauncher/menu-options/fusionmenu.jpg" alt="FusionMenu" />\r\n</div>\r\n\r\n<div class="clear largemarginbottom">&nbsp;</div><br />\r\n\r\n<h2>SplitMenu</h2>\r\n\r\n<p>A static menu system that displays 1st level items in the main horizontal menu and further children in the Sidebar.</p>\r\n\r\n<div class="rt-image">\r\n  <img src="images/rocketlauncher/menu-options/splitmenu.jpg" alt="SplitMenu" />\r\n</div>\r\n\r\n<div class="clear largemarginbottom">&nbsp;</div><br />\r\n\r\n<p class="notice">All Menu Items can be edited from <strong>Admin &rarr; Menu &rarr; <em>Menu Name</em> &rarr; <em>Menu Item</em></strong>.</p>\r\n\r\n<br />\r\n\r\n<h2>Creating child menu items</h2>\r\n\r\n<p>Go to <strong>Admin &rarr; Menu &rarr; <em>A Menu</em> &rarr; <em>A Menu Item</em> &rarr; Select a <em>Parent Item</em></strong>, and it will appear as a child of it.</p>\r\n\r\n<div class="rt-demo-block rt-demo-width-50">\r\n  <div class="rt-demo-spacer">\r\n    <div class="rt-image">\r\n      <img src="images/rocketlauncher/menu-options/childmenu-1.jpg" alt="image" />\r\n    </div> \r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-50">\r\n  <div class="rt-demo-spacer">\r\n    <div class="rt-image">\r\n      <img src="images/rocketlauncher/menu-options/childmenu-2.jpg" alt="image" />\r\n    </div>  \r\n  </div>\r\n</div>\r\n\r\n<div class="clear"></div>\r\n', '', 1, 0, 0, 8, '2012-07-05 07:20:29', 535, '', '2012-07-25 19:44:43', 535, 0, '0000-00-00 00:00:00', '2012-07-05 07:20:29', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 3, 0, 8, '', '', 1, 146, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(6, 42, 'Integrated Extensions', 'integrated-extensions', '', '<div class="rt-center largemargintop largemarginbottom">\r\n  <span class="promo2">Integrated Extensions</span><br />\r\n  <span class="promo3">Enhance Your Website with the <strong>Powerful Tools</strong></span>\r\n</div>\r\n\r\n<div class="clear"></div>\r\n\r\n<div class="rt-center">\r\n<a target="_blank" href="http://www.rockettheme.com/joomla-templates/kirigami" class="readon medmargintop"><span class="promo2"><span class="icon-download-alt"></span>Download</span></a>\r\n</div>', '', 1, 0, 0, 8, '2012-07-05 07:20:54', 535, '', '2012-07-27 16:09:45', 535, 0, '0000-00-00 00:00:00', '2012-07-05 07:20:54', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 7, 0, 7, '', '', 1, 321, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(7, 43, 'Tutorials and Guides', 'tutorials-and-guides', '', '<p>Kirigami for Joomla is a RocketTheme Joomla Template Club release featuring the revolutionary Gantry Joomla Template Framework. Gantry is a comprehensive set of building blocks to enable the rapid development and realization of a design into a flexible and powerful web platform theme.</p>\r\n\r\n<p class="notice">To configure the template, navigate to <strong>Extensions &rarr; Template Manager &rarr; <em>rt_kirigami</em></strong>. Mouseover the labels to view a description of each parameter.</p>', '', 1, 0, 0, 8, '2012-07-05 07:21:24', 535, '', '2012-07-29 15:39:12', 535, 0, '0000-00-00 00:00:00', '2012-07-05 07:21:24', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 12, 0, 6, '', '', 1, 149, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(8, 44, 'Installation Instructions', 'installation-instructions', '', '<p>The following is a guide that covers how to set up your new <strong>Kirigami</strong> template on your Joomla! site. Here you can find an overview of the files included in the Kirigami release and instructions on installing and activating the template in your Joomla! install.</p>\r\n\r\n<p class="notice"><strong>Note:</strong> The <strong>Bundle</strong> Template is only necessary if the Gantry Library is not installed at <strong>/libraries/gantry directory</strong>.</p>\r\n\r\n<h3>Step 1 - Installation</h3>\r\n\r\n<ol class="largemarginbottom">\r\n  <li>Install from <strong>Admin &rarr; Extensions &rarr; Extensions Manager</strong></li>\r\n  <li>Browse for <strong>rt_kirigami.zip</strong> and click <strong>Upload &amp; Install</strong></li>  \r\n</ol>\r\n\r\n<div class="rt-image">\r\n  <img alt="Image" src="images/rocketlauncher/installation/installation-1.jpg" />\r\n</div>\r\n\r\n<div class="clear largemarginbottom">&nbsp;</div>\r\n\r\n<h3>Step 2 - Template Default</h3>\r\n\r\n<ol class="largemarginbottom">\r\n  <li>Make the template default at <strong>Admin &rarr; Extensions &rarr; Template Manager</strong></li>\r\n  <li>Select <strong>rt_kirigami</strong></li>\r\n  <li>Press <strong>Make Default</strong></li>\r\n</ol>\r\n\r\n<div class="rt-image">\r\n  <img alt="Image" src="images/rocketlauncher/installation/installation-2.jpg" />\r\n</div>\r\n\r\n<div class="clear largemarginbottom">&nbsp;</div><br />\r\n\r\n<h2>RocketLauncher Instructions</h2>\r\n\r\n<p>We always recommend installing a <strong>RocketLauncher</strong> first to trial and understand the template more effectively. It must be installed as <strong>new</strong>, and <strong>not</strong> over an existing Joomla install.</p>\r\n\r\n<h3>Step 1 - Upload</h3>\r\n\r\n<ul class="medmarginbottom">\r\n  <li><strong>Download</strong> the RocketLauncher</li>\r\n  <li><strong>Unzip</strong> the file</li>\r\n  <li><strong>Upload</strong> the created folder to your server</li>\r\n</ul>\r\n\r\n<p class="notice"><strong>Note:</strong> You can upload all the files via FTP, or use cPanel or SSH to upload the zip and unzip directly onto the server. Enquire with your hosting provider.</p>\r\n\r\n<h3>Step 2 - Installation</h3>\r\n\r\n<ul>\r\n  <li>Go to <a href="#">www.yoursite.com/<em>*folder name*</em></a></li>\r\n  <li>Follow the Installation instructions</li>\r\n  <li>Ensure you click <em class="bold2">Install Sample Data</em> during installation</li>\r\n  <li>Remove the installation folder in the Installation interface</li>\r\n</ul>\r\n', '', 1, 0, 0, 8, '2012-07-05 07:21:47', 535, '', '2012-07-25 13:47:09', 535, 0, '0000-00-00 00:00:00', '2012-07-05 07:21:47', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 2, 0, 5, '', '', 1, 62, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(9, 45, 'Logo Editing', 'logo-editing', '', '<p>There are two methods of changing the Kirigami logo: <strong>via the logo picker</strong> and <strong>manual</strong> change.</p>\r\n\r\n<h3>The Logo Picker</h3>\r\n\r\n<ol>\r\n  <li>Enable <strong>Logo</strong> and set to <strong>Custom</strong> at <em>Admin &rarr; Extensions &rarr; Templates Manager &rarr; rt_kirigami &rarr; Features.</em></li>\r\n  <li>Set <strong>Logo Picker</strong> to either <strong>RokGallery</strong> or <strong>MediaManager</strong>.</li>\r\n  <li><strong>Select</strong> your logo, <strong>Insert</strong> and <strong>Save</strong></li>\r\n</ol>\r\n\r\n<br />\r\n\r\n<div class="rt-image">\r\n  <img src="images/rocketlauncher/logo-editing/logo-panel.jpg" alt="Logo Panel" />\r\n</div>\r\n\r\n<div class="clear largemarginbottom">&nbsp;</div><br />\r\n\r\n<div class="rt-image">\r\n  <img src="images/rocketlauncher/logo-editing/select-logo.jpg" alt="Select Logo" />\r\n</div>\r\n\r\n<div class="clear largemarginbottom">&nbsp;</div><br />\r\n\r\n<h3>Manual Change</h3>\r\n\r\n<ol>\r\n  <li>Enable <strong>Logo</strong> and set <strong>Type</strong> to <strong>Kirigami</strong>.</li>\r\n  <li>Upload <strong>logo.png</strong> to the <br /><strong> /templates/rt_kirigami/images/logo/*style*</strong> directory</li>\r\n  <li>Clear your browser cache and refresh.</li>\r\n</ol>\r\n\r\n<div class="clear"></div><br />\r\n\r\n<p>If you cannot see your new logo, ensure you have uploaded it to the right directory and the directory permissions are writeable. Enquire with your hosting provider.</p>\r\n\r\n<a target="_blank" href="http://www.rockettheme.com/joomla-templates/kirigami" class="readon"><span>Download Sources Here</span></a>\r\n\r\n<div class="clear"></div>\r\n', '', 1, 0, 0, 8, '2012-07-05 07:23:06', 535, '', '2012-07-25 18:30:29', 535, 0, '0000-00-00 00:00:00', '2012-07-05 07:23:06', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 3, 0, 4, '', '', 1, 47, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(10, 46, 'Preset Styles', 'preset-styles', '', '<p>The <strong>Style Settings</strong> panel in the Gantry based theme administration interface provides several options for configuring the main built in stylistic aspects of the template.</p>\r\n\r\n<div class="rt-image">\r\n  <img src="images/rocketlauncher/styles/admin-style-panel.jpg" alt="Style" />\r\n</div>\r\n\r\n<br />\r\n\r\n<p>Gantry also provides the ability for you to create your own custom presets based on any parameter in the theme administrator. You should determine which parameters you wish to configure to be a part of the presets.</p>\r\n\r\n<div class="clear"></div>\r\n\r\n<br />\r\n\r\n<h2>Assigning a Style</h2>\r\n\r\n<p>With Gantry, the ability to assign a certain style to an individual page has never been easier and/or more efficient. Just follow these simple steps:</p>\r\n\r\n<ul>\r\n  <li>Go to <strong>Extensions → Template Manager → rt_kirigami &rarr; Assignments &rarr; <em>*Menu Item*</em></strong></li>  \r\n  <li>Select your preset from <strong>Show Presets</strong>, configure and save.</li>\r\n</ul>\r\n\r\n<br />\r\n\r\n<p>After setting your defaults to the desired values, select the Menu Items button and choose the menu item you wish to modify the parameters for. You will then see a series of checkboxes on the left of all the supported parameters. Select the checkbox next to the parameter you wish to modify, it will then become active, and you can modify as you wish. Clicking “Save” or “Apply” in the toolbar will then save this configuration.</p>\r\n\r\n<a href="http://gantry-framework.org/documentation/joomla/configure/per-menu-item-configuration" class="readon largemargintop"><span>Gantry Framework: Per Menu Item Controls</span></a>\r\n', '', 1, 0, 0, 8, '2012-07-05 07:23:35', 535, '', '2012-07-29 15:55:17', 535, 0, '0000-00-00 00:00:00', '2012-07-05 07:23:35', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 11, 0, 3, '', '', 1, 298, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(11, 47, 'About Joomla!', 'about-joomla', '', '<h3>What is Joomla?</h3>\r\n<p>Joomla is an award-winning content management system (CMS), which enables you to build Web sites and powerful online applications. Many aspects, including its ease-of-use and extensibility, have made Joomla the most popular Web site software available. Best of all, Joomla is an open source solution that is freely available to everyone.</p>\r\n\r\n<p>With millions of websites running on Joomla, the software is used by individuals, small &amp; medium-sized businesses, and large organizations worldwide to easily create &amp; build a variety of websites &amp; web-enabled applications.</p>\r\n\r\n<h3>What Joomla! can do?</h3>\r\n<p>Joomla is used all over the world to power Web sites of all shapes and sizes. For example:</p>\r\n<ul>\r\n  <li>Corporate Web sites or portals</li>\r\n  <li>Corporate intranets and extranets</li>\r\n  <li>Online magazines, newspapers, and publications</li>\r\n  <li>E-commerce and online reservations</li>\r\n  <li>Government applications</li>\r\n  <li>Small business Web sites</li>\r\n  <li>Non-profit and organizational Web sites</li>\r\n  <li>Community-based portals</li>\r\n  <li>School and church Web sites</li>\r\n  <li>Personal or family homepages</li>\r\n</ul>\r\n\r\n<br />\r\n\r\n<h3>Site and Administrator</h3>\r\n<p>Your site actually has two separate sites. The site (also called the front end) is what visitors to your site will see. The administrator (also called the back end) is only used by people managing your site. You can access the administrator by clicking the "Site Administrator" link on the "This Site" menu or by adding /administrator to the end of you domain name.</p>\r\n<p>Log in to the administrator using the username and password created during the installation of Joomla.</p>\r\n\r\n<h3>Learn More</h3>\r\n<p>There is much more to learn about how to use Joomla! to create the web site you envision. You can learn much more at the <a href="http://docs.joomla.org" target="_blank">Joomla! documentation site</a> and on the<a href="http://forum.joomla.org" target="_blank"> Joomla! forums</a>.</p>\r\n\r\n<a href="http://www.joomla.org/" target="_blank" class="readon"><span>Visit Joomla!</span></a>', '', 1, 0, 0, 8, '2012-07-05 07:23:53', 535, '', '2012-07-29 15:46:20', 535, 0, '0000-00-00 00:00:00', '2012-07-05 07:23:53', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 3, 0, 2, '', '', 1, 75, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(12, 48, 'Top News of the Week', 'top-news-of-the-week', '', '<div class="rt-demo-block rt-demo-width-60">\r\n	<div class="rt-featured-image">\r\n		<div class="rt-image">\r\n			<img src="images/rocketlauncher/frontpage/general/fp-featured.jpg" alt="image" />\r\n		</div>\r\n	</div>\r\n</div>  \r\n\r\n<div class="rt-demo-block rt-demo-width-40">\r\n	<div class="rt-demo-spacer nomargintop">\r\n		<p>The main focus of the <strong>Kirigami</strong> release, is its Responsive Layout. <span class="hidden-tablet"><strong>Responsive</strong> effectively means a design that will adapt automatically to match whatever device or window size is loading it.</span></p> \r\n\r\n		<p>Therefore, you can have one template that will adjust itself to a <strong>mobile</strong>, tablet or desktop, without necessarily needing to load a separate layout with different content.</p>\r\n\r\n		<a class="readon" href="index.php?option=com_content&amp;view=article&amp;id=1&amp;Itemid=102"><span>See More</span></a>\r\n	</div>\r\n</div>', '', 1, 0, 0, 8, '2012-07-05 07:24:19', 535, '', '2012-07-29 20:33:33', 535, 0, '0000-00-00 00:00:00', '2012-07-05 07:24:19', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 35, 0, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(14, 50, 'Donec Nunc Magna Posuere', 'donec-nunc-magna-posuere', '', '<p>Lorem ipsum dolor sit amet, consecetur adipiscing elit. Etiam dapibus, tellus ac ornare aliquam, massa diam tristique urna, id faucibus lectus erat ut pede.</p>\r\n\r\n<p>Maecenas varius neque nec libero laoreet faucibus. Phasellus sodales, lectus sed vulputate rutrum, ipsum nulla lacinia magna, sed imperdiet ligula nisi eu ipsum. Donec nunc magna, posuere eget, aliquam in, vulputate in, lacus.</p>\r\n\r\n', '\r\n\r\n<p>In erat. Pellentesque erat. Mauris vehicula vestibulum justo. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Nulla pulvinar est. Integer urna. Pellentesque pulvinar dui a magna. Nulla facilisi.</p>\r\n\r\n<p>Proin imperdiet. Aliquam ornare, metus vitae gravida dignissim, nisi nisl ultricies felis, ac tristique enim pede eget elit. Integer non erat nec turpis sollicitudin malesuada. Vestibulum dapibus. Nulla facilisi. Nulla iaculis, leo sit amet mollis luctus, sapien eros consecetur dolor, eu faucibus elit nibh eu nibh. Maecenas lacus pede, lobortis non, rhoncus id, tristique a, mi. Cras auctor libero vitae sem vestibulum euismod. Nunc fermentum.</p>', 1, 0, 0, 9, '2012-07-05 07:28:48', 535, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2012-07-05 07:28:48', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 1, 0, 7, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(15, 51, 'Lorem Ipsum Dolor Sit Amet', 'lorem-ipsum-dolor-sit-amet', '', '<p>Lorem ipsum dolor sit amet, consecetur adipiscing elit. Etiam dapibus, tellus ac ornare aliquam, massa diam tristique urna, id faucibus lectus erat ut pede.</p>\r\n\r\n<p>Maecenas varius neque nec libero laoreet faucibus. Phasellus sodales, lectus sed vulputate rutrum, ipsum nulla lacinia magna, sed imperdiet ligula nisi eu ipsum. Donec nunc magna, posuere eget, aliquam in, vulputate in, lacus.</p>\r\n\r\n', '\r\n\r\n<p>In erat. Pellentesque erat. Mauris vehicula vestibulum justo. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Nulla pulvinar est. Integer urna. Pellentesque pulvinar dui a magna. Nulla facilisi.</p>\r\n\r\n<p>Proin imperdiet. Aliquam ornare, metus vitae gravida dignissim, nisi nisl ultricies felis, ac tristique enim pede eget elit. Integer non erat nec turpis sollicitudin malesuada. Vestibulum dapibus. Nulla facilisi. Nulla iaculis, leo sit amet mollis luctus, sapien eros consecetur dolor, eu faucibus elit nibh eu nibh. Maecenas lacus pede, lobortis non, rhoncus id, tristique a, mi. Cras auctor libero vitae sem vestibulum euismod. Nunc fermentum.</p>', 1, 0, 0, 9, '2012-07-05 07:29:15', 535, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2012-07-05 07:29:15', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 1, 0, 6, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(16, 52, 'Vestibulum Dapibus Est Nulla', 'vestibulum-dapibus-est-nulla', '', '<p>Lorem ipsum dolor sit amet, consecetur adipiscing elit. Etiam dapibus, tellus ac ornare aliquam, massa diam tristique urna, id faucibus lectus erat ut pede.</p>\r\n\r\n<p>Maecenas varius neque nec libero laoreet faucibus. Phasellus sodales, lectus sed vulputate rutrum, ipsum nulla lacinia magna, sed imperdiet ligula nisi eu ipsum. Donec nunc magna, posuere eget, aliquam in, vulputate in, lacus.</p>\r\n\r\n', '\r\n\r\n<p>In erat. Pellentesque erat. Mauris vehicula vestibulum justo. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Nulla pulvinar est. Integer urna. Pellentesque pulvinar dui a magna. Nulla facilisi.</p>\r\n\r\n<p>Proin imperdiet. Aliquam ornare, metus vitae gravida dignissim, nisi nisl ultricies felis, ac tristique enim pede eget elit. Integer non erat nec turpis sollicitudin malesuada. Vestibulum dapibus. Nulla facilisi. Nulla iaculis, leo sit amet mollis luctus, sapien eros consecetur dolor, eu faucibus elit nibh eu nibh. Maecenas lacus pede, lobortis non, rhoncus id, tristique a, mi. Cras auctor libero vitae sem vestibulum euismod. Nunc fermentum.</p>', 1, 0, 0, 9, '2012-07-05 07:29:37', 535, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2012-07-05 07:29:37', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 1, 0, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(17, 53, 'Nec Libero Laoreet Faucibus', 'nec-libero-laoreet-faucibus', '', '<p>Lorem ipsum dolor sit amet, consecetur adipiscing elit. Etiam dapibus, tellus ac ornare aliquam, massa diam tristique urna, id faucibus lectus erat ut pede.</p>\r\n\r\n<p>Maecenas varius neque nec libero laoreet faucibus. Phasellus sodales, lectus sed vulputate rutrum, ipsum nulla lacinia magna, sed imperdiet ligula nisi eu ipsum. Donec nunc magna, posuere eget, aliquam in, vulputate in, lacus.</p>\r\n\r\n', '\r\n\r\n<p>In erat. Pellentesque erat. Mauris vehicula vestibulum justo. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Nulla pulvinar est. Integer urna. Pellentesque pulvinar dui a magna. Nulla facilisi.</p>\r\n\r\n<p>Proin imperdiet. Aliquam ornare, metus vitae gravida dignissim, nisi nisl ultricies felis, ac tristique enim pede eget elit. Integer non erat nec turpis sollicitudin malesuada. Vestibulum dapibus. Nulla facilisi. Nulla iaculis, leo sit amet mollis luctus, sapien eros consecetur dolor, eu faucibus elit nibh eu nibh. Maecenas lacus pede, lobortis non, rhoncus id, tristique a, mi. Cras auctor libero vitae sem vestibulum euismod. Nunc fermentum.</p>', 1, 0, 0, 9, '2012-07-05 07:30:00', 535, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2012-07-05 07:30:00', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 1, 0, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(18, 54, 'Sed Imperdiet Ligula Nisi', 'sed-imperdiet-ligula-nisi', '', '<p>Lorem ipsum dolor sit amet, consecetur adipiscing elit. Etiam dapibus, tellus ac ornare aliquam, massa diam tristique urna, id faucibus lectus erat ut pede.</p>\r\n\r\n<p>Maecenas varius neque nec libero laoreet faucibus. Phasellus sodales, lectus sed vulputate rutrum, ipsum nulla lacinia magna, sed imperdiet ligula nisi eu ipsum. Donec nunc magna, posuere eget, aliquam in, vulputate in, lacus.</p>\r\n\r\n', '\r\n\r\n<p>In erat. Pellentesque erat. Mauris vehicula vestibulum justo. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Nulla pulvinar est. Integer urna. Pellentesque pulvinar dui a magna. Nulla facilisi.</p>\r\n\r\n<p>Proin imperdiet. Aliquam ornare, metus vitae gravida dignissim, nisi nisl ultricies felis, ac tristique enim pede eget elit. Integer non erat nec turpis sollicitudin malesuada. Vestibulum dapibus. Nulla facilisi. Nulla iaculis, leo sit amet mollis luctus, sapien eros consecetur dolor, eu faucibus elit nibh eu nibh. Maecenas lacus pede, lobortis non, rhoncus id, tristique a, mi. Cras auctor libero vitae sem vestibulum euismod. Nunc fermentum.</p>', 1, 0, 0, 9, '2012-07-05 07:30:24', 535, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2012-07-05 07:30:24', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 1, 0, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(19, 55, 'Massa Diam Tristique Urna', 'massa-diam-tristique-urna', '', '<p>Lorem ipsum dolor sit amet, consecetur adipiscing elit. Etiam dapibus, tellus ac ornare aliquam, massa diam tristique urna, id faucibus lectus erat ut pede.</p>\r\n\r\n<p>Maecenas varius neque nec libero laoreet faucibus. Phasellus sodales, lectus sed vulputate rutrum, ipsum nulla lacinia magna, sed imperdiet ligula nisi eu ipsum. Donec nunc magna, posuere eget, aliquam in, vulputate in, lacus.</p>\r\n\r\n', '\r\n\r\n<p>In erat. Pellentesque erat. Mauris vehicula vestibulum justo. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Nulla pulvinar est. Integer urna. Pellentesque pulvinar dui a magna. Nulla facilisi.</p>\r\n\r\n<p>Proin imperdiet. Aliquam ornare, metus vitae gravida dignissim, nisi nisl ultricies felis, ac tristique enim pede eget elit. Integer non erat nec turpis sollicitudin malesuada. Vestibulum dapibus. Nulla facilisi. Nulla iaculis, leo sit amet mollis luctus, sapien eros consecetur dolor, eu faucibus elit nibh eu nibh. Maecenas lacus pede, lobortis non, rhoncus id, tristique a, mi. Cras auctor libero vitae sem vestibulum euismod. Nunc fermentum.</p>', 1, 0, 0, 9, '2012-07-05 07:30:53', 535, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2012-07-05 07:30:53', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 1, 0, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(20, 56, 'Sapien Eros Consectetur Dolor', 'sapien-eros-consecetur-dolor', '', '<p>Lorem ipsum dolor sit amet, consecetur adipiscing elit. Etiam dapibus, tellus ac ornare aliquam, massa diam tristique urna, id faucibus lectus erat ut pede.</p>\r\n\r\n<p>Maecenas varius neque nec libero laoreet faucibus. Phasellus sodales, lectus sed vulputate rutrum, ipsum nulla lacinia magna, sed imperdiet ligula nisi eu ipsum. Donec nunc magna, posuere eget, aliquam in, vulputate in, lacus.</p>\r\n\r\n', '\r\n\r\n<p>In erat. Pellentesque erat. Mauris vehicula vestibulum justo. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Nulla pulvinar est. Integer urna. Pellentesque pulvinar dui a magna. Nulla facilisi.</p>\r\n\r\n<p>Proin imperdiet. Aliquam ornare, metus vitae gravida dignissim, nisi nisl ultricies felis, ac tristique enim pede eget elit. Integer non erat nec turpis sollicitudin malesuada. Vestibulum dapibus. Nulla facilisi. Nulla iaculis, leo sit amet mollis luctus, sapien eros consecetur dolor, eu faucibus elit nibh eu nibh. Maecenas lacus pede, lobortis non, rhoncus id, tristique a, mi. Cras auctor libero vitae sem vestibulum euismod. Nunc fermentum.</p>', 1, 0, 0, 9, '2012-07-05 07:31:18', 535, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2012-07-05 07:31:18', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 1, 0, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(21, 57, 'Maecenas Varius Neque Nec', 'maecenas-varius-neque-nec', '', '<p>Lorem ipsum dolor sit amet, consecetur adipiscing elit. Etiam dapibus, tellus ac ornare aliquam, massa diam tristique urna, id faucibus lectus erat ut pede.</p>\r\n\r\n<p>Maecenas varius neque nec libero laoreet faucibus. Phasellus sodales, lectus sed vulputate rutrum, ipsum nulla lacinia magna, sed imperdiet ligula nisi eu ipsum. Donec nunc magna, posuere eget, aliquam in, vulputate in, lacus.</p>\r\n\r\n', '\r\n\r\n<p>In erat. Pellentesque erat. Mauris vehicula vestibulum justo. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Nulla pulvinar est. Integer urna. Pellentesque pulvinar dui a magna. Nulla facilisi.</p>\r\n\r\n<p>Proin imperdiet. Aliquam ornare, metus vitae gravida dignissim, nisi nisl ultricies felis, ac tristique enim pede eget elit. Integer non erat nec turpis sollicitudin malesuada. Vestibulum dapibus. Nulla facilisi. Nulla iaculis, leo sit amet mollis luctus, sapien eros consecetur dolor, eu faucibus elit nibh eu nibh. Maecenas lacus pede, lobortis non, rhoncus id, tristique a, mi. Cras auctor libero vitae sem vestibulum euismod. Nunc fermentum.</p>', 1, 0, 0, 9, '2012-07-05 07:31:43', 535, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2012-07-05 07:31:43', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 1, 0, 0, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(22, 64, 'RokSprocket Module', 'roksprocket-module', '', '<div class="rt-demo-block rt-demo-width-50 rt-bottom-spacer">\r\n	<div class="rt-demo-spacer nomargintop">\r\n		<p><strong>RokSprocket</strong> is a powerful and multi-faceted <strong>content</strong> display extension. It combines many different <strong>layout modes</strong>, such as Tabs, into one extension. RokSprocket has its own <strong>custom</strong> built administrative interface<span class="rt-extra-desc">, with <strong>AJAX</strong> support, for easy and efficient control</span>.</p>\r\n		<div>\r\n		<span class="rt-image rt-floatleft"><img alt="image" src="images/rocketlauncher/frontpage/roksprocket-tabs/img1.jpg" /></span>\r\n		<h4 class="smallmarginbottom">Mosaic Mode</h4>\r\n		<p class="nomarginbottom">Mosaic is a dynamic ajax content display mode, that is perfect for content heavy sites, such as for Magazines.</p>\r\n		</div>\r\n	</div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-50">\r\n	<div class="rt-demo-spacer nomargintop">\r\n		<div>\r\n			<span class="rt-image rt-floatleft"><img alt="image" src="images/rocketlauncher/frontpage/roksprocket-tabs/img2.jpg" /></span>\r\n			<h4 class="nomargintop smallmarginbottom">Tabbed Content</h4>\r\n			<p class="nomarginbottom">Set RokSprocket to the Tabs layout mode, to display your content within dynamically adjusting tabs.</p>\r\n		</div>\r\n		<div class="clear"></div>\r\n		<div>\r\n			<span class="rt-image rt-floatleft"><img alt="image" src="images/rocketlauncher/frontpage/roksprocket-tabs/img3.jpg" /></span>\r\n			<h4 class="smallmarginbottom">More Layout Types</h4>\r\n			<p class="nomarginbottom">Also supported are the headlines, lists, and features layout modes, the latter demoed above.</p>\r\n		</div>    \r\n	</div>\r\n</div>', '', 1, 0, 0, 12, '2012-07-09 13:28:55', 535, '', '2012-07-31 14:42:21', 535, 0, '0000-00-00 00:00:00', '2012-07-09 13:28:55', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 44, 0, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(23, 65, 'Menu System', 'menu-system', '', '<div class="rt-demo-block rt-demo-width-50 rt-bottom-spacer">\r\n  <div class="rt-demo-spacer nomargintop">\r\n    <div>\r\n      <span class="rt-image rt-floatleft"><img alt="image" src="images/rocketlauncher/frontpage/roksprocket-tabs/img3.jpg" /></span>\r\n      <h4 class="nomargintop smallmarginbottom">SplitMenu</h4>\r\n      <p class="nomarginbottom">SplitMenu is a static menu option that displays parents in the header and children in the sidebar.</p>\r\n    </div>\r\n    <div class="clear"></div>\r\n    <div>\r\n      <span class="rt-image rt-floatleft"><img alt="image" src="images/rocketlauncher/frontpage/roksprocket-tabs/img2.jpg" /></span>\r\n      <h4 class="smallmarginbottom">Small Screen Devices</h4>\r\n      <p class="nomarginbottom">When a mobile, or equivalent device, with a small screen is detected, the menu becomes a selectbox.</p>\r\n    </div>    \r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-50">\r\n  <div class="rt-demo-spacer nomargintop nomarginbottom">\r\n    <div>\r\n    <span class="rt-image rt-floatleft"><img alt="image" src="images/rocketlauncher/frontpage/roksprocket-tabs/img1.jpg" /></span>\r\n    <h4 class="nomargintop smallmarginbottom">Fusion with MegaMenu</h4>\r\n    <p class="nomarginbottom">Fusion is a CSS dropdown menu system, enhanced by Mootools, such as its animations and transitions.</p>\r\n    </div>\r\n    <div class="clear"></div>\r\n    <p class="largemargintop nomarginbottom">Features include multiple columns with individual width / distribution settings, inline icons and subtext, as well as inline modules / module positions. All are configurable on a per item basis.</p>\r\n  </div>\r\n</div>', '', 1, 0, 0, 12, '2012-07-09 13:29:14', 535, '', '2012-07-27 14:40:33', 535, 0, '0000-00-00 00:00:00', '2012-07-09 13:29:14', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 20, 0, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(24, 66, 'Integrated Extensions', 'integrated-extensions', '', '<div class="rt-demo-block rt-demo-width-50 rt-bottom-spacer">\r\n  <div class="rt-demo-spacer nomargintop nomarginbottom">\r\n    <div>\r\n      <span class="rt-image rt-floatleft"><img alt="image" src="images/rocketlauncher/frontpage/roksprocket-tabs/img4.jpg" /></span>\r\n      <h4 class="nomargintop smallmarginbottom">RokGallery</h4>\r\n      <p class="nomarginbottom">RokGallery is a powerful gallery extension that is based on a custom-tagging architecture.</p>\r\n    </div>\r\n    <div class="clear"></div>\r\n    <div>\r\n      <span class="rt-image rt-floatleft"><img alt="image" src="images/rocketlauncher/frontpage/roksprocket-tabs/img3.jpg" /></span>\r\n      <h4 class="smallmarginbottom">RokTwittie</h4>\r\n      <p class="nomarginbottom">A Twitter module, that can display Twitter profile information, as well as username tweets and search strings.</p>\r\n    </div>    \r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-50">\r\n  <div class="rt-demo-spacer nomargintop">\r\n    <div>\r\n      <span class="rt-image rt-floatleft"><img alt="image" src="images/rocketlauncher/frontpage/roksprocket-tabs/img2.jpg" /></span>\r\n      <h4 class="nomargintop smallmarginbottom">RokBooster</h4>\r\n      <p class="nomarginbottom">A powerful compression / performance plugin that collates CSS / JS files into single files for faster loading.</p>\r\n    </div>\r\n    <div class="clear"></div>\r\n    <div>\r\n      <span class="rt-image rt-floatleft"><img alt="image" src="images/rocketlauncher/frontpage/roksprocket-tabs/img1.jpg" /></span>\r\n      <h4 class="smallmarginbottom">RokSprocket</h4>\r\n      <p class="nomarginbottom">A content switchblade extension that has multiple layout modes within one unified control system.</p>\r\n    </div>    \r\n  </div>\r\n</div>', '', 1, 0, 0, 12, '2012-07-09 13:29:28', 535, '', '2012-07-27 18:31:48', 535, 0, '0000-00-00 00:00:00', '2012-07-09 13:29:28', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 13, 0, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(25, 68, 'About Kirigami', 'about-the-template', '', '<p>Kirigami, is the first responsive RocketTheme template that adapts itself to a particular viewing environment, powered by the Gantry Framework</p>', '', 1, 0, 0, 13, '2012-07-09 16:16:43', 535, '', '2012-07-30 21:12:27', 535, 0, '0000-00-00 00:00:00', '2012-07-09 16:16:43', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 8, 0, 12, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(26, 69, 'Mosaic Layout', 'mosaic-layout', '', '<p>Mosaic, a template layout for RokSprocket, presents content in a dynamic and interactive grid structure; perfect for magazine and content sites</p>', '', 1, 0, 0, 13, '2012-07-09 16:19:28', 535, '', '2012-07-30 02:01:13', 535, 0, '0000-00-00 00:00:00', '2012-07-09 16:19:28', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 7, 0, 11, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(27, 70, 'Core Framework', 'core-framework', '', '<p>The Gantry Framework sits at the core of the template, providing the base for the major features and functions, such as the responsive grid.</p>', '', 1, 0, 0, 13, '2012-07-09 16:19:49', 535, '', '2012-07-30 21:09:15', 535, 0, '0000-00-00 00:00:00', '2012-07-09 16:19:49', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 6, 0, 10, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(28, 71, 'Responsive', 'responsive', '', '<p>A responsive layout adapts automatically based on the device such as mobile, tablet or desktop, removing the need for separate layouts.</p>', '', 1, 0, 0, 13, '2012-07-09 16:20:11', 535, '', '2012-07-27 12:54:01', 535, 0, '0000-00-00 00:00:00', '2012-07-09 16:20:11', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 9, 0, 9, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(29, 72, 'Multi Styles', 'multi-styles', '', '<p>Kirigami has 10 stunning preset style variations to choose from, as well as configure from the Gantry administrator, in addition to custom module variations.</p>', '', 1, 0, 0, 13, '2012-07-09 16:20:49', 535, '', '2012-07-27 12:07:30', 535, 0, '0000-00-00 00:00:00', '2012-07-09 16:20:49', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 3, 0, 8, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(30, 73, 'Typography', 'typography', '', '<p>Individualize your article or modular content with the template''s custom typography, such as a plethora of list formats and notice styles</p>', '', 1, 0, 0, 13, '2012-07-09 16:21:03', 535, '', '2012-07-24 10:05:26', 535, 0, '0000-00-00 00:00:00', '2012-07-09 16:21:03', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 3, 0, 7, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(31, 74, '78 Positions', '78-positions', '', '<p>A vast module positions assortment, spread over Gantry Grid Rows, split into groupings of six, for maximum flexibility, diversity and control</p>', '', 1, 0, 0, 13, '2012-07-09 16:21:16', 535, '', '2012-07-27 19:30:56', 535, 0, '0000-00-00 00:00:00', '2012-07-09 16:21:16', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 3, 0, 6, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(32, 75, 'Logo Picker', 'logo-picker', '', '<p>There are two methods of changing the Kirigami logo, via the logo picker or by manual change. Choose the logo from RokGallery or Media Manager.</p>', '', 1, 0, 0, 13, '2012-07-09 16:21:34', 535, '', '2012-07-24 10:07:38', 535, 0, '0000-00-00 00:00:00', '2012-07-09 16:21:34', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 2, 0, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(33, 76, 'RokSprocket', 'roksprocket', '', '<p>A powerful switchblade content extension, that provides an array of display options, all within one single modular framework with an intuitive interface</p>', '', 1, 0, 0, 13, '2012-07-09 16:22:00', 535, '', '2012-07-24 10:09:08', 535, 0, '0000-00-00 00:00:00', '2012-07-09 16:22:00', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 2, 0, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(34, 77, 'Tutorials', 'tutorials', '', '<p>Extensive overview of template files and instructions for installing and activating the template and overview for customizing the template logo</p>', '', 1, 0, 0, 13, '2012-07-09 16:22:12', 535, '', '2012-07-24 10:10:14', 535, 0, '0000-00-00 00:00:00', '2012-07-09 16:22:12', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 2, 0, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(35, 78, 'Module Variants', 'module-variants', '', '<p>Kirigami has a range of module class suffixes, both stylistic and structural that allow you to individualize a module to create unique layouts &amp; appearances</p>', '', 1, 0, 0, 13, '2012-07-09 16:22:40', 535, '', '2012-07-27 12:44:35', 535, 0, '0000-00-00 00:00:00', '2012-07-09 16:22:40', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 3, 0, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(36, 79, 'RokGallery', 'rokgallery', '', '<p>RokGallery is an advanced gallery extension, resting on a custom tag based architecture, with an non-destructive slice editor to edit photos easily</p>', '', 1, 0, 0, 13, '2012-07-09 16:23:16', 535, '', '2012-07-24 10:14:37', 535, 0, '0000-00-00 00:00:00', '2012-07-09 16:23:16', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 3, 0, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(37, 80, 'RokBooster', 'rokbooster', '', '<p>Increase the speed of your site by enabling the RokBooster plug-in which will compress and combine your CSS &amp; JavaScript into as few files as possible</p>\r\n\r\n', '', 1, 0, 0, 13, '2012-07-09 16:25:10', 535, '', '2012-07-24 10:16:05', 535, 0, '0000-00-00 00:00:00', '2012-07-09 16:25:10', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 4, 0, 0, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(38, 83, 'Content Typography', 'content-typography', '', '<p>Typography is a fundamental part of a template to characterize your site content, such as a plethora of list formats and notice styles.</p>', '', 1, 0, 0, 15, '2012-07-09 16:43:34', 535, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2012-07-09 16:43:34', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 1, 0, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(39, 84, 'Customize the Logo', 'customize-the-logo', '', '<p>There are two methods for changing the logo: either via the logo picker or by manual change and you can set Logo Picker to either RokGallery or the Media Manager.</p>', '', 1, 0, 0, 15, '2012-07-09 16:44:11', 535, '', '2012-07-30 13:22:46', 535, 0, '0000-00-00 00:00:00', '2012-07-09 16:44:11', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 2, 0, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(40, 85, 'Fusion and Split Menu', 'fusion-and-split-menu', '', '<p>Two menu systems are integrated, the Mootools enhanced CSS Dropdown Fusion Menu and Triple Level Split Menu, that support for multi-columns, custom widths, inline icons and much more.</p>', '', 1, 0, 0, 15, '2012-07-09 16:44:53', 535, '', '2012-07-30 13:24:02', 535, 0, '0000-00-00 00:00:00', '2012-07-09 16:44:53', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 2, 0, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(41, 86, 'Responsive Layout', 'responsive-layout', '', '<p>Praesent vestibulum malesuada semper. Donec sed blandit erat. Nulla hendrerit tristique ipsum, vitae condimentum mauris.</p> ', '', 1, 0, 0, 15, '2012-07-09 16:45:25', 535, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2012-07-09 16:45:25', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 1, 0, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(42, 87, 'RokGallery', 'rokgallery', '', '<p>RokGallery is an advanced gallery extension, resting on a custom tag based architecture with a non-destructive slice editor to allow you edit photos easily and swiftly.</p>', '', 1, 0, 0, 15, '2012-07-09 16:45:41', 535, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2012-07-09 16:45:41', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 1, 0, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(43, 88, 'RokSprocket Extension', 'roksprocket-extension', '', '<p>RokSprocket is a powerful switchblade content extension, that provides an array of display options, all within one single modular framework that supports a comprehensive control interface, for all layout modes, and is powered by Ajax.</p>', '', 1, 0, 0, 15, '2012-07-09 16:46:16', 535, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2012-07-09 16:46:16', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 1, 0, 0, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(44, 89, 'Grid System', 'grid-system', '', '<span>CSS grid framework to construct content by providing commonly used dimensions</span>', '', 1, 0, 0, 14, '2012-07-09 16:52:26', 535, '', '2012-07-30 14:57:28', 535, 0, '0000-00-00 00:00:00', '2012-07-09 16:52:26', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 7, 0, 6, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(45, 90, 'Stunning Interface', 'stunning-interface', '', '<span>Gantry provides a unique intuitive interface to control all design aspects</span>', '', 1, 0, 0, 14, '2012-07-09 17:01:46', 535, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2012-07-09 17:01:46', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 1, 0, 5, '', '', 1, 3, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(46, 91, 'Integrated Features', 'integrated-features', '', '<span>Many built-in features such as Date, Font-Sizer, Google Analytics, etc</span>', '', 1, 0, 0, 14, '2012-07-09 17:02:04', 535, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2012-07-09 17:02:04', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 1, 0, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(47, 92, 'Extensible AJAX', 'extensible-ajax', '', '<span>Powerful AJAX system for dynamic functionality in all features &amp; 3rd party</span>', '', 1, 0, 0, 14, '2012-07-09 17:03:37', 535, '', '2012-07-24 14:34:37', 535, 0, '0000-00-00 00:00:00', '2012-07-09 17:03:37', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 2, 0, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(48, 93, 'Custom Preset', 'custom-preset', '', '<span>Create custom presets to easily save any configured style combination</span>', '', 1, 0, 0, 14, '2012-07-09 17:04:04', 535, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2012-07-09 17:04:04', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 1, 0, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(49, 94, 'Per Menu Support', 'per-menu-support', '', '<span>Load different template configurations based on individual menu items.</span>', '', 1, 0, 0, 14, '2012-07-09 17:05:04', 535, '', '2012-07-27 13:23:47', 535, 0, '0000-00-00 00:00:00', '2012-07-09 17:05:04', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 2, 0, 1, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(50, 95, 'and Many More...', 'and-many-more', '', '<span>Gantry is packed full of features to empower the development of designs into fully functional layouts with the absolute minimum of effort and fuss.</span>', '', 1, 0, 0, 14, '2012-07-09 17:05:24', 535, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2012-07-09 17:05:24', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 1, 0, 0, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(51, 100, 'Fusion Menu', 'fusion-menu', '', '<p>Fusion with MegaMenu is a Mootools enhanced, CSS dropdown menu system, with features such as multiple columns and inline icons.</p>', '', 1, 0, 0, 13, '2012-07-09 16:22:00', 535, '', '2012-07-27 12:16:28', 535, 0, '0000-00-00 00:00:00', '2012-07-09 16:22:00', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 4, 0, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(52, 101, 'SplitMenu', 'splitmenu', '', '<p>SplitMenu is a basic, static menu system that places parent items in the header navigation area, and all children in the sidebar, or as configured.</p>', '', 1, 0, 0, 13, '2012-07-09 16:22:12', 535, '', '2012-07-27 12:18:37', 535, 0, '0000-00-00 00:00:00', '2012-07-09 16:22:12', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 4, 0, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(53, 102, 'K2 Styling', 'k2-styling', '', '<p>Kirigami has styled, including responsive, support for the popular third party content / CCK extension by JoomlaWorks.gr, K2.</p>', '', 1, 0, 0, 13, '2012-07-09 16:21:03', 535, '', '2012-07-27 12:57:58', 535, 0, '0000-00-00 00:00:00', '2012-07-09 16:21:03', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 5, 0, 7, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(54, 103, 'Styling', 'styling', '', '<div class="rt-demo-block rt-demo-width-50 rt-bottom-spacer">\r\n  <div class="rt-demo-spacer nomargintop nomarginbottom">\r\n    <div>\r\n      <span class="rt-image rt-floatleft"><img alt="image" src="images/rocketlauncher/frontpage/roksprocket-tabs/img1.jpg" /></span>\r\n      <h4 class="nomargintop smallmarginbottom">Available Preset Styles</h4>\r\n      <p class="nomarginbottom">Ten style variations are available, each with individual configuration options for custom preset creation.</p>\r\n    </div>\r\n    <div class="clear"></div>\r\n    <div>\r\n      <span class="rt-image rt-floatleft"><img alt="image" src="images/rocketlauncher/frontpage/roksprocket-tabs/img2.jpg" /></span>\r\n      <h4 class="smallmarginbottom">Module Variations</h4>\r\n      <p class="nomarginbottom">There are 10 stylistic module variations, with 25 structural suffixes. The former change the style, the latter the layout.</p>\r\n    </div>    \r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-50">\r\n  <div class="rt-demo-spacer nomargintop">\r\n    <div>\r\n      <span class="rt-image rt-floatleft"><img alt="image" src="images/rocketlauncher/frontpage/roksprocket-tabs/img3.jpg" /></span>\r\n      <h4 class="nomargintop smallmarginbottom">Content Typography</h4>\r\n      <p class="nomarginbottom">A wide portfolio of typography is available, such as custom list styles, to help individualize your content.</p>\r\n    </div>\r\n    <div class="clear"></div>\r\n    <div>\r\n      <span class="rt-image rt-floatleft"><img alt="image" src="images/rocketlauncher/frontpage/roksprocket-tabs/img4.jpg" /></span>\r\n      <h4 class="smallmarginbottom">Image Source Files</h4>\r\n      <p class="nomarginbottom">Layered Adobe Fireworks PNG Sources are provided to allow for quick and easy customization.</p>\r\n    </div>    \r\n  </div>\r\n</div>', '', 1, 0, 0, 12, '2012-07-25 17:08:01', 535, '', '2012-07-27 18:31:56', 535, 0, '0000-00-00 00:00:00', '2012-07-25 17:08:01', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":null,"urlatext":"","targeta":"","urlb":null,"urlbtext":"","targetb":"","urlc":null,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 8, 0, 0, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');

-- --------------------------------------------------------

--
-- Table structure for table `#__content_frontpage`
--

DROP TABLE IF EXISTS `#__content_frontpage`;
CREATE TABLE IF NOT EXISTS `#__content_frontpage` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`content_id`)
);

--
-- Dumping data for table `#__content_frontpage`
--

INSERT INTO `#__content_frontpage` (`content_id`, `ordering`) VALUES
(12, 1);

-- --------------------------------------------------------

--
-- Table structure for table `#__content_rating`
--

DROP TABLE IF EXISTS `#__content_rating`;
CREATE TABLE IF NOT EXISTS `#__content_rating` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(10) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(10) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`content_id`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__core_log_searches`
--

DROP TABLE IF EXISTS `#__core_log_searches`;
CREATE TABLE IF NOT EXISTS `#__core_log_searches` (
  `search_term` varchar(128) NOT NULL DEFAULT '',
  `hits` int(10) unsigned NOT NULL DEFAULT '0'
);

-- --------------------------------------------------------

--
-- Table structure for table `#__extensions`
--

DROP TABLE IF EXISTS `#__extensions`;
CREATE TABLE IF NOT EXISTS `#__extensions` (
  `extension_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `type` varchar(20) NOT NULL,
  `element` varchar(100) NOT NULL,
  `folder` varchar(100) NOT NULL,
  `client_id` tinyint(3) NOT NULL,
  `enabled` tinyint(3) NOT NULL DEFAULT '1',
  `access` int(10) unsigned NOT NULL DEFAULT '1',
  `protected` tinyint(3) NOT NULL DEFAULT '0',
  `manifest_cache` text NOT NULL,
  `params` text NOT NULL,
  `custom_data` text NOT NULL,
  `system_data` text NOT NULL,
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) DEFAULT '0',
  `state` int(11) DEFAULT '0',
  PRIMARY KEY (`extension_id`),
  KEY `element_clientid` (`element`,`client_id`),
  KEY `element_folder_clientid` (`element`,`folder`,`client_id`),
  KEY `extension` (`type`,`element`,`folder`,`client_id`)
);

--
-- Dumping data for table `#__extensions`
--

INSERT INTO `#__extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES
(1, 'com_mailto', 'component', 'com_mailto', '', 0, 1, 1, 1, '{"legacy":false,"name":"com_mailto","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_MAILTO_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(2, 'com_wrapper', 'component', 'com_wrapper', '', 0, 1, 1, 1, '{"legacy":false,"name":"com_wrapper","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_WRAPPER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(3, 'com_admin', 'component', 'com_admin', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_admin","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_ADMIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(4, 'com_banners', 'component', 'com_banners', '', 1, 1, 1, 0, '{"legacy":false,"name":"com_banners","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_BANNERS_XML_DESCRIPTION","group":""}', '{"purchase_type":"3","track_impressions":"0","track_clicks":"0","metakey_prefix":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(5, 'com_cache', 'component', 'com_cache', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_cache","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_CACHE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(6, 'com_categories', 'component', 'com_categories', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_categories","type":"component","creationDate":"December 2007","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_CATEGORIES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(7, 'com_checkin', 'component', 'com_checkin', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_checkin","type":"component","creationDate":"Unknown","author":"Joomla! Project","copyright":"(C) 2005 - 2008 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_CHECKIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(8, 'com_contact', 'component', 'com_contact', '', 1, 1, 1, 0, '{"legacy":false,"name":"com_contact","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_CONTACT_XML_DESCRIPTION","group":""}', '{"show_contact_category":"hide","show_contact_list":"0","presentation_style":"sliders","show_name":"1","show_position":"1","show_email":"0","show_street_address":"1","show_suburb":"1","show_state":"1","show_postcode":"1","show_country":"1","show_telephone":"1","show_mobile":"1","show_fax":"1","show_webpage":"1","show_misc":"1","show_image":"1","image":"","allow_vcard":"0","show_articles":"0","show_profile":"0","show_links":"0","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","contact_icons":"0","icon_address":"","icon_email":"","icon_telephone":"","icon_mobile":"","icon_fax":"","icon_misc":"","show_headings":"1","show_position_headings":"1","show_email_headings":"0","show_telephone_headings":"1","show_mobile_headings":"0","show_fax_headings":"0","allow_vcard_headings":"0","show_suburb_headings":"1","show_state_headings":"1","show_country_headings":"1","show_email_form":"1","show_email_copy":"1","banned_email":"","banned_subject":"","banned_text":"","validate_session":"1","custom_reply":"0","redirect":"","show_category_crumb":"0","metakey":"","metadesc":"","robots":"","author":"","rights":"","xreference":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(9, 'com_cpanel', 'component', 'com_cpanel', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_cpanel","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_CPANEL_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10, 'com_installer', 'component', 'com_installer', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_installer","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_INSTALLER_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(11, 'com_languages', 'component', 'com_languages', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_languages","type":"component","creationDate":"2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_LANGUAGES_XML_DESCRIPTION","group":""}', '{"administrator":"en-GB","site":"en-GB"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(12, 'com_login', 'component', 'com_login', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_login","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_LOGIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(13, 'com_media', 'component', 'com_media', '', 1, 1, 0, 1, '{"legacy":false,"name":"com_media","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_MEDIA_XML_DESCRIPTION","group":""}', '{"upload_extensions":"bmp,csv,doc,gif,ico,jpg,jpeg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,GIF,ICO,JPG,JPEG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS","upload_maxsize":"10","file_path":"images","image_path":"images","restrict_uploads":"1","allowed_media_usergroup":"3","check_mime":"1","image_extensions":"bmp,gif,jpg,png","ignore_extensions":"","upload_mime":"image\\/jpeg,image\\/gif,image\\/png,image\\/bmp,application\\/x-shockwave-flash,application\\/msword,application\\/excel,application\\/pdf,application\\/powerpoint,text\\/plain,application\\/x-zip","upload_mime_illegal":"text\\/html","enable_flash":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(14, 'com_menus', 'component', 'com_menus', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_menus","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_MENUS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(15, 'com_messages', 'component', 'com_messages', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_messages","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_MESSAGES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(16, 'com_modules', 'component', 'com_modules', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_modules","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_MODULES_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(17, 'com_newsfeeds', 'component', 'com_newsfeeds', '', 1, 1, 1, 0, '{"legacy":false,"name":"com_newsfeeds","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_NEWSFEEDS_XML_DESCRIPTION","group":""}', '{"show_feed_image":"1","show_feed_description":"1","show_item_description":"1","feed_word_count":"0","show_headings":"1","show_name":"1","show_articles":"0","show_link":"1","show_description":"1","show_description_image":"1","display_num":"","show_pagination_limit":"1","show_pagination":"1","show_pagination_results":"1","show_cat_items":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(18, 'com_plugins', 'component', 'com_plugins', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_plugins","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_PLUGINS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(19, 'com_search', 'component', 'com_search', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_search","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_SEARCH_XML_DESCRIPTION","group":""}', '{"enabled":"0","show_date":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(20, 'com_templates', 'component', 'com_templates', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_templates","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_TEMPLATES_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(21, 'com_weblinks', 'component', 'com_weblinks', '', 1, 1, 1, 0, '{"legacy":false,"name":"com_weblinks","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_WEBLINKS_XML_DESCRIPTION","group":""}', '{"target":"0","count_clicks":"1","icons":2,"link_icons":"","category_layout":"_:default","show_category_title":"1","show_description":"1","show_description_image":"1","maxLevel":"-1","show_empty_categories":"0","show_subcat_desc":"1","show_cat_num_links":"1","show_base_description":"1","maxLevelcat":"-1","show_empty_categories_cat":"0","show_subcat_desc_cat":"1","show_cat_num_links_cat":"1","show_pagination_limit":"1","show_headings":"0","show_link_description":"1","show_link_hits":"1","show_pagination":"2","show_pagination_results":"1","show_feed_link":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(22, 'com_content', 'component', 'com_content', '', 1, 1, 0, 1, '{"legacy":false,"name":"com_content","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_CONTENT_XML_DESCRIPTION","group":""}', '{"article_layout":"_:default","show_title":"1","link_titles":"0","show_intro":"1","show_category":"0","link_category":"1","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"1","show_item_navigation":"0","show_vote":"0","show_readmore":"1","show_readmore_title":"1","readmore_limit":"100","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"0","urls_position":"0","show_publishing_options":"1","show_article_options":"1","show_urls_images_frontend":"0","show_urls_images_backend":"1","targeta":0,"targetb":0,"targetc":0,"float_intro":"left","float_fulltext":"left","category_layout":"_:blog","show_category_title":"0","show_description":"0","show_description_image":"0","maxLevel":"1","show_empty_categories":"0","show_no_articles":"1","show_subcat_desc":"1","show_cat_num_articles":"0","show_base_description":"1","maxLevelcat":"-1","show_empty_categories_cat":"0","show_subcat_desc_cat":"1","show_cat_num_articles_cat":"1","num_leading_articles":"0","num_intro_articles":"4","num_columns":"1","num_links":"4","multi_column_order":"0","show_subcategory_content":"0","show_pagination_limit":"1","filter_field":"hide","show_headings":"1","list_show_date":"0","date_format":"","list_show_hits":"1","list_show_author":"1","orderby_pri":"order","orderby_sec":"rdate","order_date":"published","show_pagination":"2","show_pagination_results":"1","show_feed_link":"1","feed_summary":"0","feed_show_readmore":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(23, 'com_config', 'component', 'com_config', '', 1, 1, 0, 1, '{"legacy":false,"name":"com_config","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_CONFIG_XML_DESCRIPTION","group":""}', '{"filters":{"1":{"filter_type":"NH","filter_tags":"","filter_attributes":""},"6":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"7":{"filter_type":"NONE","filter_tags":"","filter_attributes":""},"2":{"filter_type":"NH","filter_tags":"","filter_attributes":""},"3":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"4":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"5":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"8":{"filter_type":"NONE","filter_tags":"","filter_attributes":""}}}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(24, 'com_redirect', 'component', 'com_redirect', '', 1, 1, 0, 1, '{"legacy":false,"name":"com_redirect","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_REDIRECT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(25, 'com_users', 'component', 'com_users', '', 1, 1, 0, 1, '{"legacy":false,"name":"com_users","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_USERS_XML_DESCRIPTION","group":""}', '{"allowUserRegistration":"1","new_usertype":"2","useractivation":"1","frontend_userparams":"1","mailSubjectPrefix":"","mailBodySuffix":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(27, 'com_finder', 'component', 'com_finder', '', 1, 1, 0, 0, '{"legacy":false,"name":"com_finder","type":"component","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_FINDER_XML_DESCRIPTION","group":""}', '{"show_description":"1","description_length":255,"allow_empty_query":"0","show_url":"1","show_advanced":"1","expand_advanced":"0","show_date_filters":"0","highlight_terms":"1","opensearch_name":"","opensearch_description":"","batch_size":"50","memory_table_limit":30000,"title_multiplier":"1.7","text_multiplier":"0.7","meta_multiplier":"1.2","path_multiplier":"2.0","misc_multiplier":"0.3","stemmer":"snowball"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(28, 'com_joomlaupdate', 'component', 'com_joomlaupdate', '', 1, 1, 0, 1, '{"legacy":false,"name":"com_joomlaupdate","type":"component","creationDate":"February 2012","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_JOOMLAUPDATE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(100, 'PHPMailer', 'library', 'phpmailer', '', 0, 1, 1, 1, '{"legacy":false,"name":"PHPMailer","type":"library","creationDate":"2001","author":"PHPMailer","copyright":"(c) 2001-2003, Brent R. Matzelle, (c) 2004-2009, Andy Prevost. All Rights Reserved., (c) 2010-2011, Jim Jagielski. All Rights Reserved.","authorEmail":"jimjag@gmail.com","authorUrl":"https:\\/\\/code.google.com\\/a\\/apache-extras.org\\/p\\/phpmailer\\/","version":"5.2","description":"LIB_PHPMAILER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(101, 'SimplePie', 'library', 'simplepie', '', 0, 1, 1, 1, '{"legacy":false,"name":"SimplePie","type":"library","creationDate":"2004","author":"SimplePie","copyright":"Copyright (c) 2004-2009, Ryan Parman and Geoffrey Sneddon","authorEmail":"","authorUrl":"http:\\/\\/simplepie.org\\/","version":"1.2","description":"LIB_SIMPLEPIE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(102, 'phputf8', 'library', 'phputf8', '', 0, 1, 1, 1, '{"legacy":false,"name":"phputf8","type":"library","creationDate":"2006","author":"Harry Fuecks","copyright":"Copyright various authors","authorEmail":"hfuecks@gmail.com","authorUrl":"http:\\/\\/sourceforge.net\\/projects\\/phputf8","version":"0.5","description":"LIB_PHPUTF8_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(103, 'Joomla! Platform', 'library', 'joomla', '', 0, 1, 1, 1, '{"legacy":false,"name":"Joomla! Platform","type":"library","creationDate":"2008","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"http:\\/\\/www.joomla.org","version":"11.4","description":"LIB_JOOMLA_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(200, 'mod_articles_archive', 'module', 'mod_articles_archive', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_articles_archive","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters.\\n\\t\\tAll rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_ARTICLES_ARCHIVE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(201, 'mod_articles_latest', 'module', 'mod_articles_latest', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_articles_latest","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_LATEST_NEWS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(202, 'mod_articles_popular', 'module', 'mod_articles_popular', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_articles_popular","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_POPULAR_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(203, 'mod_banners', 'module', 'mod_banners', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_banners","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_BANNERS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(204, 'mod_breadcrumbs', 'module', 'mod_breadcrumbs', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_breadcrumbs","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_BREADCRUMBS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(205, 'mod_custom', 'module', 'mod_custom', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_custom","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_CUSTOM_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(206, 'mod_feed', 'module', 'mod_feed', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_feed","type":"module","creationDate":"July 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_FEED_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(207, 'mod_footer', 'module', 'mod_footer', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_footer","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_FOOTER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(208, 'mod_login', 'module', 'mod_login', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_login","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_LOGIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(209, 'mod_menu', 'module', 'mod_menu', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_menu","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_MENU_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(210, 'mod_articles_news', 'module', 'mod_articles_news', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_articles_news","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_ARTICLES_NEWS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(211, 'mod_random_image', 'module', 'mod_random_image', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_random_image","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_RANDOM_IMAGE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(212, 'mod_related_items', 'module', 'mod_related_items', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_related_items","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_RELATED_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(213, 'mod_search', 'module', 'mod_search', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_search","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_SEARCH_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(214, 'mod_stats', 'module', 'mod_stats', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_stats","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_STATS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(215, 'mod_syndicate', 'module', 'mod_syndicate', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_syndicate","type":"module","creationDate":"May 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_SYNDICATE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(216, 'mod_users_latest', 'module', 'mod_users_latest', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_users_latest","type":"module","creationDate":"December 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_USERS_LATEST_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(217, 'mod_weblinks', 'module', 'mod_weblinks', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_weblinks","type":"module","creationDate":"July 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_WEBLINKS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(218, 'mod_whosonline', 'module', 'mod_whosonline', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_whosonline","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_WHOSONLINE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(219, 'mod_wrapper', 'module', 'mod_wrapper', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_wrapper","type":"module","creationDate":"October 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_WRAPPER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(220, 'mod_articles_category', 'module', 'mod_articles_category', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_articles_category","type":"module","creationDate":"February 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_ARTICLES_CATEGORY_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(221, 'mod_articles_categories', 'module', 'mod_articles_categories', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_articles_categories","type":"module","creationDate":"February 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_ARTICLES_CATEGORIES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(222, 'mod_languages', 'module', 'mod_languages', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_languages","type":"module","creationDate":"February 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_LANGUAGES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(223, 'mod_finder', 'module', 'mod_finder', '', 0, 1, 0, 0, '{"legacy":false,"name":"mod_finder","type":"module","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_FINDER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(300, 'mod_custom', 'module', 'mod_custom', '', 1, 1, 1, 1, '{"legacy":false,"name":"mod_custom","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_CUSTOM_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(301, 'mod_feed', 'module', 'mod_feed', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_feed","type":"module","creationDate":"July 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_FEED_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(302, 'mod_latest', 'module', 'mod_latest', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_latest","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_LATEST_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(303, 'mod_logged', 'module', 'mod_logged', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_logged","type":"module","creationDate":"January 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_LOGGED_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(304, 'mod_login', 'module', 'mod_login', '', 1, 1, 1, 1, '{"legacy":false,"name":"mod_login","type":"module","creationDate":"March 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_LOGIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(305, 'mod_menu', 'module', 'mod_menu', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_menu","type":"module","creationDate":"March 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_MENU_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(307, 'mod_popular', 'module', 'mod_popular', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_popular","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_POPULAR_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(308, 'mod_quickicon', 'module', 'mod_quickicon', '', 1, 1, 1, 1, '{"legacy":false,"name":"mod_quickicon","type":"module","creationDate":"Nov 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_QUICKICON_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(309, 'mod_status', 'module', 'mod_status', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_status","type":"module","creationDate":"Feb 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_STATUS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(310, 'mod_submenu', 'module', 'mod_submenu', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_submenu","type":"module","creationDate":"Feb 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_SUBMENU_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(311, 'mod_title', 'module', 'mod_title', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_title","type":"module","creationDate":"Nov 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_TITLE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(312, 'mod_toolbar', 'module', 'mod_toolbar', '', 1, 1, 1, 1, '{"legacy":false,"name":"mod_toolbar","type":"module","creationDate":"Nov 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_TOOLBAR_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(313, 'mod_multilangstatus', 'module', 'mod_multilangstatus', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_multilangstatus","type":"module","creationDate":"September 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_MULTILANGSTATUS_XML_DESCRIPTION","group":""}', '{"cache":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(314, 'mod_version', 'module', 'mod_version', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_version","type":"module","creationDate":"January 2012","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_VERSION_XML_DESCRIPTION","group":""}', '{"format":"short","product":"1","cache":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(400, 'plg_authentication_gmail', 'plugin', 'gmail', 'authentication', 0, 0, 1, 0, '{"legacy":false,"name":"plg_authentication_gmail","type":"plugin","creationDate":"February 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_GMAIL_XML_DESCRIPTION","group":""}', '{"applysuffix":"0","suffix":"","verifypeer":"1","user_blacklist":""}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(401, 'plg_authentication_joomla', 'plugin', 'joomla', 'authentication', 0, 1, 1, 1, '{"legacy":false,"name":"plg_authentication_joomla","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_AUTH_JOOMLA_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(402, 'plg_authentication_ldap', 'plugin', 'ldap', 'authentication', 0, 0, 1, 0, '{"legacy":false,"name":"plg_authentication_ldap","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_LDAP_XML_DESCRIPTION","group":""}', '{"host":"","port":"389","use_ldapV3":"0","negotiate_tls":"0","no_referrals":"0","auth_method":"bind","base_dn":"","search_string":"","users_dn":"","username":"admin","password":"bobby7","ldap_fullname":"fullName","ldap_email":"mail","ldap_uid":"uid"}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(404, 'plg_content_emailcloak', 'plugin', 'emailcloak', 'content', 0, 1, 1, 0, '{"legacy":false,"name":"plg_content_emailcloak","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_CONTENT_EMAILCLOAK_XML_DESCRIPTION","group":""}', '{"mode":"1"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(405, 'plg_content_geshi', 'plugin', 'geshi', 'content', 0, 0, 1, 0, '{"legacy":false,"name":"plg_content_geshi","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"","authorUrl":"qbnz.com\\/highlighter","version":"2.5.0","description":"PLG_CONTENT_GESHI_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(406, 'plg_content_loadmodule', 'plugin', 'loadmodule', 'content', 0, 1, 1, 0, '{"legacy":false,"name":"plg_content_loadmodule","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_LOADMODULE_XML_DESCRIPTION","group":""}', '{"style":"xhtml"}', '', '', 0, '2011-09-18 15:22:50', 0, 0),
(407, 'plg_content_pagebreak', 'plugin', 'pagebreak', 'content', 0, 1, 1, 1, '{"legacy":false,"name":"plg_content_pagebreak","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_CONTENT_PAGEBREAK_XML_DESCRIPTION","group":""}', '{"title":"1","multipage_toc":"1","showall":"1"}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(408, 'plg_content_pagenavigation', 'plugin', 'pagenavigation', 'content', 0, 1, 1, 1, '{"legacy":false,"name":"plg_content_pagenavigation","type":"plugin","creationDate":"January 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_PAGENAVIGATION_XML_DESCRIPTION","group":""}', '{"position":"1"}', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(409, 'plg_content_vote', 'plugin', 'vote', 'content', 0, 1, 1, 1, '{"legacy":false,"name":"plg_content_vote","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_VOTE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 6, 0),
(410, 'plg_editors_codemirror', 'plugin', 'codemirror', 'editors', 0, 1, 1, 1, '{"legacy":false,"name":"plg_editors_codemirror","type":"plugin","creationDate":"28 March 2011","author":"Marijn Haverbeke","copyright":"","authorEmail":"N\\/A","authorUrl":"","version":"1.0","description":"PLG_CODEMIRROR_XML_DESCRIPTION","group":""}', '{"linenumbers":"0","tabmode":"indent"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(411, 'plg_editors_none', 'plugin', 'none', 'editors', 0, 1, 1, 1, '{"legacy":false,"name":"plg_editors_none","type":"plugin","creationDate":"August 2004","author":"Unknown","copyright":"","authorEmail":"N\\/A","authorUrl":"","version":"2.5.0","description":"PLG_NONE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(412, 'plg_editors_tinymce', 'plugin', 'tinymce', 'editors', 0, 1, 1, 1, '{"legacy":false,"name":"plg_editors_tinymce","type":"plugin","creationDate":"2005-2012","author":"Moxiecode Systems AB","copyright":"Moxiecode Systems AB","authorEmail":"N\\/A","authorUrl":"tinymce.moxiecode.com\\/","version":"3.5.2","description":"PLG_TINY_XML_DESCRIPTION","group":""}', '{"mode":"1","skin":"0","entity_encoding":"raw","lang_mode":"0","lang_code":"en","text_direction":"ltr","content_css":"1","content_css_custom":"","relative_urls":"1","newlines":"0","invalid_elements":"script,applet,iframe","extended_elements":"","toolbar":"top","toolbar_align":"left","html_height":"550","html_width":"750","resizing":"true","resize_horizontal":"false","element_path":"1","fonts":"1","paste":"1","searchreplace":"1","insertdate":"1","format_date":"%Y-%m-%d","inserttime":"1","format_time":"%H:%M:%S","colors":"1","table":"1","smilies":"1","media":"1","hr":"1","directionality":"1","fullscreen":"1","style":"1","layer":"1","xhtmlxtras":"1","visualchars":"1","nonbreaking":"1","template":"1","blockquote":"1","wordcount":"1","advimage":"1","advlink":"1","advlist":"1","autosave":"1","contextmenu":"1","inlinepopups":"1","custom_plugin":"","custom_button":""}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(413, 'plg_editors-xtd_article', 'plugin', 'article', 'editors-xtd', 0, 1, 1, 1, '{"legacy":false,"name":"plg_editors-xtd_article","type":"plugin","creationDate":"October 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_ARTICLE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(414, 'plg_editors-xtd_image', 'plugin', 'image', 'editors-xtd', 0, 1, 1, 0, '{"legacy":false,"name":"plg_editors-xtd_image","type":"plugin","creationDate":"August 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_IMAGE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(415, 'plg_editors-xtd_pagebreak', 'plugin', 'pagebreak', 'editors-xtd', 0, 1, 1, 0, '{"legacy":false,"name":"plg_editors-xtd_pagebreak","type":"plugin","creationDate":"August 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_EDITORSXTD_PAGEBREAK_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(416, 'plg_editors-xtd_readmore', 'plugin', 'readmore', 'editors-xtd', 0, 1, 1, 0, '{"legacy":false,"name":"plg_editors-xtd_readmore","type":"plugin","creationDate":"March 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_READMORE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(417, 'plg_search_categories', 'plugin', 'categories', 'search', 0, 1, 1, 0, '{"legacy":false,"name":"plg_search_categories","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SEARCH_CATEGORIES_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(418, 'plg_search_contacts', 'plugin', 'contacts', 'search', 0, 1, 1, 0, '{"legacy":false,"name":"plg_search_contacts","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SEARCH_CONTACTS_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(419, 'plg_search_content', 'plugin', 'content', 'search', 0, 1, 1, 0, '{"legacy":false,"name":"plg_search_content","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SEARCH_CONTENT_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(420, 'plg_search_newsfeeds', 'plugin', 'newsfeeds', 'search', 0, 1, 1, 0, '{"legacy":false,"name":"plg_search_newsfeeds","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SEARCH_NEWSFEEDS_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(421, 'plg_search_weblinks', 'plugin', 'weblinks', 'search', 0, 1, 1, 0, '{"legacy":false,"name":"plg_search_weblinks","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SEARCH_WEBLINKS_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(422, 'plg_system_languagefilter', 'plugin', 'languagefilter', 'system', 0, 0, 1, 1, '{"legacy":false,"name":"plg_system_languagefilter","type":"plugin","creationDate":"July 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SYSTEM_LANGUAGEFILTER_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(423, 'plg_system_p3p', 'plugin', 'p3p', 'system', 0, 1, 1, 1, '{"legacy":false,"name":"plg_system_p3p","type":"plugin","creationDate":"September 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_P3P_XML_DESCRIPTION","group":""}', '{"headers":"NOI ADM DEV PSAi COM NAV OUR OTRo STP IND DEM"}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(424, 'plg_system_cache', 'plugin', 'cache', 'system', 0, 0, 1, 1, '{"legacy":false,"name":"plg_system_cache","type":"plugin","creationDate":"February 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_CACHE_XML_DESCRIPTION","group":""}', '{"browsercache":"0","cachetime":"15"}', '', '', 0, '0000-00-00 00:00:00', 9, 0),
(425, 'plg_system_debug', 'plugin', 'debug', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"plg_system_debug","type":"plugin","creationDate":"December 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_DEBUG_XML_DESCRIPTION","group":""}', '{"profile":"1","queries":"1","memory":"1","language_files":"1","language_strings":"1","strip-first":"1","strip-prefix":"","strip-suffix":""}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(426, 'plg_system_log', 'plugin', 'log', 'system', 0, 1, 1, 1, '{"legacy":false,"name":"plg_system_log","type":"plugin","creationDate":"April 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_LOG_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 5, 0);
INSERT INTO `#__extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES
(427, 'plg_system_redirect', 'plugin', 'redirect', 'system', 0, 1, 1, 1, '{"legacy":false,"name":"plg_system_redirect","type":"plugin","creationDate":"April 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_REDIRECT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 6, 0),
(428, 'plg_system_remember', 'plugin', 'remember', 'system', 0, 1, 1, 1, '{"legacy":false,"name":"plg_system_remember","type":"plugin","creationDate":"April 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_REMEMBER_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 7, 0),
(429, 'plg_system_sef', 'plugin', 'sef', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"plg_system_sef","type":"plugin","creationDate":"December 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SEF_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 8, 0),
(430, 'plg_system_logout', 'plugin', 'logout', 'system', 0, 1, 1, 1, '{"legacy":false,"name":"plg_system_logout","type":"plugin","creationDate":"April 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SYSTEM_LOGOUT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(431, 'plg_user_contactcreator', 'plugin', 'contactcreator', 'user', 0, 0, 1, 1, '{"legacy":false,"name":"plg_user_contactcreator","type":"plugin","creationDate":"August 2009","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_CONTACTCREATOR_XML_DESCRIPTION","group":""}', '{"autowebpage":"","category":"34","autopublish":"0"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(432, 'plg_user_joomla', 'plugin', 'joomla', 'user', 0, 1, 1, 0, '{"legacy":false,"name":"plg_user_joomla","type":"plugin","creationDate":"December 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2009 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_USER_JOOMLA_XML_DESCRIPTION","group":""}', '{"autoregister":"1"}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(433, 'plg_user_profile', 'plugin', 'profile', 'user', 0, 0, 1, 1, '{"legacy":false,"name":"plg_user_profile","type":"plugin","creationDate":"January 2008","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_USER_PROFILE_XML_DESCRIPTION","group":""}', '{"register-require_address1":"1","register-require_address2":"1","register-require_city":"1","register-require_region":"1","register-require_country":"1","register-require_postal_code":"1","register-require_phone":"1","register-require_website":"1","register-require_favoritebook":"1","register-require_aboutme":"1","register-require_tos":"1","register-require_dob":"1","profile-require_address1":"1","profile-require_address2":"1","profile-require_city":"1","profile-require_region":"1","profile-require_country":"1","profile-require_postal_code":"1","profile-require_phone":"1","profile-require_website":"1","profile-require_favoritebook":"1","profile-require_aboutme":"1","profile-require_tos":"1","profile-require_dob":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(434, 'plg_extension_joomla', 'plugin', 'joomla', 'extension', 0, 1, 1, 1, '{"legacy":false,"name":"plg_extension_joomla","type":"plugin","creationDate":"May 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_EXTENSION_JOOMLA_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(435, 'plg_content_joomla', 'plugin', 'joomla', 'content', 0, 1, 1, 0, '{"legacy":false,"name":"plg_content_joomla","type":"plugin","creationDate":"November 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_CONTENT_JOOMLA_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(436, 'plg_system_languagecode', 'plugin', 'languagecode', 'system', 0, 0, 1, 0, '{"legacy":false,"name":"plg_system_languagecode","type":"plugin","creationDate":"November 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SYSTEM_LANGUAGECODE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 10, 0),
(437, 'plg_quickicon_joomlaupdate', 'plugin', 'joomlaupdate', 'quickicon', 0, 1, 1, 1, '{"legacy":false,"name":"plg_quickicon_joomlaupdate","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_QUICKICON_JOOMLAUPDATE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(438, 'plg_quickicon_extensionupdate', 'plugin', 'extensionupdate', 'quickicon', 0, 1, 1, 1, '{"legacy":false,"name":"plg_quickicon_extensionupdate","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_QUICKICON_EXTENSIONUPDATE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(439, 'plg_captcha_recaptcha', 'plugin', 'recaptcha', 'captcha', 0, 1, 1, 0, '{"legacy":false,"name":"plg_captcha_recaptcha","type":"plugin","creationDate":"December 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_CAPTCHA_RECAPTCHA_XML_DESCRIPTION","group":""}', '{"public_key":"","private_key":"","theme":"clean"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(440, 'plg_system_highlight', 'plugin', 'highlight', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"plg_system_highlight","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SYSTEM_HIGHLIGHT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 7, 0),
(441, 'plg_content_finder', 'plugin', 'finder', 'content', 0, 0, 1, 0, '{"legacy":false,"name":"plg_content_finder","type":"plugin","creationDate":"December 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_CONTENT_FINDER_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(442, 'plg_finder_categories', 'plugin', 'categories', 'finder', 0, 1, 1, 0, '{"legacy":false,"name":"plg_finder_categories","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_FINDER_CATEGORIES_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(443, 'plg_finder_contacts', 'plugin', 'contacts', 'finder', 0, 1, 1, 0, '{"legacy":false,"name":"plg_finder_contacts","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_FINDER_CONTACTS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(444, 'plg_finder_content', 'plugin', 'content', 'finder', 0, 1, 1, 0, '{"legacy":false,"name":"plg_finder_content","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_FINDER_CONTENT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(445, 'plg_finder_newsfeeds', 'plugin', 'newsfeeds', 'finder', 0, 1, 1, 0, '{"legacy":false,"name":"plg_finder_newsfeeds","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_FINDER_NEWSFEEDS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(446, 'plg_finder_weblinks', 'plugin', 'weblinks', 'finder', 0, 1, 1, 0, '{"legacy":false,"name":"plg_finder_weblinks","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_FINDER_WEBLINKS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(500, 'atomic', 'template', 'atomic', '', 0, 1, 1, 0, '{"legacy":false,"name":"atomic","type":"template","creationDate":"10\\/10\\/09","author":"Ron Severdia","copyright":"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.","authorEmail":"contact@kontentdesign.com","authorUrl":"http:\\/\\/www.kontentdesign.com","version":"2.5.0","description":"TPL_ATOMIC_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(502, 'bluestork', 'template', 'bluestork', '', 1, 1, 1, 0, '{"legacy":false,"name":"bluestork","type":"template","creationDate":"07\\/02\\/09","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"TPL_BLUESTORK_XML_DESCRIPTION","group":""}', '{"useRoundedCorners":"1","showSiteName":"0","textBig":"0","highContrast":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(503, 'beez_20', 'template', 'beez_20', '', 0, 1, 1, 0, '{"legacy":false,"name":"beez_20","type":"template","creationDate":"25 November 2009","author":"Angie Radtke","copyright":"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.","authorEmail":"a.radtke@derauftritt.de","authorUrl":"http:\\/\\/www.der-auftritt.de","version":"2.5.0","description":"TPL_BEEZ2_XML_DESCRIPTION","group":""}', '{"wrapperSmall":"53","wrapperLarge":"72","sitetitle":"","sitedescription":"","navposition":"center","templatecolor":"nature"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(504, 'hathor', 'template', 'hathor', '', 1, 1, 1, 0, '{"legacy":false,"name":"hathor","type":"template","creationDate":"May 2010","author":"Andrea Tarr","copyright":"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.","authorEmail":"hathor@tarrconsulting.com","authorUrl":"http:\\/\\/www.tarrconsulting.com","version":"2.5.0","description":"TPL_HATHOR_XML_DESCRIPTION","group":""}', '{"showSiteName":"0","colourChoice":"0","boldText":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(505, 'beez5', 'template', 'beez5', '', 0, 1, 1, 0, '{"legacy":false,"name":"beez5","type":"template","creationDate":"21 May 2010","author":"Angie Radtke","copyright":"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.","authorEmail":"a.radtke@derauftritt.de","authorUrl":"http:\\/\\/www.der-auftritt.de","version":"2.5.0","description":"TPL_BEEZ5_XML_DESCRIPTION","group":""}', '{"wrapperSmall":"53","wrapperLarge":"72","sitetitle":"","sitedescription":"","navposition":"center","html5":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(600, 'English (United Kingdom)', 'language', 'en-GB', '', 0, 1, 1, 1, '{"legacy":false,"name":"English (United Kingdom)","type":"language","creationDate":"2008-03-15","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.5","description":"en-GB site language","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(601, 'English (United Kingdom)', 'language', 'en-GB', '', 1, 1, 1, 1, '{"legacy":false,"name":"English (United Kingdom)","type":"language","creationDate":"2008-03-15","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.5","description":"en-GB administrator language","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(700, 'files_joomla', 'file', 'joomla', '', 0, 1, 1, 1, '{"legacy":false,"name":"files_joomla","type":"file","creationDate":"June 2012","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.6","description":"FILES_JOOMLA_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(800, 'PKG_JOOMLA', 'package', 'pkg_joomla', '', 0, 1, 1, 1, '{"legacy":false,"name":"PKG_JOOMLA","type":"package","creationDate":"2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"http:\\/\\/www.joomla.org","version":"2.5.0","description":"PKG_JOOMLA_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(801, 'rt_kirigami', 'template', 'rt_kirigami', '', 0, 1, 1, 0, '{"legacy":false,"name":"rt_kirigami","type":"template","creationDate":" July 10, 2012","author":"RocketTheme, LLC","copyright":"Copyright 2005-2012 - RocketTheme.com","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.0-SNAPSHOT","description":"Kirigami","group":""}', '{"master":"true"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(803, 'Gantry', 'library', 'lib_gantry', '', 0, 1, 1, 0, '{"legacy":false,"name":"Gantry","type":"library","creationDate":"June 19, 2012","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2012 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"3.2.20","description":"${project.description}","group":""}', '{}', '{"last_update":1343731557}', '', 0, '0000-00-00 00:00:00', 0, 0),
(804, 'gantry', 'component', 'com_gantry', '', 0, 1, 0, 0, 'false', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(805, 'System - Gantry', 'plugin', 'gantry', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"System - Gantry","type":"plugin","creationDate":"June 19, 2012","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2012 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"3.2.20","description":"Gantry System Plugin for Joomla","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(808, 'System - RokCommon', 'plugin', 'rokcommon', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"System - RokCommon","type":"plugin","creationDate":"June 26, 2012","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2012 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"2.6.4","description":"RokCommon System Plugin","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(809, 'roksprocket', 'component', 'com_roksprocket', '', 1, 1, 0, 0, '{"legacy":false,"name":"RokSprocket","type":"component","creationDate":"July 17, 2012","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2012 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.5.7-SNAPSHOT","description":"RokSprocket Component for Joomla","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(810, 'RokSprocket Module', 'module', 'mod_roksprocket', '', 0, 1, 1, 0, '{"legacy":false,"name":"RokSprocket Module","type":"module","creationDate":"July 17, 2012","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2012 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.5.7-SNAPSHOT","description":"","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(811, 'System - RokSprocket', 'plugin', 'roksprocket', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"System - RokSprocket","type":"plugin","creationDate":"July 17, 2012","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2012 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.5.7-SNAPSHOT","description":"RokSprocket System Plugin","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(812, 'Content - RokInjectModule', 'plugin', 'rokinjectmodule', 'content', 0, 1, 1, 0, '{"legacy":false,"name":"Content - RokInjectModule","type":"plugin","creationDate":"April 10, 2012","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2012 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.2","description":"RokInjectModule Content Plugin.  Use format [module-{moduleid}] in your article to inject a module. You can also specify a style, eg: [module-28 style=xhtml]","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(814, 'RokAjaxSearch', 'module', 'mod_rokajaxsearch', '', 0, 1, 1, 0, '{"legacy":false,"name":"RokAjaxSearch","type":"module","creationDate":"May 2, 2012","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2012 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.1","description":"RokAjaxSearch is an ajaxian searcher that displays the results immediately and allows to choose the proper one.","group":""}', '{"moduleclass_sfx":"","search_page":"index.php?option=com_search&view=search&tmpl=component","adv_search_page":"index.php?option=com_search&view=search","spacer_style_options":"","include_css":"1","theme":"blue","spacer_advanced_search":"","searchphrase":"any","ordering":"newest","limit":"10","perpage":"3","websearch":"0","blogsearch":"0","imagesearch":"0","videosearch":"0","websearch_api":"","show_pagination":"1","safesearch":"MODERATE","image_size":"MEDIUM","show_estimated":"1","spacer_advanced_settings":"","hide_divs":"","include_link":"1","show_description":"1","include_category":"1","show_readmore":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(817, 'rokgallery', 'component', 'com_rokgallery', '', 1, 1, 0, 0, '{"legacy":false,"name":"RokGallery","type":"component","creationDate":"July 15, 2012","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2012 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"2.15-SNAPSHOT","description":"A Gallery component for Joomla 1.6 from RocketTheme.","group":""}', '{"allow_duplicate_files":"1","autoclear_successful_jobs":"0","publish_slices_on_file_publish":"1","gallery_remove_slice":"1","gallery_autopublish":"1","default_thumb_xsize":"150","default_thumb_ysize":"150","default_thumb_keep_aspect":"1","default_thumb_background":"transparent","jpeg_quality":"100","png_compression":"0","love_text":"ROKGALLERY_LOVE","unlove_text":"ROKGALLERY_UNLOVE"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(818, 'RokGallery Module', 'module', 'mod_rokgallery', '', 0, 1, 1, 0, '{"legacy":false,"name":"RokGallery Module","type":"module","creationDate":"July 15, 2012","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2012 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"2.15-SNAPSHOT","description":"A module to allow you to display galleries from the RokGallery component in a module position.","group":""}', '{"link":"0","default_menuitem":"0","title":"false","caption":"false","sort_by":"gallery_ordering","sort_direction":"ASC","limit_count":"10","style":"light","layout":"grid","columns":"1","arrows":"onhover","navigation":"thumbnails","animation_type":"random","animation_duration":"500","autoplay_enabled":"0","autoplay_delay":"7","showcase_arrows":"onhover","showcase_image_position":"left","showcase_imgpadding":"0","showcase_fixedheight":"0","showcase_animatedheight":"1","showcase_animation_type":"random","showcase_captionsanimation":"crossfade","showcase_animation_duration":"500","showcase_autoplay_enabled":"0","showcase_autoplay_delay":"7","cache":"0","module_cache":"1","cache_time":"900","moduleclass_sfx":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(819, 'Button - RokGallery', 'plugin', 'rokgallery', 'editors-xtd', 0, 1, 1, 0, '{"legacy":false,"name":"Button - RokGallery","type":"plugin","creationDate":"July 15, 2012","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2012 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"2.15-SNAPSHOT","description":"This is an Editor Button to allow selection of RokGallery Slices","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 50, 0),
(820, 'System - RokGallery', 'plugin', 'rokgallery', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"System - RokGallery","type":"plugin","creationDate":"July 15, 2012","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2012 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"2.15-SNAPSHOT","description":"A system level support plugin for RokGallery.","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 50, 0),
(822, 'Content - RokSocialButtons', 'plugin', 'roksocialbuttons', 'content', 0, 0, 1, 0, '{"legacy":false,"name":"Content - RokSocialButtons","type":"plugin","creationDate":"April 2, 2012","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2012 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.1","description":"RokSocialButtons Content Plugin.  Use format {socialbuttons} in your article to display the social buttons in your article","group":""}', '{"addthis_id":"","enable_twitter":"1","enable_facebook":"1","enable_google":"1","prepend_text":"","extra_class":""}', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(824, 'System - RokBooster', 'plugin', 'rokbooster', 'system', 0, 0, 1, 0, '{"legacy":false,"name":"System - RokBooster","type":"plugin","creationDate":"June 26, 2012","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2012 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.0.1","description":"\\n        \\n        <div class=\\"booster-description\\">\\n        <img src=\\"..\\/plugins\\/system\\/rokbooster\\/assets\\/images\\/rokbooster.jpg\\" class=\\"img-padding\\" \\/><h1>RokBooster<\\/h1>\\n        <p>Increase the speed of your site by enabling the RokBooster plug-in.  This advanced extensions will <strong>compress<\\/strong> and <strong>combine<\\/strong> your <strong>CSS<\\/strong> and <strong>JavaScript<\\/strong> into as few files as possible each.  RokBooster can dramatically reduce the number of HTTP calls a browser has to make, and sending those compressed files GZipped means your pages will load faster with less load on your server.<\\/p>\\n\\n        <h2>Key Features:<\\/h2>\\n        <ul class=\\"features\\">\\n            <li>Combine and compress CSS and JavaScript into as few files as possible<\\/li>\\n            <li>GZip compression used to send CSS and JavaScript files<\\/li>\\n            <li>Compress Inline CSS and JavaScript<\\/li>\\n            <li>Customizable cache timeout<\\/li>\\n            <li>Background rendering, so initial file processing won''t slow your users down<\\/li>\\n            <li>Full page scan allows for non-header JavaScript and CSS to be included<\\/li>\\n            <li>Ability to ignore specific CSS and JavaScript files<\\/li>\\n        <\\/ul>\\n        <p class=\\"note\\"><strong>NOTE:<\\/strong> Clearing the Joomla cache will remove the RokBooster compressed cache files causing them to regenerate on the next page hit<\\/p>\\n        <\\/div>\\n        \\n    ","group":""}', '{"cache_time":"60","minify_css":"1","style_sort":"RokBooster_Compressor_Sort_ExternalOnTop","inline_css":"1","imported_css":"1","minify_js":"1","script_sort":"RokBooster_Compressor_Sort_ExternalOnTop","inline_js":"1","ignored_files":"","scan_method":"header","use_background_processing":"1","disable_for_ie":"1"}', '', '', 0, '0000-00-00 00:00:00', 100, 0),
(826, 'RokTwittie', 'module', 'mod_roktwittie', '', 0, 1, 1, 0, '{"legacy":false,"name":"RokTwittie","type":"module","creationDate":"June 1, 2012","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2012 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.7","description":"RokTwittie is a Twitter module that lets you display up to 140 tweets, display tweets through oAuth authentication and display Twitter search results. RokTwittie supports many settings like multiple users to display, merged tweets and comes with a light and dark built-in styles.","group":""}', '{"@status":"","use_oauth":"0","consumer_key":"","consumer_secret":"","@signin":"","moduleclass_sfx":"","load_css":"1","enable_cache":"1","timeout_connect":"3","timeout_response":"6","enable_cache_time":"5","usernames":"rockettheme","inactive_opacity":"0.5","show_default_avatar":"1","header_style":"dark","include_rts":"1","enable_statuses":"1","status_external":"1","show_feed":"1","show_follow_updates":"1","show_bio":"1","show_web":"1","show_location":"1","show_updates":"1","show_followers":"1","show_following":"1","show_following_icons":"1","following_icons_count":"10","show_viewall":"1","enable_usernames":"1","enable_usernames_avatar":"1","usernames_avatar_size":"48","usernames_count_size":"4","usernames_count_merged":"1","enable_usernames_externals":"1","enable_usernames_source":"1","enable_usernames_user":"1","enable_search":"1","search":"@rockettheme","enable_search_avatar":"1","search_avatar_size":"48","search_count_size":"4","enable_search_externals":"1","enable_search_source":"1","enable_search_user":"1","oauth_token":"","oauth_token_secret":"","cache":"0","module_cache":"1","cache_time":"900"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(828, 'System - RokExtender', 'plugin', 'rokextender', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"System - RokExtender","type":"plugin","creationDate":"February 24, 2011","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2011 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.0","description":"System - Gantry","group":""}', '{"registered":"\\/modules\\/mod_roknavmenu\\/lib\\/RokNavMenuEvents.php"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(829, 'RokNavMenu', 'module', 'mod_roknavmenu', '', 0, 1, 1, 0, '{"legacy":false,"name":"RokNavMenu","type":"module","creationDate":"July 2, 2012","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2012 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.13","description":"RocketTheme Customizable Navigation Menu","group":""}', '{"limit_levels":"0","startLevel":"0","endLevel":"0","showAllChildren":"0","filteringspacer2":"","theme":"default","custom_layout":"default.php","custom_formatter":"default.php","cache":"1","cache_time":"900","cachemode":"itemid"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(833, 'Editor - RokPad', 'plugin', 'rokpad', 'editors', 0, 1, 1, 0, '{"legacy":false,"name":"Editor - RokPad","type":"plugin","creationDate":"July 9, 2012","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2012 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"2.0.0","description":"\\n        <div class=\\"rokpad-description\\">\\n        <img src=\\"..\\/plugins\\/editors\\/rokpad\\/assets\\/admin\\/images\\/rokpad.jpg\\" class=\\"img-padding\\" \\/><h1>RokPad<\\/h1>\\n        <h2>The Power of Desktop Text Editor in a Joomla!<\\/h2>\\n        <p>Ever wished you could use a powerful desktop text editor such as Textmate, SublimeText, or UltraEdit directly on a Joomla! web site?  Now with RokPad we provide many features and capabilities that traditionally would only be found in a powerful desktop editor.  RokPad provides advanced functions such as an Ajax saving action, syntax highlighting, configurable themes, multiple cursors and selections, shortcut keys, multiple language support, and many other incredible features.<\\/p>\\n\\n        <h2>Key Features:<\\/h2>\\n        <ul class=\\"features\\">\\n\\t\\t\\t<li>Code Highlighter built on the great ACE Editor<\\/li>\\n\\t        <li>Support for CSS, HTML, JavaScript, JSON, LESS, Markdown, PHP, SQL, Plain Text, Textile, XML and more...<\\/li>\\n\\t        <li>Ajax save and Automatic Save options. You''ll never loose your content again, nor wait until the page has finished reloading after a save!<\\/li>\\n\\t        <li>Save, Undo, Redo, Goto line, Advanced Search and Search &amp; Replace, Full Screen. Settings like Themes, Font Size, Code Folding, Wrap Mode, Invisible Characters, Print Margin, Highlight of selected word<\\/li>\\n\\t        <li>26 Themes to choose from<\\/li>\\n\\t        <li>Resizable Editor by dragging the Statusbar<\\/li>\\n\\t        <li>Keyboard shortcuts<\\/li>\\n\\t        <li>Brackets match<\\/li>\\n\\t        <li>Multiple cursors and selections<\\/li>\\n\\t        <li>Vertical Selection<\\/li>\\n\\t        <li>Ability to insert at multiple locations xtd-buttons shortcodes, all at once.<\\/li>\\n\\t        <li>Shortcodes and Universal Tag Insertion<\\/li>\\n\\t        <li>Drag &amp; Drop of text from external applications such as other Browser Tabs\\/windows or Native Applications (Supported on Firefox, Chrome, IE10 and Safari)<\\/li>\\n\\t        <li>Import local files by Drag &amp; Drop directly from your desktop! (Supported on Firefox, Chrome, IE10 and Safari 6+)<\\/li>\\n\\t        <li>And much more!<\\/li>\\n        <\\/ul>\\n        <\\/div>\\n        ","group":""}', '{"autosave-enabled":"0","autosave-time":"5","theme":"fluidvision","font-size":"12px","fold-style":"markbeginend","use-wrap-mode":"free","selection-style":"1","highlight-active-line":"1","highlight-selected-word":"1","show-invisibles":"0","show-gutter":"1","show-print-margin":"1","fade-fold-widgets":"0"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(835, 'System - RokBox', 'plugin', 'rokbox', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"System - RokBox","type":"plugin","creationDate":"April 2, 2012","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2012 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.2","description":"RokBox System Plugin","group":""}', '{"theme":"clean","custom-theme":"sample","custom-legacy":"0","width":"640","height":"460","transition":"Quad.easeOut","duration":"200","chase":"40","effect":"quicksilver","frame-border":"20","content-padding":"0","arrows-height":"35","captions":"1","captionsDelay":"800","scrolling":"0","keyEvents":"1","overlay_background":"#000000","overlay_opacity":"0.85","overlay_duration":"200","overlay_transition":"Quad.easeInOut","autoplay":"true","ytautoplay":"0","ythighquality":"0","controller":"false","bgcolor":"#f3f3f3","vimeoColor":"00adef","vimeoPortrait":"0","vimeoTitle":"0","vimeoFullScreen":"1","vimeoByline":"0"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(836, 'Content - RokBox', 'plugin', 'rokbox', 'content', 0, 1, 1, 0, '{"legacy":false,"name":"Content - RokBox","type":"plugin","creationDate":"April 2, 2012","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2012 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.2","description":"To be used with a RokBox enabled RocketTheme Joomla! template.  Syntax is {rokbox}link{\\/rokbox}.  If you want the image to be part of an ''album'', you can use the syntax {rokbox album=|albumname|}link{\\/rokbox}.  To provide text descriptions, please use the syntax {rokbox title=|your description|}link{\\/rokbox}. To specify a thumbnail, use the syntax {rokbox thumb=|thumbnail_link.jpg|}link{\\/rokbox}. If you want to use a text link, you can specify the text using syntax: {rokbox text=|your link text here|}link{\\/rokbox}. You can also use album, title, thumb and text in the same tag.","group":""}', '{"remote_sizes":"0","thumb_ext":"_thumb","thumb_class":"album","thumb_custom":"0","thumb_dir":"cache","thumb_width":"150","thumb_height":"100","thumb_quality":"90"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(838, 'RokCandy', 'component', 'com_rokcandy', '', 1, 1, 0, 0, '{"legacy":false,"name":"RokCandy","type":"component","creationDate":"April 2, 2012","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2012 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.3","description":"\\n\\t\\tRokCandy is a simple yet powerful macro system for Joomla 1.6.  It provides the ability to create and categorize macros that can be used throughout your site.\\n\\t","group":""}', '{"forcecache":"0","adminenabled":"0","editenabled":"0","contentPlugin":"0","disabled":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(839, 'Button - RokCandy', 'plugin', 'rokcandy', 'editors-xtd', 0, 1, 1, 0, '{"legacy":false,"name":"Button - RokCandy","type":"plugin","creationDate":"April 2, 2012","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2012 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.3","description":"This is an Editor Button to allow selection of RokCandy macros","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(840, 'System - RokCandy', 'plugin', 'rokcandy', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"System - RokCandy","type":"plugin","creationDate":"April 2, 2012","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2012 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.3","description":"This is the RokCandy system plugin that performs the macro replacement","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 50, 0),
(849, 'Installer', 'plugin', 'installer', 'system', 0, 0, 1, 0, '{"legacy":false,"name":"Installer","type":"plugin","creationDate":"July 19, 2012","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2012 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.5.7-SNAPSHOT","description":"RokSprocket (ver. 1.5.7-SNAPSHOT) - The swiss army knife of Joomla content modules!","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(853, 'RokCommon', 'library', 'lib_rokcommon', '', 0, 1, 1, 0, '{"legacy":false,"name":"RokCommon","type":"library","creationDate":"June 26, 2012","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2012 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"2.6.4","description":"RokCommon Shared Library","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0);

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_filters`
--

DROP TABLE IF EXISTS `#__finder_filters`;
CREATE TABLE IF NOT EXISTS `#__finder_filters` (
  `filter_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `state` tinyint(1) NOT NULL DEFAULT '1',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL,
  `created_by_alias` varchar(255) NOT NULL,
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `map_count` int(10) unsigned NOT NULL DEFAULT '0',
  `data` text NOT NULL,
  `params` mediumtext,
  PRIMARY KEY (`filter_id`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links`
--

DROP TABLE IF EXISTS `#__finder_links`;
CREATE TABLE IF NOT EXISTS `#__finder_links` (
  `link_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `url` varchar(255) NOT NULL,
  `route` varchar(255) NOT NULL,
  `title` varchar(255) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `indexdate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `md5sum` varchar(32) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '1',
  `state` int(5) DEFAULT '1',
  `access` int(5) DEFAULT '0',
  `language` varchar(8) NOT NULL,
  `publish_start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `list_price` double unsigned NOT NULL DEFAULT '0',
  `sale_price` double unsigned NOT NULL DEFAULT '0',
  `type_id` int(11) NOT NULL,
  `object` mediumblob NOT NULL,
  PRIMARY KEY (`link_id`),
  KEY `idx_type` (`type_id`),
  KEY `idx_title` (`title`),
  KEY `idx_md5` (`md5sum`),
  KEY `idx_url` (`url`(75)),
  KEY `idx_published_list` (`published`,`state`,`access`,`publish_start_date`,`publish_end_date`,`list_price`),
  KEY `idx_published_sale` (`published`,`state`,`access`,`publish_start_date`,`publish_end_date`,`sale_price`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_terms0`
--

DROP TABLE IF EXISTS `#__finder_links_terms0`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms0` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_terms1`
--

DROP TABLE IF EXISTS `#__finder_links_terms1`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms1` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_terms2`
--

DROP TABLE IF EXISTS `#__finder_links_terms2`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms2` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_terms3`
--

DROP TABLE IF EXISTS `#__finder_links_terms3`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms3` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_terms4`
--

DROP TABLE IF EXISTS `#__finder_links_terms4`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms4` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_terms5`
--

DROP TABLE IF EXISTS `#__finder_links_terms5`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms5` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_terms6`
--

DROP TABLE IF EXISTS `#__finder_links_terms6`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms6` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_terms7`
--

DROP TABLE IF EXISTS `#__finder_links_terms7`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms7` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_terms8`
--

DROP TABLE IF EXISTS `#__finder_links_terms8`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms8` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_terms9`
--

DROP TABLE IF EXISTS `#__finder_links_terms9`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms9` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_termsa`
--

DROP TABLE IF EXISTS `#__finder_links_termsa`;
CREATE TABLE IF NOT EXISTS `#__finder_links_termsa` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_termsb`
--

DROP TABLE IF EXISTS `#__finder_links_termsb`;
CREATE TABLE IF NOT EXISTS `#__finder_links_termsb` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_termsc`
--

DROP TABLE IF EXISTS `#__finder_links_termsc`;
CREATE TABLE IF NOT EXISTS `#__finder_links_termsc` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_termsd`
--

DROP TABLE IF EXISTS `#__finder_links_termsd`;
CREATE TABLE IF NOT EXISTS `#__finder_links_termsd` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_termse`
--

DROP TABLE IF EXISTS `#__finder_links_termse`;
CREATE TABLE IF NOT EXISTS `#__finder_links_termse` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_termsf`
--

DROP TABLE IF EXISTS `#__finder_links_termsf`;
CREATE TABLE IF NOT EXISTS `#__finder_links_termsf` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_taxonomy`
--

DROP TABLE IF EXISTS `#__finder_taxonomy`;
CREATE TABLE IF NOT EXISTS `#__finder_taxonomy` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL,
  `state` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `access` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `parent_id` (`parent_id`),
  KEY `state` (`state`),
  KEY `ordering` (`ordering`),
  KEY `access` (`access`),
  KEY `idx_parent_published` (`parent_id`,`state`,`access`)
);

--
-- Dumping data for table `#__finder_taxonomy`
--

INSERT INTO `#__finder_taxonomy` (`id`, `parent_id`, `title`, `state`, `access`, `ordering`) VALUES
(1, 0, 'ROOT', 0, 0, 0);

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_taxonomy_map`
--

DROP TABLE IF EXISTS `#__finder_taxonomy_map`;
CREATE TABLE IF NOT EXISTS `#__finder_taxonomy_map` (
  `link_id` int(10) unsigned NOT NULL,
  `node_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`node_id`),
  KEY `link_id` (`link_id`),
  KEY `node_id` (`node_id`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_terms`
--

DROP TABLE IF EXISTS `#__finder_terms`;
CREATE TABLE IF NOT EXISTS `#__finder_terms` (
  `term_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` float unsigned NOT NULL DEFAULT '0',
  `soundex` varchar(75) NOT NULL,
  `links` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  UNIQUE KEY `idx_term` (`term`),
  KEY `idx_term_phrase` (`term`,`phrase`),
  KEY `idx_stem_phrase` (`stem`,`phrase`),
  KEY `idx_soundex_phrase` (`soundex`,`phrase`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_terms_common`
--

DROP TABLE IF EXISTS `#__finder_terms_common`;
CREATE TABLE IF NOT EXISTS `#__finder_terms_common` (
  `term` varchar(75) NOT NULL,
  `language` varchar(3) NOT NULL,
  KEY `idx_word_lang` (`term`,`language`),
  KEY `idx_lang` (`language`)
);

--
-- Dumping data for table `#__finder_terms_common`
--

INSERT INTO `#__finder_terms_common` (`term`, `language`) VALUES
('a', 'en'),
('about', 'en'),
('after', 'en'),
('ago', 'en'),
('all', 'en'),
('am', 'en'),
('an', 'en'),
('and', 'en'),
('ani', 'en'),
('any', 'en'),
('are', 'en'),
('aren''t', 'en'),
('as', 'en'),
('at', 'en'),
('be', 'en'),
('but', 'en'),
('by', 'en'),
('for', 'en'),
('from', 'en'),
('get', 'en'),
('go', 'en'),
('how', 'en'),
('if', 'en'),
('in', 'en'),
('into', 'en'),
('is', 'en'),
('isn''t', 'en'),
('it', 'en'),
('its', 'en'),
('me', 'en'),
('more', 'en'),
('most', 'en'),
('must', 'en'),
('my', 'en'),
('new', 'en'),
('no', 'en'),
('none', 'en'),
('not', 'en'),
('noth', 'en'),
('nothing', 'en'),
('of', 'en'),
('off', 'en'),
('often', 'en'),
('old', 'en'),
('on', 'en'),
('onc', 'en'),
('once', 'en'),
('onli', 'en'),
('only', 'en'),
('or', 'en'),
('other', 'en'),
('our', 'en'),
('ours', 'en'),
('out', 'en'),
('over', 'en'),
('page', 'en'),
('she', 'en'),
('should', 'en'),
('small', 'en'),
('so', 'en'),
('some', 'en'),
('than', 'en'),
('thank', 'en'),
('that', 'en'),
('the', 'en'),
('their', 'en'),
('theirs', 'en'),
('them', 'en'),
('then', 'en'),
('there', 'en'),
('these', 'en'),
('they', 'en'),
('this', 'en'),
('those', 'en'),
('thus', 'en'),
('time', 'en'),
('times', 'en'),
('to', 'en'),
('too', 'en'),
('true', 'en'),
('under', 'en'),
('until', 'en'),
('up', 'en'),
('upon', 'en'),
('use', 'en'),
('user', 'en'),
('users', 'en'),
('veri', 'en'),
('version', 'en'),
('very', 'en'),
('via', 'en'),
('want', 'en'),
('was', 'en'),
('way', 'en'),
('were', 'en'),
('what', 'en'),
('when', 'en'),
('where', 'en'),
('whi', 'en'),
('which', 'en'),
('who', 'en'),
('whom', 'en'),
('whose', 'en'),
('why', 'en'),
('wide', 'en'),
('will', 'en'),
('with', 'en'),
('within', 'en'),
('without', 'en'),
('would', 'en'),
('yes', 'en'),
('yet', 'en'),
('you', 'en'),
('your', 'en'),
('yours', 'en');

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_tokens`
--

DROP TABLE IF EXISTS `#__finder_tokens`;
CREATE TABLE IF NOT EXISTS `#__finder_tokens` (
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` float unsigned NOT NULL DEFAULT '1',
  `context` tinyint(1) unsigned NOT NULL DEFAULT '2',
  KEY `idx_word` (`term`),
  KEY `idx_context` (`context`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_tokens_aggregate`
--

DROP TABLE IF EXISTS `#__finder_tokens_aggregate`;
CREATE TABLE IF NOT EXISTS `#__finder_tokens_aggregate` (
  `term_id` int(10) unsigned NOT NULL,
  `map_suffix` char(1) NOT NULL,
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `term_weight` float unsigned NOT NULL,
  `context` tinyint(1) unsigned NOT NULL DEFAULT '2',
  `context_weight` float unsigned NOT NULL,
  `total_weight` float unsigned NOT NULL,
  KEY `token` (`term`),
  KEY `keyword_id` (`term_id`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_types`
--

DROP TABLE IF EXISTS `#__finder_types`;
CREATE TABLE IF NOT EXISTS `#__finder_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL,
  `mime` varchar(100) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `title` (`title`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__languages`
--

DROP TABLE IF EXISTS `#__languages`;
CREATE TABLE IF NOT EXISTS `#__languages` (
  `lang_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `lang_code` char(7) NOT NULL,
  `title` varchar(50) NOT NULL,
  `title_native` varchar(50) NOT NULL,
  `sef` varchar(50) NOT NULL,
  `image` varchar(50) NOT NULL,
  `description` varchar(512) NOT NULL,
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `sitename` varchar(1024) NOT NULL DEFAULT '',
  `published` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`lang_id`),
  UNIQUE KEY `idx_sef` (`sef`),
  UNIQUE KEY `idx_image` (`image`),
  UNIQUE KEY `idx_langcode` (`lang_code`),
  KEY `idx_access` (`access`),
  KEY `idx_ordering` (`ordering`)
);

--
-- Dumping data for table `#__languages`
--

INSERT INTO `#__languages` (`lang_id`, `lang_code`, `title`, `title_native`, `sef`, `image`, `description`, `metakey`, `metadesc`, `sitename`, `published`, `access`, `ordering`) VALUES
(1, 'en-GB', 'English (UK)', 'English (UK)', 'en', 'en', '', '', '', '', 1, 0, 1);

-- --------------------------------------------------------

--
-- Table structure for table `#__menu`
--

DROP TABLE IF EXISTS `#__menu`;
CREATE TABLE IF NOT EXISTS `#__menu` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL COMMENT 'The type of menu this item belongs to. FK to #__menu_types.menutype',
  `title` varchar(255) NOT NULL COMMENT 'The display title of the menu item.',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL COMMENT 'The SEF alias of the menu item.',
  `note` varchar(255) NOT NULL DEFAULT '',
  `path` varchar(1024) NOT NULL COMMENT 'The computed path of the menu item based on the alias field.',
  `link` varchar(1024) NOT NULL COMMENT 'The actually link the menu item refers to.',
  `type` varchar(16) NOT NULL COMMENT 'The type of link: Component, URL, Alias, Separator',
  `published` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The published state of the menu link.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '1' COMMENT 'The parent menu item in the menu tree.',
  `level` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The relative level in the tree.',
  `component_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__extensions.id',
  `ordering` int(11) NOT NULL DEFAULT '0' COMMENT 'The relative ordering of the menu item in the tree.',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__users.id',
  `checked_out_time` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'The time the menu item was checked out.',
  `browserNav` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The click behaviour of the link.',
  `access` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The access level required to view the menu item.',
  `img` varchar(255) NOT NULL COMMENT 'The image of the menu item.',
  `template_style_id` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL COMMENT 'JSON encoded data for the menu item.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `home` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Indicates if this menu item is the home or default page.',
  `language` char(7) NOT NULL DEFAULT '',
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_client_id_parent_id_alias_language` (`client_id`,`parent_id`,`alias`,`language`),
  KEY `idx_componentid` (`component_id`,`menutype`,`published`,`access`),
  KEY `idx_menutype` (`menutype`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_path` (`path`(255)),
  KEY `idx_language` (`language`)
);

--
-- Dumping data for table `#__menu`
--

INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `ordering`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES
(1, '', 'Menu_Item_Root', 'root', '', '', '', '', 1, 0, 0, 0, 0, 0, '0000-00-00 00:00:00', 0, 0, '', 0, '', 0, 223, 0, '*', 0),
(2, 'menu', 'com_banners', 'Banners', '', 'Banners', 'index.php?option=com_banners', 'component', 0, 1, 1, 4, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners', 0, '', 1, 10, 0, '*', 1),
(3, 'menu', 'com_banners', 'Banners', '', 'Banners/Banners', 'index.php?option=com_banners', 'component', 0, 2, 2, 4, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners', 0, '', 2, 3, 0, '*', 1),
(4, 'menu', 'com_banners_categories', 'Categories', '', 'Banners/Categories', 'index.php?option=com_categories&extension=com_banners', 'component', 0, 2, 2, 6, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-cat', 0, '', 4, 5, 0, '*', 1),
(5, 'menu', 'com_banners_clients', 'Clients', '', 'Banners/Clients', 'index.php?option=com_banners&view=clients', 'component', 0, 2, 2, 4, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-clients', 0, '', 6, 7, 0, '*', 1),
(6, 'menu', 'com_banners_tracks', 'Tracks', '', 'Banners/Tracks', 'index.php?option=com_banners&view=tracks', 'component', 0, 2, 2, 4, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-tracks', 0, '', 8, 9, 0, '*', 1),
(7, 'menu', 'com_contact', 'Contacts', '', 'Contacts', 'index.php?option=com_contact', 'component', 0, 1, 1, 8, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact', 0, '', 11, 16, 0, '*', 1),
(8, 'menu', 'com_contact', 'Contacts', '', 'Contacts/Contacts', 'index.php?option=com_contact', 'component', 0, 7, 2, 8, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact', 0, '', 12, 13, 0, '*', 1),
(9, 'menu', 'com_contact_categories', 'Categories', '', 'Contacts/Categories', 'index.php?option=com_categories&extension=com_contact', 'component', 0, 7, 2, 6, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact-cat', 0, '', 14, 15, 0, '*', 1),
(10, 'menu', 'com_messages', 'Messaging', '', 'Messaging', 'index.php?option=com_messages', 'component', 0, 1, 1, 15, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages', 0, '', 17, 22, 0, '*', 1),
(11, 'menu', 'com_messages_add', 'New Private Message', '', 'Messaging/New Private Message', 'index.php?option=com_messages&task=message.add', 'component', 0, 10, 2, 15, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages-add', 0, '', 18, 19, 0, '*', 1),
(12, 'menu', 'com_messages_read', 'Read Private Message', '', 'Messaging/Read Private Message', 'index.php?option=com_messages', 'component', 0, 10, 2, 15, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages-read', 0, '', 20, 21, 0, '*', 1),
(13, 'menu', 'com_newsfeeds', 'News Feeds', '', 'News Feeds', 'index.php?option=com_newsfeeds', 'component', 0, 1, 1, 17, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds', 0, '', 23, 28, 0, '*', 1),
(14, 'menu', 'com_newsfeeds_feeds', 'Feeds', '', 'News Feeds/Feeds', 'index.php?option=com_newsfeeds', 'component', 0, 13, 2, 17, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds', 0, '', 24, 25, 0, '*', 1),
(15, 'menu', 'com_newsfeeds_categories', 'Categories', '', 'News Feeds/Categories', 'index.php?option=com_categories&extension=com_newsfeeds', 'component', 0, 13, 2, 6, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds-cat', 0, '', 26, 27, 0, '*', 1),
(16, 'menu', 'com_redirect', 'Redirect', '', 'Redirect', 'index.php?option=com_redirect', 'component', 0, 1, 1, 24, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:redirect', 0, '', 43, 44, 0, '*', 1),
(17, 'menu', 'com_search', 'Basic Search', '', 'Basic Search', 'index.php?option=com_search', 'component', 0, 1, 1, 19, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:search', 0, '', 33, 34, 0, '*', 1),
(18, 'menu', 'com_weblinks', 'Weblinks', '', 'Weblinks', 'index.php?option=com_weblinks', 'component', 0, 1, 1, 21, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:weblinks', 0, '', 35, 40, 0, '*', 1),
(19, 'menu', 'com_weblinks_links', 'Links', '', 'Weblinks/Links', 'index.php?option=com_weblinks', 'component', 0, 18, 2, 21, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:weblinks', 0, '', 36, 37, 0, '*', 1),
(20, 'menu', 'com_weblinks_categories', 'Categories', '', 'Weblinks/Categories', 'index.php?option=com_categories&extension=com_weblinks', 'component', 0, 18, 2, 6, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:weblinks-cat', 0, '', 38, 39, 0, '*', 1),
(21, 'menu', 'com_finder', 'Smart Search', '', 'Smart Search', 'index.php?option=com_finder', 'component', 0, 1, 1, 27, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:finder', 0, '', 31, 32, 0, '*', 1),
(22, 'menu', 'com_joomlaupdate', 'Joomla! Update', '', 'Joomla! Update', 'index.php?option=com_joomlaupdate', 'component', 0, 1, 1, 28, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:joomlaupdate', 0, '', 41, 42, 0, '*', 1),
(101, 'mainmenu', 'Home', 'home', '', 'home', 'index.php?option=com_content&view=featured', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"featured_categories":[""],"layout_type":"blog","num_leading_articles":"1","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"1","orderby_pri":"","orderby_sec":"front","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"0","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"August 2012 Template Demo","show_page_heading":0,"page_heading":"","pageclass_sfx":" aug12-home","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"fusion_item_subtext":"Welcome!","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"87","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"164","splitmenu_item_subtext":"Welcome!"}', 29, 30, 1, '*', 0),
(102, 'mainmenu', 'Features', 'features', '', 'features', 'index.php?option=com_content&view=article&id=1', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"0","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"0","show_item_navigation":"","show_vote":"","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"fusion_item_subtext":"Awesome Stuff","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"87","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"164","splitmenu_item_subtext":"Awesome Stuff"}', 45, 164, 0, '*', 0),
(103, 'mainmenu', 'Module Positions', 'module-positions', '', 'features/module-positions', 'index.php?option=com_content&view=article&id=2', 'component', 1, 102, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 8, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"0","show_item_navigation":"","show_vote":"","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"138","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"138","splitmenu_item_subtext":""}', 46, 47, 0, '*', 0),
(104, 'mainmenu', 'Module Variations', 'module-variations', '', 'features/module-variations', 'index.php?option=com_content&view=article&id=3', 'component', 1, 102, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 9, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"0","show_item_navigation":"","show_vote":"","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"130","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"130","splitmenu_item_subtext":""}', 48, 49, 0, '*', 0),
(105, 'mainmenu', 'Typography', 'typography', '', 'features/typography', 'index.php?option=com_content&view=article&id=4', 'component', 1, 102, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"0","show_item_navigation":"","show_vote":"","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"138","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"138","splitmenu_item_subtext":""}', 50, 51, 0, '*', 0),
(106, 'mainmenu', 'Menu Options', 'menu-options', '', 'features/menu-options', 'index.php?option=com_content&view=article&id=5', 'component', 1, 102, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"0","show_item_navigation":"","show_vote":"","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"2","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"360","fusion_column_widths":"180,180","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"87","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"138","splitmenu_item_subtext":""}', 52, 157, 0, '*', 0),
(107, 'mainmenu', 'Extensions', 'extensions', '', 'features/extensions', 'index.php?option=com_content&view=article&id=6', 'component', 1, 102, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"0","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"0","show_item_navigation":"","show_vote":"","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"130","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"130","splitmenu_item_subtext":""}', 158, 159, 0, '*', 0),
(108, 'mainmenu', 'Tutorials', 'tutorials', '', 'tutorials', 'index.php?option=com_content&view=article&id=7', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"0","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"0","show_item_navigation":"","show_vote":"","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"fusion_item_subtext":"Theme Guides","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"87","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"164","splitmenu_item_subtext":"Theme Guides"}', 165, 174, 0, '*', 0),
(109, 'mainmenu', 'Installation', 'installation', '', 'tutorials/installation', 'index.php?option=com_content&view=article&id=8', 'component', 1, 108, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"0","show_item_navigation":"","show_vote":"","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"130","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"130","splitmenu_item_subtext":""}', 166, 167, 0, '*', 0),
(110, 'mainmenu', 'Logo Editing', 'logo-editing', '', 'tutorials/logo-editing', 'index.php?option=com_content&view=article&id=9', 'component', 1, 108, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"0","show_item_navigation":"","show_vote":"","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"130","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"130","splitmenu_item_subtext":""}', 168, 169, 0, '*', 0),
(111, 'mainmenu', 'Preset Styles', 'preset-styles', '', 'preset-styles', 'index.php?option=com_content&view=article&id=10', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"0","show_item_navigation":"","show_vote":"","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"fusion_item_subtext":"Choose a Variation","fusion_customimage":"","fusion_customclass":"","fusion_columns":"2","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"220","fusion_column_widths":"110,110","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"87","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"164","splitmenu_item_subtext":"Choose a Variation"}', 175, 196, 0, '*', 0),
(112, 'mainmenu', 'J! Stuff', 'j-stuff', '', 'j-stuff', 'index.php?option=com_content&view=article&id=11', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"fusion_item_subtext":"Joomla Style","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"87","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"164","splitmenu_item_subtext":"Joomla Style"}', 197, 206, 0, '*', 0),
(116, 'mainmenu', '404 Error Page', '2012-07-09-11-38-14', '', 'features/2012-07-09-11-38-14', '?option=404', 'url', 1, 102, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"87","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"164","splitmenu_item_subtext":""}', 160, 161, 0, '*', 0),
(117, 'mainmenu', 'Forum Guides', '2012-07-09-11-38-54', '', 'tutorials/2012-07-09-11-38-54', 'http://www.rockettheme.com/forum/index.php?f=653&rb_v=viewforum', 'url', 1, 108, 2, 0, 0, 0, '0000-00-00 00:00:00', 1, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"87","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"164","splitmenu_item_subtext":""}', 170, 171, 0, '*', 0),
(118, 'mainmenu', 'Gantry Framework', '2012-07-09-11-39-16', '', 'tutorials/2012-07-09-11-39-16', 'http://www.gantry-framework.org/documentation', 'url', 1, 108, 2, 0, 0, 0, '0000-00-00 00:00:00', 1, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"87","fusion_module_positions":"","splitmenu_item_subtext":""}', 172, 173, 0, '*', 0),
(119, 'mainmenu', 'More Details', '2012-07-09-11-39-53', '', 'features/2012-07-09-11-39-53', 'http://www.rockettheme.com/joomla-templates/kirigami', 'url', 1, 102, 2, 0, 0, 0, '0000-00-00 00:00:00', 1, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"87","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"132","splitmenu_item_subtext":""}', 162, 163, 0, '*', 0),
(120, 'mainmenu', 'Member Access', 'member-access', '', 'j-stuff/member-access', 'index.php?option=com_users&view=login', 'component', 1, 112, 2, 25, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"login_redirect_url":"","logindescription_show":"1","login_description":"The RocketTheme Joomla Template Club features exclusive access to professional Joomla templates to help transform your Joomla based site and set you apart from the competition. Complimentary access to to the new RocketTheme Extensions Club is provided for all RocketTheme Joomla Club members.","login_image":"","logout_redirect_url":"","logoutdescription_show":"1","logout_description":"","logout_image":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"87","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"132","splitmenu_item_subtext":""}', 198, 199, 0, '*', 0),
(121, 'mainmenu', 'Category Blog', 'category-blog', '', 'j-stuff/category-blog', 'index.php?option=com_content&view=category&layout=blog&id=9', 'component', 1, 112, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"","num_intro_articles":"","num_columns":"","num_links":"","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"87","fusion_module_positions":"","splitmenu_item_subtext":""}', 200, 201, 0, '*', 0),
(122, 'mainmenu', 'Web Links', 'web-links', '', 'j-stuff/web-links', 'index.php?option=com_weblinks&view=category&id=10', 'component', 1, 112, 2, 21, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_subcat_desc":"","show_cat_num_links":"","show_pagination_limit":"0","show_headings":"","show_link_description":"","show_link_hits":"","show_pagination":"","show_pagination_results":"","show_feed_link":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"87","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"132","splitmenu_item_subtext":""}', 202, 203, 0, '*', 0),
(123, 'mainmenu', 'Contact Us', 'contact-us', '', 'j-stuff/contact-us', 'index.php?option=com_contact&view=contact&id=1', 'component', 1, 112, 2, 8, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"presentation_style":"plain","show_contact_category":"","show_contact_list":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"0","show_image":"","allow_vcard":"","show_articles":"","show_links":"","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"0","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"87","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"132","splitmenu_item_subtext":""}', 204, 205, 0, '*', 0),
(124, 'mainmenu', 'Menu Examples', 'menu-examples', '', 'features/menu-options/menu-examples', 'index.php?Itemid=', 'alias', 1, 106, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"1","fusion_children_type":"menuitems","fusion_modules":"87","fusion_module_positions":"","splitmenu_item_subtext":""}', 53, 148, 0, '*', 0),
(125, 'mainmenu', 'Menu Types', 'menu-types', '', 'features/menu-options/menu-types', 'index.php?Itemid=', 'alias', 1, 106, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"1","fusion_children_type":"menuitems","fusion_modules":"87","fusion_module_positions":"","splitmenu_item_subtext":""}', 149, 156, 0, '*', 0),
(126, 'mainmenu', 'Child Items', 'child-items', '', 'features/menu-options/menu-examples/child-items', 'index.php?Itemid=', 'alias', 1, 124, 4, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"87","fusion_module_positions":"","splitmenu_item_subtext":""}', 54, 143, 0, '*', 0),
(127, 'mainmenu', 'Menu Icons', 'menu-icons', '', 'features/menu-options/menu-examples/menu-icons', 'index.php?Itemid=', 'alias', 1, 124, 4, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"icon-like.png","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"87","fusion_module_positions":"","splitmenu_item_subtext":""}', 144, 145, 0, '*', 0),
(128, 'mainmenu', 'Module Menu', 'module-menu', '', 'features/menu-options/menu-examples/module-menu', 'index.php?Itemid=', 'alias', 1, 124, 4, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"250","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"modulepos","fusion_modules":"87","fusion_module_positions":"menu-mod","splitmenu_item_subtext":""}', 146, 147, 0, '*', 0),
(129, 'mainmenu', 'Fusion Menu', '2012-07-09-11-55-42', '', 'features/menu-options/menu-types/2012-07-09-11-55-42', 'index.php?option=com_content&view=article&id=5&Itemid=106&menu-type=fusionmenu', 'url', 1, 125, 4, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"87","fusion_module_positions":"","splitmenu_item_subtext":""}', 150, 151, 0, '*', 0),
(130, 'mainmenu', 'Split Menu', '2012-07-09-11-55-43', '', 'features/menu-options/menu-types/2012-07-09-11-55-43', 'index.php?option=com_content&view=article&id=5&Itemid=106&menu-type=splitmenu', 'url', 1, 125, 4, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"87","fusion_module_positions":"","splitmenu_item_subtext":""}', 152, 153, 0, '*', 0),
(131, 'mainmenu', 'No Menu', '2012-07-09-11-55-44', '', 'features/menu-options/menu-types/2012-07-09-11-55-44', 'index.php?option=com_content&view=article&id=5&Itemid=106&menu-type=nomenu', 'url', 1, 125, 4, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"87","fusion_module_positions":"","splitmenu_item_subtext":""}', 154, 155, 0, '*', 0),
(132, 'mainmenu', 'Child Items', 'child-items-1', '', 'features/menu-options/menu-examples/child-items/child-items-1', 'index.php?Itemid=', 'alias', -2, 126, 5, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"Single Column Example","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"130","fusion_column_widths":"130","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"87","fusion_module_positions":"","splitmenu_item_subtext":""}', 55, 64, 0, '*', 0),
(133, 'mainmenu', 'Child Items', 'child-items-2', '', 'features/menu-options/menu-examples/child-items/child-items-2', 'index.php?Itemid=', 'alias', -2, 126, 5, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"Dual Column Example","fusion_customimage":"","fusion_customclass":"","fusion_columns":"2","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"260","fusion_column_widths":"130,130","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"87","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"132","splitmenu_item_subtext":""}', 65, 82, 0, '*', 0),
(134, 'mainmenu', 'Child Items', 'child-items-3', '', 'features/menu-options/menu-examples/child-items/child-items-3', 'index.php?Itemid=', 'alias', -2, 126, 5, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"Triple Column Example","fusion_customimage":"","fusion_customclass":"","fusion_columns":"4","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"360","fusion_column_widths":"120,120,120","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"87","fusion_module_positions":"","splitmenu_item_subtext":""}', 83, 108, 0, '*', 0),
(135, 'mainmenu', 'Child Items', 'child-items-4', '', 'features/menu-options/menu-examples/child-items/child-items-4', 'index.php?Itemid=', 'alias', -2, 126, 5, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"Single Column Example","fusion_customimage":"","fusion_customclass":"","fusion_columns":"4","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"480","fusion_column_widths":"120,120,120,120","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"87","fusion_module_positions":"","splitmenu_item_subtext":""}', 109, 142, 0, '*', 0),
(136, 'mainmenu', 'Child Item', 'child-item-1', '', 'features/menu-options/menu-examples/child-items/child-items-1/child-item-1', 'index.php?Itemid=', 'alias', -2, 132, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 56, 57, 0, '*', 0),
(137, 'mainmenu', 'Child Item', 'child-item-2', '', 'features/menu-options/menu-examples/child-items/child-items-1/child-item-2', 'index.php?Itemid=', 'alias', -2, 132, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 58, 59, 0, '*', 0),
(138, 'mainmenu', 'Child Item', 'child-item-3', '', 'features/menu-options/menu-examples/child-items/child-items-1/child-item-3', 'index.php?Itemid=', 'alias', -2, 132, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 60, 61, 0, '*', 0),
(139, 'mainmenu', 'Child Item', 'child-item-4', '', 'features/menu-options/menu-examples/child-items/child-items-1/child-item-4', 'index.php?Itemid=', 'alias', -2, 132, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 62, 63, 0, '*', 0),
(140, 'mainmenu', 'Child Item', 'child-item-1', '', 'features/menu-options/menu-examples/child-items/child-items-2/child-item-1', 'index.php?Itemid=', 'alias', -2, 133, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 66, 67, 0, '*', 0),
(141, 'mainmenu', 'Child Item', 'child-item-2', '', 'features/menu-options/menu-examples/child-items/child-items-2/child-item-2', 'index.php?Itemid=', 'alias', -2, 133, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 68, 69, 0, '*', 0),
(142, 'mainmenu', 'Child Item', 'child-item-3', '', 'features/menu-options/menu-examples/child-items/child-items-2/child-item-3', 'index.php?Itemid=', 'alias', -2, 133, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 70, 71, 0, '*', 0),
(143, 'mainmenu', 'Child Item', 'child-item-4', '', 'features/menu-options/menu-examples/child-items/child-items-2/child-item-4', 'index.php?Itemid=', 'alias', -2, 133, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 72, 73, 0, '*', 0),
(144, 'mainmenu', 'Child Item', 'child-item-5', '', 'features/menu-options/menu-examples/child-items/child-items-2/child-item-5', 'index.php?Itemid=', 'alias', -2, 133, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 74, 75, 0, '*', 0),
(145, 'mainmenu', 'Child Item', 'child-item-6', '', 'features/menu-options/menu-examples/child-items/child-items-2/child-item-6', 'index.php?Itemid=', 'alias', -2, 133, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 76, 77, 0, '*', 0),
(146, 'mainmenu', 'Child Item', 'child-item-7', '', 'features/menu-options/menu-examples/child-items/child-items-2/child-item-7', 'index.php?Itemid=', 'alias', -2, 133, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 78, 79, 0, '*', 0),
(147, 'mainmenu', 'Child Item', 'child-item-8', '', 'features/menu-options/menu-examples/child-items/child-items-2/child-item-8', 'index.php?Itemid=', 'alias', -2, 133, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 80, 81, 0, '*', 0),
(148, 'mainmenu', 'Child Item', 'child-item-1', '', 'features/menu-options/menu-examples/child-items/child-items-3/child-item-1', 'index.php?Itemid=', 'alias', -2, 134, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 84, 85, 0, '*', 0),
(149, 'mainmenu', 'Child Item', 'child-item-2', '', 'features/menu-options/menu-examples/child-items/child-items-3/child-item-2', 'index.php?Itemid=', 'alias', -2, 134, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 86, 87, 0, '*', 0),
(150, 'mainmenu', 'Child Item', 'child-item-3', '', 'features/menu-options/menu-examples/child-items/child-items-3/child-item-3', 'index.php?Itemid=', 'alias', -2, 134, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 88, 89, 0, '*', 0),
(151, 'mainmenu', 'Child Item', 'child-item-4', '', 'features/menu-options/menu-examples/child-items/child-items-3/child-item-4', 'index.php?Itemid=', 'alias', -2, 134, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 90, 91, 0, '*', 0),
(152, 'mainmenu', 'Child Item', 'child-item-5', '', 'features/menu-options/menu-examples/child-items/child-items-3/child-item-5', 'index.php?Itemid=', 'alias', -2, 134, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 92, 93, 0, '*', 0),
(153, 'mainmenu', 'Child Item', 'child-item-6', '', 'features/menu-options/menu-examples/child-items/child-items-3/child-item-6', 'index.php?Itemid=', 'alias', -2, 134, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 94, 95, 0, '*', 0);
INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `ordering`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES
(154, 'mainmenu', 'Child Item', 'child-item-7', '', 'features/menu-options/menu-examples/child-items/child-items-3/child-item-7', 'index.php?Itemid=', 'alias', -2, 134, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 96, 97, 0, '*', 0),
(155, 'mainmenu', 'Child Item', 'child-item-8', '', 'features/menu-options/menu-examples/child-items/child-items-3/child-item-8', 'index.php?Itemid=', 'alias', -2, 134, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 98, 99, 0, '*', 0),
(156, 'mainmenu', 'Child Item', 'child-item-9', '', 'features/menu-options/menu-examples/child-items/child-items-3/child-item-9', 'index.php?Itemid=', 'alias', -2, 134, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 100, 101, 0, '*', 0),
(157, 'mainmenu', 'Child Item', 'child-item-10', '', 'features/menu-options/menu-examples/child-items/child-items-3/child-item-10', 'index.php?Itemid=', 'alias', -2, 134, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 102, 103, 0, '*', 0),
(158, 'mainmenu', 'Child Item', 'child-item-11', '', 'features/menu-options/menu-examples/child-items/child-items-3/child-item-11', 'index.php?Itemid=', 'alias', -2, 134, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 104, 105, 0, '*', 0),
(159, 'mainmenu', 'Child Item', 'child-item-12', '', 'features/menu-options/menu-examples/child-items/child-items-3/child-item-12', 'index.php?Itemid=', 'alias', -2, 134, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 106, 107, 0, '*', 0),
(160, 'mainmenu', 'Child Item', 'child-item-1', '', 'features/menu-options/menu-examples/child-items/child-items-4/child-item-1', 'index.php?Itemid=', 'alias', -2, 135, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 110, 111, 0, '*', 0),
(161, 'mainmenu', 'Child Item', 'child-item-2', '', 'features/menu-options/menu-examples/child-items/child-items-4/child-item-2', 'index.php?Itemid=', 'alias', -2, 135, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 112, 113, 0, '*', 0),
(162, 'mainmenu', 'Child Item', 'child-item-3', '', 'features/menu-options/menu-examples/child-items/child-items-4/child-item-3', 'index.php?Itemid=', 'alias', -2, 135, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 114, 115, 0, '*', 0),
(163, 'mainmenu', 'Child Item', 'child-item-4', '', 'features/menu-options/menu-examples/child-items/child-items-4/child-item-4', 'index.php?Itemid=', 'alias', -2, 135, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 116, 117, 0, '*', 0),
(164, 'mainmenu', 'Child Item', 'child-item-5', '', 'features/menu-options/menu-examples/child-items/child-items-4/child-item-5', 'index.php?Itemid=', 'alias', -2, 135, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 118, 119, 0, '*', 0),
(165, 'mainmenu', 'Child Item', 'child-item-6', '', 'features/menu-options/menu-examples/child-items/child-items-4/child-item-6', 'index.php?Itemid=', 'alias', -2, 135, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 120, 121, 0, '*', 0),
(166, 'mainmenu', 'Child Item', 'child-item-7', '', 'features/menu-options/menu-examples/child-items/child-items-4/child-item-7', 'index.php?Itemid=', 'alias', -2, 135, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 122, 123, 0, '*', 0),
(167, 'mainmenu', 'Child Item', 'child-item-8', '', 'features/menu-options/menu-examples/child-items/child-items-4/child-item-8', 'index.php?Itemid=', 'alias', -2, 135, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 124, 125, 0, '*', 0),
(168, 'mainmenu', 'Child Item', 'child-item-9', '', 'features/menu-options/menu-examples/child-items/child-items-4/child-item-9', 'index.php?Itemid=', 'alias', -2, 135, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 126, 127, 0, '*', 0),
(169, 'mainmenu', 'Child Item', 'child-item-10', '', 'features/menu-options/menu-examples/child-items/child-items-4/child-item-10', 'index.php?Itemid=', 'alias', -2, 135, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 128, 129, 0, '*', 0),
(170, 'mainmenu', 'Child Item', 'child-item-11', '', 'features/menu-options/menu-examples/child-items/child-items-4/child-item-11', 'index.php?Itemid=', 'alias', -2, 135, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 130, 131, 0, '*', 0),
(171, 'mainmenu', 'Child Item', 'child-item-12', '', 'features/menu-options/menu-examples/child-items/child-items-4/child-item-12', 'index.php?Itemid=', 'alias', -2, 135, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 132, 133, 0, '*', 0),
(172, 'mainmenu', 'Child Item', 'child-item-13', '', 'features/menu-options/menu-examples/child-items/child-items-4/child-item-13', 'index.php?Itemid=', 'alias', -2, 135, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 134, 135, 0, '*', 0),
(173, 'mainmenu', 'Child Item', 'child-item-14', '', 'features/menu-options/menu-examples/child-items/child-items-4/child-item-14', 'index.php?Itemid=', 'alias', -2, 135, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 136, 137, 0, '*', 0),
(174, 'mainmenu', 'Child Item', 'child-item-15', '', 'features/menu-options/menu-examples/child-items/child-items-4/child-item-15', 'index.php?Itemid=', 'alias', -2, 135, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 138, 139, 0, '*', 0),
(175, 'mainmenu', 'Child Item', 'child-item-16', '', 'features/menu-options/menu-examples/child-items/child-items-4/child-item-16', 'index.php?Itemid=', 'alias', -2, 135, 6, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"148","fusion_module_positions":"","splitmenu_item_subtext":""}', 140, 141, 0, '*', 0),
(177, 'main', 'RokCandy', 'rokcandy', '', 'rokcandy', 'index.php?option=com_rokcandy', 'component', 0, 1, 1, 838, 0, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_rokcandy/assets/rokcandy-icon-16.png', 0, '', 207, 212, 0, '', 1),
(178, 'main', 'Macros', 'macros', '', 'rokcandy/macros', 'index.php?option=com_rokcandy', 'component', 0, 177, 2, 838, 0, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_rokcandy/assets/rokcandy-icon-16.png', 0, '', 208, 209, 0, '', 1),
(179, 'main', 'Categories', 'categories', '', 'rokcandy/categories', 'index.php?option=com_categories&extension=com_rokcandy', 'component', 0, 177, 2, 838, 0, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_rokcandy/assets/icon-16-category.png', 0, '', 210, 211, 0, '', 1),
(181, 'main', 'RokGallery', 'rokgallery', '', 'rokgallery', 'index.php?option=com_rokgallery', 'component', 0, 1, 1, 817, 0, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_rokgallery/assets/images/rokgallery_16x16.png', 0, '', 213, 214, 0, '', 1),
(184, 'copyrightmenu', 'Features', 'template-features', '', 'template-features', 'index.php?Itemid=', 'alias', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"102","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"134","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"134","splitmenu_item_subtext":""}', 215, 216, 0, '*', 0),
(185, 'copyrightmenu', 'Extensions', 'template-extensions', '', 'template-extensions', 'index.php?Itemid=', 'alias', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"107","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"134","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"134","splitmenu_item_subtext":""}', 217, 218, 0, '*', 0),
(186, 'copyrightmenu', 'MegaMenu', 'megamenu', '', 'megamenu', 'index.php?Itemid=', 'alias', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"106","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"134","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"134","splitmenu_item_subtext":""}', 219, 220, 0, '*', 0),
(187, 'copyrightmenu', 'Variations', 'template-variations', '', 'template-variations', 'index.php?Itemid=', 'alias', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"111","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"134","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"134","splitmenu_item_subtext":""}', 221, 222, 0, '*', 0),
(188, 'mainmenu', 'Preset 1', '2012-07-25-20-47-57', '', 'preset-styles/2012-07-25-20-47-57', '?presets=preset1', 'url', 1, 111, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"164","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"164","splitmenu_item_subtext":""}', 176, 177, 0, '*', 0),
(189, 'mainmenu', 'Preset 2', '2012-07-25-20-47-58', '', 'preset-styles/2012-07-25-20-47-58', '?presets=preset2', 'url', 1, 111, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"164","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"164","splitmenu_item_subtext":""}', 178, 179, 0, '*', 0),
(190, 'mainmenu', 'Preset 3', '2012-07-25-20-47-59', '', 'preset-styles/2012-07-25-20-47-59', '?presets=preset3', 'url', 1, 111, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"164","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"164","splitmenu_item_subtext":""}', 180, 181, 0, '*', 0),
(191, 'mainmenu', 'Preset 4', '2012-07-25-20-47-60', '', 'preset-styles/2012-07-25-20-47-60', '?presets=preset4', 'url', 1, 111, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"164","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"164","splitmenu_item_subtext":""}', 182, 183, 0, '*', 0),
(192, 'mainmenu', 'Preset 5', '2012-07-25-20-47-61', '', 'preset-styles/2012-07-25-20-47-61', '?presets=preset5', 'url', 1, 111, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"164","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"164","splitmenu_item_subtext":""}', 184, 185, 0, '*', 0),
(193, 'mainmenu', 'Preset 6', '2012-07-25-20-47-62', '', 'preset-styles/2012-07-25-20-47-62', '?presets=preset6', 'url', 1, 111, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"164","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"164","splitmenu_item_subtext":""}', 186, 187, 0, '*', 0),
(194, 'mainmenu', 'Preset 7', '2012-07-25-20-47-63', '', 'preset-styles/2012-07-25-20-47-63', '?presets=preset7', 'url', 1, 111, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"164","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"164","splitmenu_item_subtext":""}', 188, 189, 0, '*', 0),
(195, 'mainmenu', 'Preset 8', '2012-07-25-20-47-64', '', 'preset-styles/2012-07-25-20-47-64', '?presets=preset8', 'url', 1, 111, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"164","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"164","splitmenu_item_subtext":""}', 190, 191, 0, '*', 0),
(196, 'mainmenu', 'Preset 9', '2012-07-25-20-47-65', '', 'preset-styles/2012-07-25-20-47-65', '?presets=preset9', 'url', 1, 111, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"164","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"164","splitmenu_item_subtext":""}', 192, 193, 0, '*', 0),
(197, 'mainmenu', 'Preset 10', '2012-07-25-20-47-66', '', 'preset-styles/2012-07-25-20-47-66', '?presets=preset10', 'url', 1, 111, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"164","fusion_module_positions":"","splitmenu_menu_entry_type":"normal","splitmenu_menu_module":"164","splitmenu_item_subtext":""}', 194, 195, 0, '*', 0);

-- --------------------------------------------------------

--
-- Table structure for table `#__menu_types`
--

DROP TABLE IF EXISTS `#__menu_types`;
CREATE TABLE IF NOT EXISTS `#__menu_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL,
  `title` varchar(48) NOT NULL,
  `description` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_menutype` (`menutype`)
);

--
-- Dumping data for table `#__menu_types`
--

INSERT INTO `#__menu_types` (`id`, `menutype`, `title`, `description`) VALUES
(1, 'mainmenu', 'Main Menu', 'The main menu for the site'),
(2, 'copyrightmenu', 'Copyright Menu', 'Copyright Menu');

-- --------------------------------------------------------

--
-- Table structure for table `#__messages`
--

DROP TABLE IF EXISTS `#__messages`;
CREATE TABLE IF NOT EXISTS `#__messages` (
  `message_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id_from` int(10) unsigned NOT NULL DEFAULT '0',
  `user_id_to` int(10) unsigned NOT NULL DEFAULT '0',
  `folder_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `date_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `priority` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(255) NOT NULL DEFAULT '',
  `message` text NOT NULL,
  PRIMARY KEY (`message_id`),
  KEY `useridto_state` (`user_id_to`,`state`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__messages_cfg`
--

DROP TABLE IF EXISTS `#__messages_cfg`;
CREATE TABLE IF NOT EXISTS `#__messages_cfg` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `cfg_name` varchar(100) NOT NULL DEFAULT '',
  `cfg_value` varchar(255) NOT NULL DEFAULT '',
  UNIQUE KEY `idx_user_var_name` (`user_id`,`cfg_name`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__modules`
--

DROP TABLE IF EXISTS `#__modules`;
CREATE TABLE IF NOT EXISTS `#__modules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `content` text NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `position` varchar(50) NOT NULL DEFAULT '',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `module` varchar(50) DEFAULT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `showtitle` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `published` (`published`,`access`),
  KEY `newsfeeds` (`module`,`published`),
  KEY `idx_language` (`language`)
);

--
-- Dumping data for table `#__modules`
--

INSERT INTO `#__modules` (`id`, `title`, `note`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `published`, `module`, `access`, `showtitle`, `params`, `client_id`, `language`) VALUES
(2, 'Login', '', '', 1, 'login', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_login', 1, 1, '', 1, '*'),
(3, 'Popular Articles', '', '', 3, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_popular', 3, 1, '{"count":"5","catid":"","user_id":"0","layout":"_:default","moduleclass_sfx":"","cache":"0","automatic_title":"1"}', 1, '*'),
(4, 'Recently Added Articles', '', '', 4, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_latest', 3, 1, '{"count":"5","ordering":"c_dsc","catid":"","user_id":"0","layout":"_:default","moduleclass_sfx":"","cache":"0","automatic_title":"1"}', 1, '*'),
(8, 'Toolbar', '', '', 1, 'toolbar', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_toolbar', 3, 1, '', 1, '*'),
(9, 'Quick Icons', '', '', 1, 'icon', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_quickicon', 3, 1, '', 1, '*'),
(10, 'Logged-in Users', '', '', 2, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_logged', 3, 1, '{"count":"5","name":"1","layout":"_:default","moduleclass_sfx":"","cache":"0","automatic_title":"1"}', 1, '*'),
(12, 'Admin Menu', '', '', 1, 'menu', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 3, 1, '{"layout":"","moduleclass_sfx":"","shownew":"1","showhelp":"1","cache":"0"}', 1, '*'),
(13, 'Admin Submenu', '', '', 1, 'submenu', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_submenu', 3, 1, '', 1, '*'),
(14, 'User Status', '', '', 2, 'status', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_status', 3, 1, '', 1, '*'),
(15, 'Title', '', '', 1, 'title', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_title', 3, 1, '', 1, '*'),
(79, 'Multilanguage status', '', '', 1, 'status', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_multilangstatus', 3, 1, '{"layout":"_:default","moduleclass_sfx":"","cache":"0"}', 1, '*'),
(86, 'Joomla Version', '', '', 1, 'footer', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_version', 3, 1, '{"format":"short","product":"1","layout":"_:default","moduleclass_sfx":"","cache":"0"}', 1, '*'),
(87, 'Module in Menu', '', '<p>This is an example of a module being displayed inside the menu <strong>dropdowns</strong>.</p>\r\n<p><a href="#" class="readon"><span>Read More</span></a></p>', 1, 'menu-mod ', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(88, 'Footer - Features', '', '<div class="rt-demo-block rt-demo-width-70">\r\n  <div class="rt-demo-spacer">\r\n    <h3>All the Features - in One Complete List</h3>\r\n    <h4 class="nomargintop">Kirigami Template</h4>\r\n    \r\n    <div class="rt-demo-block rt-demo-width-50">\r\n      <div class="rt-demo-spacer">\r\n        <ul class="circle">\r\n          <li>10 Preset Styles</li>\r\n          <li>78 Module Positions</li>\r\n          <li>Powered by Gantry</li>\r\n          <li>Fusion with MegaMenu</li>\r\n          <li>SplitMenu</li>\r\n          <li>Custom Typography</li>\r\n        </ul>\r\n      </div>\r\n    </div>\r\n    \r\n    <div class="rt-demo-block rt-demo-width-50">\r\n      <div class="rt-demo-spacer">\r\n        <ul class="circle">\r\n          <li>RokSprocket Styling</li>\r\n          <li>RokExtensions Styling</li>\r\n          <li>Gantry Framework</li>\r\n          <li>RTL Layout Support</li>\r\n          <li>Major Browsers Support</li>\r\n          <li>W3C XHTML1.0 / CSS3 Valid</li>\r\n        </ul>\r\n      </div>\r\n    </div>\r\n    \r\n    <div class="clear"></div>\r\n    \r\n    <h4 class="nomargintop">Gantry Framework</h4>\r\n\r\n    <div class="rt-demo-block rt-demo-width-50">\r\n      <div class="rt-demo-spacer">\r\n        <ul class="circle">\r\n          <li>CSS Grid Framework</li>\r\n          <li>Stunning Admin Interface</li>\r\n          <li>Source Ordered Mainbody</li>\r\n          <li>Extensive Administrator Interface</li>\r\n          <li>Image Smart Loading</li>\r\n        </ul>\r\n      </div>\r\n    </div>\r\n    \r\n    <div class="rt-demo-block rt-demo-width-50">\r\n      <div class="rt-demo-spacer">\r\n        <ul class="circle">\r\n          <li>Versatile Layout</li>\r\n          <li>Grid RTL Support</li>\r\n          <li>Built-in GZip and General Caching</li>\r\n          <li>Google Web Fonts Support</li>   \r\n          <li>Per Browser based CSS / JS control</li>\r\n        </ul>\r\n      </div>\r\n    </div>\r\n    \r\n    <div class="clear"></div>\r\n  </div>\r\n</div>\r\n\r\n\r\n<div class="rt-demo-block rt-demo-width-30">\r\n  <div class="rt-demo-spacer">\r\n    <h3>System Requirements</h3>\r\n    <ul class="checkmark">\r\n      <li><strong>Apache 2.x or Microsoft IIS 7</strong><br />\r\n        <em>Most widely deployed web server software which is required to run Joomla!</em></li>\r\n      <li><strong>PHP 5.3.x</strong><br />\r\n        <em>General-purpose server-side scripting language designed for web development.</em></li>\r\n      <li><strong>MySQL 5.0.4 or higher</strong><br />\r\n        <em>The most popular open-source database system that providing databases.</em></li>\r\n      <li><strong>Joomla! 2.5.x</strong><br />\r\n        <em>Please download the latest version of Joomla! at <a class="normalfont nobold" href="http://www.joomla.org" target="_blank">Joomla! Official Site</a>.</em></li>\r\n      <li><strong>Gantry Framework</strong><br />\r\n        <em>Please ensure you are using the latest version of <a class="normalfont nobold" href="http://www.gantry-framework.org" target="_blank">Gantry Framework</a>.</em></li>\r\n      <li><strong>RokNavMenu Module</strong><br />\r\n        <em>Essential ingredient of <a class="normalfont nobold" href="index.php?option=com_content&amp;view=article&amp;id=5&amp;Itemid=112">powerful menu</a> system of RocketTheme templates.</em></li>\r\n    </ul>\r\n  <div class="clear"></div>\r\n  </div>\r\n</div>\r\n', 1, 'footer-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(90, 'Gantry Grid Distribution', '', '<p>Configure at <strong>Admin &rarr; Extensions &rarr; Template Manager &rarr; rt_kirigami</strong>, then go to <strong>Layouts</strong> to set the grid widths and allocated positions.</p>\r\n\r\n<div class="rt-image">\r\n  <img src="images/rocketlauncher/module-positions/grid-distribution.jpg" alt="image" />\r\n</div>\r\n', 1, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(91, 'Injected Gantry Features', '', '<div class="rt-image">\r\n  <img alt="Non-Standard Elements" src="images/rocketlauncher/module-positions/injected-features.jpg" />\r\n</div>\r\n\r\n<div class="clear largemarginbottom">&nbsp;</div>\r\n\r\n<p class="nomarginbottom">There are <strong>Features</strong> that are injected into a position when enabled, and are stacked vertically; which includes: Logo, Date, Font Sizer, Login Panel, Popup Module, Branding, Copyright, More Articles.</p>', 1, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(92, 'MainBody/Sidebar Layouts', '', '<p>Configure at <strong>Admin &rarr; Extensions &rarr; Template Manager &rarr; rt_kirigami</strong>, then go to <strong>Layouts</strong> tab and set the varying Mainbody/Sidebar layout possibilities.</p>\r\n\r\n<div class="rt-demo-block rt-demo-width-33">\r\n  <div class="rt-demo-spacer">\r\n    <div class="rt-image">\r\n      <img src="images/rocketlauncher/module-positions/position-config-mb1.jpg" alt="image"/>\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-33">\r\n  <div class="rt-demo-spacer">\r\n    <div class="rt-image">\r\n      <img src="images/rocketlauncher/module-positions/position-config-mb2.jpg" alt="image"/>\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-33">\r\n  <div class="rt-demo-spacer">\r\n    <div class="rt-image">\r\n      <img src="images/rocketlauncher/module-positions/position-config-mb3.jpg" alt="image"/>\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<div class="clear"></div><br />\r\n\r\n<p class="attention">Note: If no modules are assigned to the Sidebar positions, the Mainbody will become full width.</p>\r\n\r\n<div class="rt-image">\r\n  <img alt="Module Positions" src="images/rocketlauncher/module-positions/gantry-layout.jpg" />\r\n</div>\r\n', 1, 'mainbottom-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(93, 'Basic: Using Layouts', '', '<div class="rt-demo-block rt-demo-width-25">\r\n  <div class="rt-demo-spacer">\r\n    <a rel="rokbox[745 505]" title="Video Tutorial :: Using Gantry Layouts" href="http://www.gantry-framework.org/media/videos/module_widths.mov">\r\n      <span class="rt-image">\r\n        <img src="images/rocketlauncher/module-positions/using-layouts.jpg" alt="Using Layouts" />\r\n      </span>\r\n    </a>\r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-75">\r\n  <div class="rt-demo-spacer">\r\n    <p>To find out about <strong>Gantry Layouts</strong> and <strong>Module Widths</strong>, check out this screencast which covers basic concepts of configuring layout with a combination of module setting and the Gantry layout control.</p>\r\n\r\n    <a class="readon smallmargintop" href="http://www.gantry-framework.org/documentation/joomla/configure/layouts" target="_blank"><span>View : Using Gantry Layouts</span></a>\r\n  </div>    \r\n</div>', 1, 'footer-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(94, 'Advanced: Adding Positions', '', '<div class="rt-demo-block rt-demo-width-25">\r\n  <div class="rt-demo-spacer">\r\n    <a rel="rokbox[745 505]" title="Video Tutorial :: Module Positions" href="http://www.gantry-framework.org/media/videos/module_positions.mov">\r\n      <span class="rt-image">\r\n      <img src="images/rocketlauncher/module-positions/adding-module-positions.jpg" alt="Using Layouts" />\r\n      </span>  \r\n    </a>\r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-75">\r\n  <div class="rt-demo-spacer">\r\n    <p>Check out this quick screencast on <strong>Module Positions</strong> to get an overview of how module positions work within Gantry Framework. Click below button to learn how to <strong>add a new row of module positions</strong>.</p>\r\n\r\n    <a class="readon smallmargintop" href="http://www.gantry-framework.org/documentation/joomla/customize/adding-module-positions" target="_blank"><span>Learn : Adding Positions</span></a>\r\n  </div>    \r\n</div>\r\n', 1, 'footer-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(95, 'Standard Variations: 25 Additional Module Class Suffixes', '', '<div class="rt-demo-grid-4 nomarginleft">\r\n  <ul class="nomarginbottom nomarginleft">\r\n    <li><strong>rt-center:</strong> centres the content of the module.</li>\r\n    <li><strong>shadow2-10</strong> adds varying shadows around the module.</li>\r\n    <li><strong>square and basic:</strong> changes the border style of the module.</li>\r\n  </ul>\r\n</div>\r\n\r\n<div class="rt-demo-grid-4">\r\n  <ul class="nomarginbottom nomarginleft nomarginright">\r\n    <li><strong>standardcase, uppercase, lowercase:</strong> change the case of the module title.</li>  \r\n    <li><strong>nomargintop, nomarginright, nomarginbottom, nomarginleft, nomarginall:</strong> removes the various margins around the module.</li>\r\n  </ul>\r\n</div>\r\n\r\n<div class="rt-demo-grid-4 nomarginright">\r\n  <ul class="nomarginbottom nomarginright">\r\n    <li><strong>nopaddingtop, nopaddingright, nopaddingbottom, nopaddingleft, nopaddingall:</strong> removes the various paddings around the module</li>\r\n  </ul>\r\n</div>', 1, 'footer-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(96, 'Why Use RokCandy', '', '<p><strong>RokCandy</strong> is the ideal solution for those with <strong>limited coding skills</strong> or those who implement our templates for their clients.</p>\r\n\r\n<p>It is <strong>free</strong> from the WYSIWYG editors horrific filtering habits and can be easily pre-configured for your <strong>personal needs</strong> or the needs of your client.</p>\r\n\r\n<a href="http://www.rockettheme.com/extensions-joomla/rokcandy" class="readon" target="_blank"><span>Download : RokCandy</span></a>', 1, 'footer-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(97, 'Video : Using Typography', '', '<div class="rt-demo-block rt-demo-width-25">\r\n  <div class="rt-demo-spacer">\r\n    <a href="http://www.rockettheme.com/video/joomla15/using-typography-joomla15.mov" title="Video Tutorial :: Joomla Using Typography Video Tutorial" rel="rokbox[540 380]">\r\n      <span class="rt-image">\r\n        <img src="images/rocketlauncher/typography/using-typography.jpg" alt="Using Typography" />\r\n      </span>\r\n    </a>\r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-75">\r\n  <div class="rt-demo-spacer">\r\n    <p>Check out this quick screencast to learn how to use RokCandy to enhance your Joomla! content. The tags are very easy to learn and this guide shows you how to use all the styles.</p>\r\n    <a href="http://www.rockettheme.com/video/joomla15/using-typography-joomla15.mov" title="Video Tutorial :: Joomla Using Typography Video Tutorial" rel="rokbox[540 380]" class="readon"><span>Watch : Using Typography</span></a>\r\n  </div>    \r\n</div>', 1, 'footer-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(98, 'Set Menu Type', '', '<div class="rt-demo-block rt-demo-width-50">\r\n  <div class="rt-demo-spacer">\r\n    <p>To find all the parameters for FusionMenu &amp; SplitMenu on Kirigami template, such as transitions, duration &amp; sublevel position, please navigate to:</p>\r\n    \r\n    <ul class="dots">\r\n      <li><strong>Extensions &rarr; Template Manager &rarr; rt_kirigami</strong></li>\r\n      <li>Then go to <strong>Menu</strong> tab, and set the Menu parameters</li>\r\n    </ul>\r\n    \r\n    <p class="largemargintop attention">Descriptions of each template parameter can be seen when you mouseover the label of each option.</p>\r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-50">\r\n  <div class="rt-demo-spacer">\r\n    <div class="rt-image">\r\n      <img src="images/rocketlauncher/menu-options/menu-setting.jpg" alt="Set Menu" />\r\n    </div>\r\n  </div>\r\n</div>\r\n', 1, 'maintop-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(99, 'Fusion Menu', '', '<p>A Mootools enhanced CSS dropdown menu, with multi-columns, icons and more.</p>\r\n<a href="index.php?option=com_content&amp;view=article&amp;id=5&amp;Itemid=106&amp;menu-type=fusionmenu" class="readon"><span>FusionMenu</span></a>', 1, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"hidden-phone","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(100, 'Split Menu', '', '<p>A static menu system that displays 1st level and 2nd level items in the main horizontal menu and all children in the Sidebar.</p>\r\n<a href="index.php?option=com_content&amp;view=article&amp;id=5&amp;Itemid=106&amp;menu-type=splitmenu" class="readon"><span>SplitMenu</span></a>', 1, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"hidden-phone","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(101, 'No Menu', '', '<p>An option to disable the menu, allowing for normal module use of the navigation position.</p>', 1, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"hidden-phone","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(102, 'SubText Line', '', '<p>The option that allows you to insert additional text to the Menu Item Title. There is separate styling for this, making it useful for adding brief descriptions to menu items.</p>\r\n', 1, 'footer-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"hidden-phone","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(103, 'Menu Item Image', '', '<p>RokNavMenu provides the option to display a small icon image for the menu item. The menu icon can be displayed both for the parent items and the child items.</p>\r\n', 1, 'footer-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"hidden-phone","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(104, 'Multiple Columns', '', '<p>Who needs a single dropdown column when you can have as many as you want? Using the built-in configurable parameters, you can make incredible multi column dropdowns.</p>\r\n', 1, 'footer-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(105, 'Footer - Extensions', '', '<div class="rt-demo-block rt-demo-width-70">\r\n  <div class="rt-demo-spacer">\r\n    <h3>All RocketTheme Extensions</h3>\r\n    <p>Many of our extensions were developed to accompany RocketTheme templates but we have now created versions that are intended to work independently of our templates if you wish.</p>\r\n\r\n    <h4>Club Extensions</h4>\r\n    \r\n    <div class="rt-demo-block rt-demo-width-33">\r\n      <div class="rt-demo-spacer">\r\n        <ul class="circle">\r\n          <li><a href="http://www.rockettheme.com/extensions-joomla/rokgallery" target="_blank">RokGallery</a></li>\r\n          <li><a href="http://www.rockettheme.com/extensions-joomla/rokstock" target="_blank">RokStock</a></li>\r\n          <li><a href="http://www.rockettheme.com/extensions-joomla/rokpad" target="_blank">RokPad</a></li>     \r\n        </ul>\r\n      </div>\r\n    </div>\r\n    \r\n    <div class="rt-demo-block rt-demo-width-33">\r\n      <div class="rt-demo-spacer">\r\n        <ul class="circle">  \r\n          <li><a href="http://www.rockettheme.com/extensions-joomla/rokminievents" target="_blank">RokMiniEvents</a></li>\r\n          <li><a href="http://www.rockettheme.com/extensions-joomla/rokweather" target="_blank">RokWeather</a></li>\r\n        </ul>\r\n      </div>\r\n    </div>\r\n\r\n    <div class="rt-demo-block rt-demo-width-33">\r\n      <div class="rt-demo-spacer">\r\n        <ul class="circle">\r\n          <li><a href="http://www.rockettheme.com/extensions-joomla/roktwittie" target="_blank">RokTwittie</a></li>\r\n          <li><a href="http://www.rockettheme.com/extensions-joomla/rokfeaturetable" target="_blank">RokFeatureTable</a></li>\r\n        </ul>  \r\n      </div>\r\n    </div>    \r\n    \r\n    <div class="clear"></div>\r\n    \r\n    <h4 class="nomargintop">Free Extensions</h4>\r\n\r\n    <div class="rt-demo-block rt-demo-width-33">\r\n      <div class="rt-demo-spacer">\r\n        <ul class="circle">\r\n          <li><a href="http://www.rockettheme.com/extensions-joomla/roksprocket" target="_blank">RokSprocket</a></li>\r\n          <li><a href="http://www.rockettheme.com/extensions-joomla/rokbox" target="_blank">RokBox</a></li>\r\n          <li><a href="http://www.rockettheme.com/extensions-joomla/rokbooster" target="_blank">RokBooster</a></li>\r\n        </ul>\r\n      </div>\r\n    </div>   \r\n\r\n    <div class="rt-demo-block rt-demo-width-33">\r\n      <div class="rt-demo-spacer">\r\n        <ul class="circle">\r\n          <li><a href="http://www.rockettheme.com/extensions-joomla/roknavmenu" target="_blank">RokNavMenu</a></li>\r\n          <li><a href="http://www.rockettheme.com/extensions-joomla/rokquickcart" target="_blank">RokQuickCart</a></li>\r\n          <li><a href="http://www.rockettheme.com/extensions-joomla/rokcandy" target="_blank">RokCandy</a></li>\r\n        </ul>\r\n      </div>\r\n    </div>   \r\n\r\n    <div class="rt-demo-block rt-demo-width-33">\r\n      <div class="rt-demo-spacer">\r\n        <ul class="circle">\r\n          <li><a href="http://www.rockettheme.com/extensions-joomla/rokajaxsearch" target="_blank">RokAjaxSearch</a></li>      \r\n          <li><a href="http://www.rockettheme.com/extensions-joomla/rokcomments" target="_blank">RokComments</a></li>\r\n        </ul>  \r\n      </div>\r\n    </div>            \r\n\r\n    <div class="clear"></div>\r\n  </div>\r\n</div>\r\n\r\n\r\n<div class="rt-demo-block rt-demo-width-30">\r\n  <div class="rt-demo-spacer">\r\n    <p class="notice">RokSprocket has been designed to replace our existing ‘content’ modules, including RokStories, RokTabs, RokNewsPager, RokNewsflash and any other module that manipulates &amp; displays articles.</p>\r\n    \r\n    <p>You can download the extensions from:</p>\r\n    \r\n    <ul class="normalfont nomarginbottom checkmark">\r\n      <li><strong>Kirigami Download Page:</strong><br /><strong>rt_kirigami-extensions.zip</strong> for J2.5. Unzip the file, it contains all the extensions used for Kirigami template.</li>\r\n      <li class="nomarginbottom"><strong>RocketTheme Extensions Page:</strong><br />Contains all individual extensions are available from the Extensions section of RokDownloads.</li>\r\n    </ul>\r\n    \r\n    <a href="http://www.rockettheme.com/extensions-downloads/" target="_blank" class="readon largemargintop"><span>Download : Kirigami Extensions</span></a>\r\n  <div class="clear"></div>\r\n  </div>\r\n</div>\r\n', 1, 'footer-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(106, 'Installation Process', '', '<p>Download and install the <strong>Bundle</strong> file if Gantry is not installed, use the Standard Template file if <a href="index.php?option=com_content&amp;view=article&amp;id=8&amp;Itemid=109">Gantry</a> is already present.</p>\r\n<a href="index.php?option=com_content&amp;view=article&amp;id=8&amp;Itemid=109" class="readon"><span>More Information</span></a>', 1, 'showcase-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(107, 'Demo Replica', '', '<p>You may deploy a <a href="index.php?option=com_content&amp;view=article&amp;id=8&amp;Itemid=109">replica</a> of this month''s demo with ease, using the readily available <strong>RocketLauncher</strong> package.</p><a href="index.php?option=com_content&amp;view=article&amp;id=8&amp;Itemid=109" class="readon"><span>More Information</span></a>', 1, 'showcase-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(108, 'RocketTheme Help', '', '<p>RocketTheme provides tutorials of template installation, RocketLauncher, and RocketTheme templates related topics.</p>\r\n<a href="http://www.rockettheme.com/joomla-tutorials" class="readon" target="_blank"><span>Read More</span></a>', 1, 'footer-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(109, 'Gantry Support', '', '<p>More extensive details of the Gantry Framework, inclusive of both written and video tutorials, please visit Gantry Site.</p>\r\n<a href="http://www.gantry-framework.org/" target="_blank" class="readon"><span>Learn More</span></a>', 1, 'footer-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(110, 'Requirements', '', '<ul class="checkmark nomarginbottom">\r\n  <li><strong>Apache 2.x or Microsoft IIS 7</strong></li>\r\n  <li><strong>PHP 5.3.x</strong></li>\r\n  <li><strong>MySQL 5.0.4 or higher</strong></li>\r\n  <li><strong>Joomla! 2.5.x</strong></li> \r\n  <li><strong>Gantry Framework</strong></li>\r\n  <li class="nomarginbottom"><strong>RokNavMenu Module</strong></li>\r\n</ul>', 1, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(111, 'RocketLauncher', '', '<p class="medmarginbottom"><strong>RocketLauncher</strong> is a customized <strong>Joomla</strong> install, that installs a <strong>replica</strong> of the <strong>demo</strong>.</p>\r\n<p class="alert nomarginbottom"><strong>Note</strong>: All sample content images will be replaced with blank versions in the RocketLauncher.</p>', 1, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(112, 'Essential Files', '', '<ul class="list-icon checkmark normalfont nomarginbottom">\r\n  <li><strong>Gantry Framework</strong> - Download the latest version of Gantry Framework from <a href="" target="_blank">http://www.gantry-framework.org/</a> for update</li>\r\n  <li><strong>Template (Standalone)</strong> <em>rt_kirigami.zip</em> - Standalone template file without the Gantry Framework (If Gantry is already installed)</li>\r\n  <li><strong>Template (Bundle)</strong> <em>rt_kirigami-bundle.zip</em> - Template plus the Gantry Framework (If Gantry is not installed)</li>\r\n  <li><strong>RokNavMenu</strong> <em>rt_kirigami-extensions.zip(<strong>unzip first</strong>) and find mod_roknavmenu.zip</em> - Required for the menu to work</li>\r\n</ul>', 1, 'footer-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(113, 'Additional Files', '', '<ul class="list-icon checkmark normalfont nomarginbottom">\r\n  <li><strong>Source PNG(s)</strong> <em>rt_kirigami-sources.zip</em> - Adobe® Fireworks PNG source file(s) and any applicable fonts</li>\r\n  <li><strong>Source BG PNG(s)</strong> <em>rt_kirigami-sources-bg.zip</em> - Adobe® Fireworks PNG BG source file(s) — <em>Only distributed if the template has complex BGs</em></li>\r\n  <li><strong>Extensions</strong> <em>rt_kirigami-extensions.zip</em> - All extensions used for the template (Unzip first to find the individual extension)</li>\r\n  <li><strong>RocketLauncher</strong> <em>rt_kirigami-rocketlauncher.zip</em> - Demo replica installer. RocketLauncher needs a fresh Joomla! installation</li>\r\n</ul>', 1, 'footer-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(114, '10 Preset Styles - Preview Live', '', '<p class="notice">View all styles live by appending <strong>?presets=preset#</strong> or <strong>&amp;presets=preset#</strong> to the end of your URL such as <strong><a href="#">http://yoursite.com/index.php?presets=preset4</a></strong>.</p>\r\n\r\n<p>In sequential order, <strong>Preset 1 - Preset 10</strong>. Please click on the image to load a live example of each style variation.</p>\r\n\r\n<div class="rt-demo-block rt-demo-width-20">\r\n  <div class="rt-demo-spacer">\r\n    <a href="index.php?option=com_content&amp;view=article&amp;id=10&amp;Itemid=111&amp;presets=preset1">\r\n      <span class="rt-image">\r\n        <img alt="Preset 1" src="images/rocketlauncher/styles/ss1.jpg" />\r\n      </span>\r\n    </a>\r\n  </div>\r\n</div>\r\n<div class="rt-demo-block rt-demo-width-20">\r\n  <div class="rt-demo-spacer">\r\n    <a href="index.php?option=com_content&amp;view=article&amp;id=10&amp;Itemid=111&amp;presets=preset2">\r\n      <span class="rt-image">\r\n        <img alt="Preset 2" src="images/rocketlauncher/styles/ss2.jpg" />\r\n      </span>\r\n    </a>\r\n  </div>\r\n</div>\r\n<div class="rt-demo-block rt-demo-width-20">\r\n  <div class="rt-demo-spacer">\r\n    <a href="index.php?option=com_content&amp;view=article&amp;id=10&amp;Itemid=111&amp;presets=preset3">\r\n      <span class="rt-image">\r\n        <img alt="Preset 3" src="images/rocketlauncher/styles/ss3.jpg" />\r\n      </span>\r\n    </a>\r\n  </div>\r\n</div>\r\n<div class="rt-demo-block rt-demo-width-20">\r\n  <div class="rt-demo-spacer">\r\n    <a href="index.php?option=com_content&amp;view=article&amp;id=10&amp;Itemid=111&amp;presets=preset4">\r\n      <span class="rt-image">\r\n        <img alt="Preset 4" src="images/rocketlauncher/styles/ss4.jpg" />\r\n      </span>\r\n    </a>\r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-20">\r\n  <div class="rt-demo-spacer">\r\n    <a href="index.php?option=com_content&amp;view=article&amp;id=10&amp;Itemid=111&amp;presets=preset5">\r\n      <span class="rt-image">\r\n        <img alt="Preset 5" src="images/rocketlauncher/styles/ss5.jpg" />\r\n      </span>\r\n    </a>\r\n  </div>\r\n</div>\r\n<div class="rt-demo-block rt-demo-width-20">\r\n  <div class="rt-demo-spacer">\r\n    <a href="index.php?option=com_content&amp;view=article&amp;id=10&amp;Itemid=111&amp;presets=preset6">\r\n      <span class="rt-image">\r\n        <img alt="Preset 6" src="images/rocketlauncher/styles/ss6.jpg" />\r\n      </span>\r\n    </a>\r\n  </div>\r\n</div>\r\n<div class="rt-demo-block rt-demo-width-20">\r\n  <div class="rt-demo-spacer">\r\n    <a href="index.php?option=com_content&amp;view=article&amp;id=10&amp;Itemid=111&amp;presets=preset7">\r\n      <span class="rt-image">\r\n        <img alt="Preset 7" src="images/rocketlauncher/styles/ss7.jpg" />\r\n      </span>\r\n    </a>\r\n  </div>\r\n</div>\r\n<div class="rt-demo-block rt-demo-width-20">\r\n  <div class="rt-demo-spacer">\r\n    <a href="index.php?option=com_content&amp;view=article&amp;id=10&amp;Itemid=111&amp;presets=preset8">\r\n      <span class="rt-image">\r\n        <img alt="Preset 8" src="images/rocketlauncher/styles/ss8.jpg" />\r\n      </span>\r\n    </a>\r\n  </div>\r\n</div>\r\n<div class="rt-demo-block rt-demo-width-20">\r\n  <div class="rt-demo-spacer">\r\n    <a href="index.php?option=com_content&amp;view=article&amp;id=10&amp;Itemid=111&amp;presets=preset9">\r\n      <span class="rt-image">\r\n        <img alt="Preset 7" src="images/rocketlauncher/styles/ss9.jpg" />\r\n      </span>\r\n    </a>\r\n  </div>\r\n</div>\r\n<div class="rt-demo-block rt-demo-width-20">\r\n  <div class="rt-demo-spacer">\r\n    <a href="index.php?option=com_content&amp;view=article&amp;id=10&amp;Itemid=111&amp;presets=preset10">\r\n      <span class="rt-image">\r\n        <img alt="Preset 8" src="images/rocketlauncher/styles/ss10.jpg" />\r\n      </span>\r\n    </a>\r\n  </div>\r\n</div>\r\n\r\n<div class="clear"></div>\r\n', 1, 'showcase-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(115, 'Creating Custom Preset Style(s)', '', '<ul class="circle-large">\r\n  <li>Go to <strong>Extensions &rarr; Template Manager &rarr; rt_kirigami &rarr; Show Presets</strong></li>\r\n  <li>Configure the Settings</li>\r\n  <li>Click <strong>Save Preset</strong></li>\r\n  <li>Follow the <strong>Preset Saver procedure</strong></li>\r\n</ul>\r\n\r\n<p class="notice">You can edit the prebuilt presets in the <strong>gantry.config.php</strong> file, or use the User Interface method outlined above.</p>', 1, 'footer-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(116, 'Preset Footer B', '', '<br /><br />\r\n\r\n<div class="rt-demo-block rt-demo-width-50">\r\n	<div class="rt-demo-spacer">\r\n		<div class="rt-image">\r\n		  <img alt="image" src="images/rocketlauncher/styles/style-1.jpg" />\r\n		</div>\r\n	</div>\r\n</div>\r\n<div class="rt-demo-block rt-demo-width-50">\r\n	<div class="rt-demo-spacer">\r\n		<div class="rt-image">\r\n  			<img alt="image" src="images/rocketlauncher/styles/style-2.jpg" />\r\n		</div>\r\n	</div>\r\n</div>\r\n', 1, 'footer-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(117, 'Joomla Guides', '', '<p>Joomla.org is an invaluable resource for general instructions and information on how to use, configure and modify Joomla.</p>\r\n<a href="http://docs.joomla.org" class="readon" target="_blank"><span>Read More</span></a>', 1, 'footer-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(118, 'Video Docs', '', '<ul class="dots">\r\n  <li><a class="nobold" href="http://www.rockettheme.com/video/joomla15/installing-rocketlauncher-joomla15.mov" title="Video Tutorial :: Joomla RocketLauncher Installation Video Tutorial" rel="rokbox[503 356]">RocketLauncher</a></li>\r\n  <li><a class="nobold" href="http://www.rockettheme.com/video/joomla15/menu-configuration-joomla15.mov" title="Video Tutorial :: Joomla Menu Setup Video Tutorial" rel="rokbox[504 336]">Menu Setup</a></li>\r\n  <li><a class="nobold" href="http://www.gantry-framework.org/media/videos/module_widths.mov" title="Video Tutorial :: Using Layouts" rel="rokbox[745 505]">Using Gantry Layout</a></li>\r\n  <li><a class="nobold" href="http://www.rockettheme.com/video/joomla15/using-typography-joomla15.mov" title="Video Tutorial :: Joomla Using Typography Video Tutorial" rel="rokbox[540 380]">Using Typography</a></li>  \r\n  <li><a class="nobold" rel="rokbox[504 360]" title="Video Tutorial :: Joomla 1.5 Template Management" href="http://www.rockettheme.com/video/joomla15/template-manager-joomla15.mov">Template Manager</a></li>\r\n  <li><a class="nobold" rel="rokbox[504 336]" title="Video Tutorial :: Joomla 1.5 Using Custom Modules" href="http://www.rockettheme.com/video/joomla15/custom-modules-joomla15.mov">Custom Modules</a></li>\r\n  <li><a class="nobold" rel="rokbox[504 336]" title="Video Tutorial :: Joomla 1.5 Using the Extensions Manager" href="http://www.rockettheme.com/video/joomla15/extensions-manager-joomla15.mov">Extensions Manager</a></li>\r\n  <li><a class="nobold" rel="rokbox[504 336](joomla15basic)" title="Video Tutorial :: Joomla 1.5 Menu Access Levels" href="http://www.rockettheme.com/video/joomla15/menu-access-levels-joomla15.mov">Menu Access</a></li>\r\n</ul>\r\n<a href="http://www.rockettheme.com/joomla-tutorials/video-tutorials" target="_blank" class="readon largemargintop smallmarginbottom"><span>View All</span></a>', 18, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"hidden-phone","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(119, 'Forum Guides', '', '<ul class="dots">\r\n  <li><a class="nobold" href="http://www.rockettheme.com/forum/index.php?f=654&amp;t=172030&amp;rb_v=viewtopic" target="_blank">Editing the Logo</a></li>\r\n  <li><a class="nobold" href="http://www.rockettheme.com/forum/index.php?f=654&amp;t=172031&amp;rb_v=viewtopic" target="_blank">Template Text</a></li>\r\n  <li><a class="nobold" href="http://www.rockettheme.com/forum/index.php?f=654&amp;t=172032&amp;rb_v=viewtopic" target="_blank">RokBox Login</a></li>\r\n  <li><a class="nobold" href="http://www.rockettheme.com/forum/index.php?f=654&amp;t=172033&amp;rb_v=viewtopic" target="_blank">Popup Module</a></li>\r\n  <li><a class="nobold" href="http://www.rockettheme.com/forum/index.php?f=654&amp;t=172034&amp;rb_v=viewtopic" target="_blank">Template Guide</a></li>\r\n  <li><a class="nobold" href="http://www.rockettheme.com/forum/index.php?f=654&amp;t=172035&amp;rb_v=viewtopic" target="_blank">Template FAQs</a></li>\r\n  <li><a class="nobold" href="http://www.rockettheme.com/forum/index.php?f=654&amp;t=172036&amp;rb_v=viewtopic" target="_blank">Responsive Classes</a></li>\r\n  <li><a class="nobold" href="http://www.rockettheme.com/forum/index.php?f=654&amp;t=172037&amp;rb_v=viewtopic" target="_blank">Demo Content</a></li>\r\n</ul>\r\n<a class="readon largemargintop smallmarginbottom" target="_blank" href="http://www.rockettheme.com/forum/index.php?f=654&amp;rb_v=viewforum"><span>View All</span></a>', 5, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"hidden-phone","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(120, 'Video Documentation', '', '<div class="rt-demo-block rt-demo-width-50">\r\n	<div class="rt-demo-spacer">\r\n		<ul class="dots">\r\n		  <li><a class="nobold" href="http://www.rockettheme.com/video/joomla15/installing-rocketlauncher-joomla15.mov" title="Video Tutorial :: Joomla RocketLauncher Installation Video Tutorial" rel="rokbox[503 356]">RocketLauncher</a></li>\r\n		  <li><a class="nobold" href="http://www.rockettheme.com/video/joomla15/menu-configuration-joomla15.mov" title="Video Tutorial :: Joomla Menu Setup Video Tutorial" rel="rokbox[504 336]">Menu Setup</a></li>\r\n		  <li><a class="nobold" href="http://www.gantry-framework.org/media/videos/module_widths.mov" title="Video Tutorial :: Using Layouts" rel="rokbox[745 505]">Using Gantry Layout</a></li>\r\n		  <li><a class="nobold" href="http://www.rockettheme.com/video/joomla15/using-typography-joomla15.mov" title="Video Tutorial :: Joomla Using Typography Video Tutorial" rel="rokbox[540 380]">Using Typography</a></li>  \r\n		</ul>		\r\n	</div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-50">\r\n	<div class="rt-demo-spacer">\r\n		<ul>\r\n		  <li><a class="nobold" rel="rokbox[504 360]" title="Video Tutorial :: Joomla 1.5 Template Management" href="http://www.rockettheme.com/video/joomla15/template-manager-joomla15.mov">Template Manager</a></li>\r\n		  <li><a class="nobold" rel="rokbox[504 336]" title="Video Tutorial :: Joomla 1.5 Using Custom Modules" href="http://www.rockettheme.com/video/joomla15/custom-modules-joomla15.mov">Custom Modules</a></li>\r\n		  <li><a class="nobold" rel="rokbox[504 336]" title="Video Tutorial :: Joomla 1.5 Using the Extensions Manager" href="http://www.rockettheme.com/video/joomla15/extensions-manager-joomla15.mov">Extensions Manager</a></li>\r\n		  <li><a class="nobold" rel="rokbox[504 336](joomla15basic)" title="Video Tutorial :: Joomla 1.5 Menu Access Levels" href="http://www.rockettheme.com/video/joomla15/menu-access-levels-joomla15.mov">Menu Access</a></li>\r\n		</ul>		\r\n	</div>\r\n</div>\r\n\r\n<div class="clear"></div>\r\n\r\n<a href="http://www.rockettheme.com/joomla-tutorials/video-tutorials" target="_blank" class="readon largemargintop smallmarginbottom"><span>View All</span></a>', 1, 'content-bottom-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(121, 'Using a Suffix', '', '<p>Enter any available suffixes at <strong>Extensions &rarr; Module Manager &rarr; <em>Module</em> &rarr; Module Class Suffix</strong>.</p>\r\n<p class="notice nomarginbottom">You can compound multiple suffixes together such as: <strong><em>box1 title3</em></strong>.</p>', 1, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(122, 'box3 title4', '', '<p>An example module using the <strong>box1 title4</strong> module class suffix.</p>\r\n<p>Lorem ipsum dolor sit amet, consecetur adipiscing elit. Donec sit amet nibh.</p>\r\n<a href="#" class="readon"><span>More</span></a>', 1, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"box1 title4","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(123, 'box2 title2', '', '<p>An example module using the <strong>box2 title2</strong> module class suffix.</p>\r\n<p>Lorem ipsum dolor sit amet, consecetur adipiscing elit. Donec sit amet nibh.</p>\r\n<a href="#" class="readon"><span>More</span></a>', 1, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"box2 title2","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(124, 'box4 title3', '', '<p>An example module using the <strong>box4 title3</strong> module class suffix.</p>\r\n<p>Lorem ipsum dolor sit amet, consecetur adipiscing elit. Donec sit amet nibh.</p>\r\n<a href="#" class="readon"><span>More</span></a>', 1, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"box4 title3","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(125, 'Demo Information', '', '<p><strong>NOTE:</strong> All demo content is for <strong>sample</strong> purposes only, intended to show a live site. All images are licensed from <a target="_blank" href="http://www.shutterstock.com"><strong>ShutterStock</strong></a> for  exclusive use on this <strong>demo</strong> site only.</p>\r\n\r\n<p><img src="images/rocketlauncher/frontpage/general/logo-footer.png" alt="image" /></p>\r\n\r\n<p class="nomarginbottom">t: +1 (888) 123-4567</p>\r\n\r\n<p>e: kirigami@<span>no-contact.com</span></p>\r\n', 1, 'footer-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(126, 'Inside Kirigami', '', '<div class="smallmarginbottom"><a href="index.php?option=com_content&amp;view=article&amp;id=1&amp;Itemid=102"><em class="bold">Features</em></a></div>\r\n<div class="smallmarginbottom"><a href="index.php?option=com_content&amp;view=article&amp;id=2&amp;Itemid=103"><em class="bold">Module Positions</em></a></div>\r\n<div class="smallmarginbottom"><a href="index.php?option=com_content&amp;view=article&amp;id=3&amp;Itemid=104"><em class="bold">Module Variations</em></a></div>', 1, 'footer-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"hidden-phone","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(127, 'Contact Details', '', '<img class="rt-floatleft" alt="image" src="images/rocketlauncher/frontpage/general/fp-footer-icon1.png" />\r\n<a href="#"><em class="bold">+1 (555) 555-555-5555</em></a><br />\r\n<a href="#"><em class="bold nobold">+1 (555) 555-555-5556</em></a>\r\n\r\n<div class="clear largemarginbottom">&nbsp;</div>\r\n\r\n<img class="rt-floatleft" alt="image" src="images/rocketlauncher/frontpage/general/fp-footer-icon2.png" />\r\n<em class="bold">\r\n  <strong>Kirigami Template LLC</strong><br />\r\n</em>\r\n<em class="bold nobold">\r\n  123 Joomla! Boulevard<br />\r\n  Seattle, WA 00000<br />\r\n  United States of America\r\n</em>\r\n\r\n<div class="clear largemarginbottom">&nbsp;</div>\r\n\r\n<img class="rt-floatleft" alt="image" src="images/rocketlauncher/frontpage/general/fp-footer-icon3.png" />\r\n<em class="bold">noreply@domain.com</em>', 1, 'footer-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"hidden-phone","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(136, 'RocketTheme', '', '<div>\r\n  <h4 class="nomarginbottom">Joomla Templates Club</h4>\r\n  <p>Best known template club in JoomlaSphere</p>\r\n</div>\r\n\r\n<div>\r\n  <h4 class="nomarginbottom">Wordpress Themes Club</h4>\r\n  <p>Provides a stunningly unique blog design</p>\r\n</div>\r\n\r\n<div>\r\n  <h4 class="nomarginbottom">Magento Templates Club</h4>\r\n  <p>eCommerce template platform for growth</p>\r\n</div>  \r\n\r\n<div>\r\n  <h4 class="nomarginbottom">phpBB3 Styles Club</h4>\r\n  <p>Transform phpBB3 into a professional forum</p>\r\n</div>  \r\n\r\n<a href="https://www.rockettheme.com/join-a-club" class="readon"><span>Join Now</span></a>\r\n', 1, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(139, 'title1', '', '<p>An example module using the <strong>title1</strong> module class suffix.</p>\r\n\r\n<p>Lorem ipsum dolor sit amet, consecetur adipiscing elit. Donec sit amet nibh.</p>', 1, 'content-bottom-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"title1","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(140, 'title3', '', '<p>An example module using the <strong>title3</strong> module class suffix.</p>\r\n\r\n<p>Lorem ipsum dolor sit amet, consecetur adipiscing elit. Donec sit amet nibh.</p>', 1, 'content-bottom-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"title3","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*');
INSERT INTO `#__modules` (`id`, `title`, `note`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `published`, `module`, `access`, `showtitle`, `params`, `client_id`, `language`) VALUES
(141, 'box1', '', '<p>An example module using the <strong>box1</strong> module class suffix.</p>\r\n\r\n<p>Lorem ipsum dolor sit amet, consecetur adipiscing elit. Donec sit amet nibh.</p>', 1, 'content-bottom-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"box1","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(142, 'box3', '', '<p>An example module using the <strong>box3</strong> module class suffix.</p>\r\n\r\n<p>Lorem ipsum dolor sit amet, consecetur adipiscing elit. Donec sit amet nibh.</p>', 1, 'content-bottom-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"box3","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(144, 'title2', '', '<p>An example module using the <strong>title2</strong> module class suffix.</p>\r\n\r\n<p>Lorem ipsum dolor sit amet, consecetur adipiscing elit. Donec sit amet nibh.</p>', 1, 'content-bottom-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"title2","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(145, 'title4', '', '<p>An example module using the <strong>title4</strong> module class suffix.</p>\r\n\r\n<p class="medmarginbottom">Lorem ipsum dolor sit amet, consecetur adipiscing elit. Donec sit amet nibh. Lorem ipsum dolor sit amet<span class="hidden-tablet">, consecetur adipiscing elit.</span> <span class="rt-extra-desc">Donec sit amet nibh.</span></p>', 1, 'content-bottom-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"title4","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(146, 'box2', '', '<p>An example module using the <strong>box2</strong> module class suffix.</p>\r\n\r\n<p>Lorem ipsum dolor sit amet, consecetur adipiscing elit. Donec sit amet nibh.</p>', 1, 'content-bottom-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"box2","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(147, 'box4', '', '<p>An example module using the <strong>box4</strong> module class suffix.</p>\r\n\r\n<p>Lorem ipsum dolor sit amet, consecetur adipiscing elit. Donec sit amet nibh.</p>', 1, 'content-bottom-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"box4","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(148, 'basic', '', '<p>An example module using the <strong>basic</strong> module class suffix.</p>\r\n\r\n<p>Lorem ipsum dolor sit amet, consecetur adipiscing elit. Donec sit amet nibh.</p>', 1, 'content-bottom-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"basic","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(154, 'FP Feature', '', '<span class="promo1 ribbon"><span>Kirigami is clean, flexible &amp; responsive</span></span>', 1, 'feature-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"rt-center","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(155, 'FP Showcase - RokSprocket Features', '', '', 1, 'showcase-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_roksprocket', 1, 0, '{"provider":"joomla","layout":"features","joomla_articles":{"1":{"root":{"article":"6"}},"2":{"root":{"article":"1"}},"3":{"root":{"article":"10"}}},"joomla_sort":"manual","joomla_sort_manual_append":"after","tabs_themes":"default","mosaic_themes":"default","headlines_themes":"default","lists_themes":"default","display_limit":"\\u221e","lists_enable_accordion":"1","tabs_position":"top","headlines_label_text":"","features_themes":"showcase","lists_previews_length":"20","features_show_title":"1","tabs_animation":"slideandfade","headlines_previews_length":"20","lists_strip_html_tags":"1","tabs_autoplay":"0","lists_items_per_page":"5","features_show_article_text":"1","headlines_show_arrows":"show","mosaic_columns":"3","features_previews_length":"\\u221e","features_strip_html_tags":"0","mosaic_previews_length":"20","headlines_animation":"slideandfade","tabs_autoplay_delay":"5","features_show_arrows":"show","lists_show_arrows":"show","mosaic_strip_html_tags":"1","features_show_pagination":"1","mosaic_items_per_page":"5","headlines_autoplay":"0","lists_show_pagination":"1","tabs_resize_enable":"0","tabs_resize_width":"0","tabs_resize_height":"0","features_animation":"crossfade","lists_autoplay":"0","tabs_previews_length":"0","mosaic_article_details":"0","headlines_autoplay_delay":"5","features_autoplay":"0","lists_autoplay_delay":"5","tabs_strip_html_tags":"0","mosaic_animations":["fade","scale","rotate"],"headlines_resize_enable":"0","headlines_resize_width":"0","headlines_resize_height":"0","mosaic_ordering":["default","title","date","random"],"features_autoplay_delay":"5","lists_resize_enable":"0","lists_resize_width":"0","lists_resize_height":"0","features_resize_enable":"0","features_resize_width":"0","features_resize_height":"0","headlines_description_default":"primary","headlines_image_default":"primary","tabs_title_default":"title","features_title_default":"title","lists_title_default":"title","features_description_default":"primary","headlines_image_default_custom":"","tabs_icon_default":"primary","lists_image_default":"primary","lists_description_default":"primary","features_image_default":"primary","lists_image_default_custom":"","tabs_icon_default_custom":"","headlines_link_default":"primary","features_image_default_custom":"","lists_link_default":"primary","headlines_link_default_custom":"","tabs_link_default":"primary","lists_link_default_custom":"","tabs_link_default_custom":"","features_link_default":"primary","features_link_default_custom":"","mosaic_resize_enable":"0","mosaic_resize_width":"0","mosaic_resize_height":"0","mosaic_title_default":"title","tabs_description_default":"primary","mosaic_description_default":"primary","mosaic_image_default":"primary","mosaic_image_default_custom":"","mosaic_link_default":"primary","mosaic_link_default_custom":"","cache":"0","moduleclass_sfx":"","module_cache":"1","cache_time":"900"}', 0, '*'),
(157, 'Popular Features', '', '', 1, 'content-bottom-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_roksprocket', 1, 1, '{"provider":"joomla","layout":"tabs","joomla_filters":{"1":{"root":{"category":"12"}}},"joomla_sort":"automatic","joomla_sort_manual_append":"after","tabs_themes":"default","mosaic_themes":"default","headlines_themes":"default","lists_themes":"default","display_limit":"\\u221e","lists_enable_accordion":"1","tabs_position":"top","headlines_label_text":"","features_themes":"slideshow","lists_previews_length":"20","features_show_title":"1","tabs_animation":"slideandfade","headlines_previews_length":"20","lists_strip_html_tags":"1","tabs_autoplay":"0","lists_items_per_page":"5","features_show_article_text":"1","headlines_show_arrows":"show","mosaic_columns":"3","features_previews_length":"\\u221e","features_strip_html_tags":"1","mosaic_previews_length":"20","headlines_animation":"slideandfade","tabs_autoplay_delay":"5","features_show_arrows":"show","lists_show_arrows":"show","mosaic_strip_html_tags":"1","features_show_pagination":"1","mosaic_items_per_page":"5","headlines_autoplay":"0","lists_show_pagination":"1","tabs_resize_enable":"0","tabs_resize_width":"0","tabs_resize_height":"0","features_animation":"crossfade","lists_autoplay":"0","tabs_previews_length":"\\u221e","mosaic_article_details":"0","headlines_autoplay_delay":"5","features_autoplay":"1","lists_autoplay_delay":"5","tabs_strip_html_tags":"0","mosaic_animations":["fade","scale","rotate"],"headlines_resize_enable":"0","headlines_resize_width":"0","headlines_resize_height":"0","mosaic_ordering":["default","title","date","random"],"features_autoplay_delay":"5","lists_resize_enable":"0","lists_resize_width":"0","lists_resize_height":"0","features_resize_enable":"0","features_resize_width":"0","features_resize_height":"0","headlines_description_default":"primary","headlines_image_default":"primary","tabs_title_default":"title","features_title_default":"title","lists_title_default":"title","features_description_default":"primary","headlines_image_default_custom":"","tabs_icon_default":"primary","lists_image_default":"primary","lists_description_default":"primary","features_image_default":"primary","lists_image_default_custom":"","tabs_icon_default_custom":"","headlines_link_default":"primary","features_image_default_custom":"","lists_link_default":"primary","headlines_link_default_custom":"","tabs_link_default":"none","lists_link_default_custom":"","tabs_link_default_custom":"","features_link_default":"primary","features_link_default_custom":"","mosaic_resize_enable":"0","mosaic_resize_width":"0","mosaic_resize_height":"0","mosaic_title_default":"title","tabs_description_default":"primary","mosaic_description_default":"primary","mosaic_image_default":"primary","mosaic_image_default_custom":"","mosaic_link_default":"primary","mosaic_link_default_custom":"","cache":"0","moduleclass_sfx":"basic title5 blockfill","module_cache":"1","cache_time":"900"}', 0, '*'),
(158, 'FP MainTop - RokSprocket Mosaic', '', '', 1, 'maintop-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_roksprocket', 1, 0, '{"provider":"joomla","layout":"mosaic","joomla_filters":{"1":{"root":{"category":"13"}}},"joomla_sort":"manual","joomla_sort_manual_append":"after","tabs_themes":"default","mosaic_themes":"default","headlines_themes":"default","lists_themes":"default","display_limit":"\\u221e","lists_enable_accordion":"1","tabs_position":"top","headlines_label_text":"","features_themes":"slideshow","lists_previews_length":"20","features_show_title":"1","tabs_animation":"slideandfade","headlines_previews_length":"20","lists_strip_html_tags":"1","tabs_autoplay":"0","lists_items_per_page":"5","features_show_article_text":"1","headlines_show_arrows":"show","mosaic_columns":"4","features_previews_length":"\\u221e","features_strip_html_tags":"1","mosaic_previews_length":"100","headlines_animation":"slideandfade","tabs_autoplay_delay":"5","features_show_arrows":"show","lists_show_arrows":"show","mosaic_strip_html_tags":"1","features_show_pagination":"1","mosaic_items_per_page":"8","headlines_autoplay":"0","lists_show_pagination":"1","tabs_resize_enable":"0","tabs_resize_width":"0","tabs_resize_height":"0","features_animation":"crossfade","lists_autoplay":"0","tabs_previews_length":"\\u221e","mosaic_article_details":"0","headlines_autoplay_delay":"5","features_autoplay":"1","lists_autoplay_delay":"5","tabs_strip_html_tags":"1","mosaic_animations":["fade","scale","rotate"],"headlines_resize_enable":"0","headlines_resize_width":"0","headlines_resize_height":"0","mosaic_ordering":["default","title","date","random"],"features_autoplay_delay":"5","lists_resize_enable":"0","lists_resize_width":"0","lists_resize_height":"0","features_resize_enable":"0","features_resize_width":"0","features_resize_height":"0","headlines_description_default":"primary","headlines_image_default":"primary","tabs_title_default":"title","features_title_default":"title","lists_title_default":"title","features_description_default":"primary","headlines_image_default_custom":"","tabs_icon_default":"primary","lists_image_default":"primary","lists_description_default":"primary","features_image_default":"primary","lists_image_default_custom":"","tabs_icon_default_custom":"","headlines_link_default":"primary","features_image_default_custom":"","lists_link_default":"primary","headlines_link_default_custom":"","tabs_link_default":"primary","lists_link_default_custom":"","tabs_link_default_custom":"","features_link_default":"primary","features_link_default_custom":"","mosaic_resize_enable":"0","mosaic_resize_width":"0","mosaic_resize_height":"0","mosaic_title_default":"title","tabs_description_default":"primary","mosaic_description_default":"primary","mosaic_image_default":"primary","mosaic_image_default_custom":"","mosaic_link_default":"custom","mosaic_link_default_custom":"index.php?option=com_content&view=article&id=1&Itemid=102","cache":"0","moduleclass_sfx":"basic","module_cache":"1","cache_time":"900"}', 0, '*'),
(159, 'Gantry Extras', '', '', 10, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_roksprocket', 1, 1, '{"provider":"joomla","layout":"lists","joomla_filters":{"1":{"root":{"category":"14"}}},"joomla_sort":"manual","joomla_sort_manual_append":"after","tabs_themes":"default","mosaic_themes":"default","headlines_themes":"default","lists_themes":"default","display_limit":"\\u221e","lists_enable_accordion":"1","tabs_position":"top","headlines_label_text":"","features_themes":"slideshow","lists_previews_length":"20","features_show_title":"1","tabs_animation":"slideandfade","headlines_previews_length":"20","lists_strip_html_tags":"1","tabs_autoplay":"0","lists_items_per_page":"4","features_show_article_text":"1","headlines_show_arrows":"show","mosaic_columns":"3","features_previews_length":"\\u221e","features_strip_html_tags":"1","mosaic_previews_length":"20","headlines_animation":"slideandfade","tabs_autoplay_delay":"5","features_show_arrows":"show","lists_show_arrows":"show","mosaic_strip_html_tags":"1","features_show_pagination":"1","mosaic_items_per_page":"5","headlines_autoplay":"0","lists_show_pagination":"1","tabs_resize_enable":"0","tabs_resize_width":"0","tabs_resize_height":"0","features_animation":"crossfade","lists_autoplay":"0","tabs_previews_length":"0","mosaic_article_details":"0","headlines_autoplay_delay":"5","features_autoplay":"1","lists_autoplay_delay":"5","tabs_strip_html_tags":"0","mosaic_animations":["fade","scale","rotate"],"headlines_resize_enable":"0","headlines_resize_width":"0","headlines_resize_height":"0","mosaic_ordering":["default","title","date","random"],"features_autoplay_delay":"5","lists_resize_enable":"0","lists_resize_width":"0","lists_resize_height":"0","features_resize_enable":"0","features_resize_width":"0","features_resize_height":"0","headlines_description_default":"primary","headlines_image_default":"primary","tabs_title_default":"title","features_title_default":"title","lists_title_default":"title","features_description_default":"primary","headlines_image_default_custom":"","tabs_icon_default":"primary","lists_image_default":"primary","lists_description_default":"primary","features_image_default":"primary","lists_image_default_custom":"","tabs_icon_default_custom":"","headlines_link_default":"primary","features_image_default_custom":"","lists_link_default":"custom","headlines_link_default_custom":"","tabs_link_default":"primary","lists_link_default_custom":"index.php?option=com_content&view=article&id=1&Itemid=102","tabs_link_default_custom":"","features_link_default":"primary","features_link_default_custom":"","mosaic_resize_enable":"0","mosaic_resize_width":"0","mosaic_resize_height":"0","mosaic_title_default":"title","tabs_description_default":"primary","mosaic_description_default":"primary","mosaic_image_default":"primary","mosaic_image_default_custom":"","mosaic_link_default":"primary","mosaic_link_default_custom":"","cache":"0","moduleclass_sfx":"","module_cache":"1","cache_time":"900"}', 0, '*'),
(161, 'Demo Replica', '', '<p class="medmarginbottom hidden-tablet"><strong>RocketLauncher</strong> is a customized <strong>Joomla</strong> install, that installs a <strong>replica</strong> of the <strong>demo</strong>.</p>\r\n\r\n<p>All sample content images, shown in this demo, will be replaced with blanks in the <a href="index.php?option=com_content&amp;view=article&amp;id=8&amp;Itemid=109"><strong>Kirigami RocketLauncher</strong></a> package to avoid any copyright issue.</p>\r\n\r\n<a class="readon" href="index.php?option=com_content&amp;view=article&amp;id=8&amp;Itemid=109"><span>Download</span></a>', 10, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"basictitle box1 hidden-phone","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(164, 'Breadcrumbs', '', '', 1, 'breadcrumb', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_breadcrumbs', 1, 0, '{"showHere":"1","showHome":"1","homeText":"","showLast":"1","separator":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(165, 'Member Access', '', '', 20, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_login', 1, 1, '{"pretext":"","posttext":"","login":"","logout":"","greeting":"1","name":"0","usesecure":"0","layout":"_:default","moduleclass_sfx":"hidden-phone","cache":"0"}', 0, '*'),
(166, 'Who''s Online', '', '', 20, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_whosonline', 1, 1, '{"showmode":"0","layout":"_:default","moduleclass_sfx":"basictitle box1 hidden-phone hidden-tablet","cache":"0","filter_groups":"0"}', 0, '*'),
(167, 'Setup and Configuration', '', '<p>An overview of template files and instructions for installing &amp; configuring Kirigami template.</p>\r\n<a class="readon" href="index.php?option=com_content&amp;view=article&amp;id=8&amp;Itemid=109"><span>Read More</span></a>', 1, 'content-top-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(168, 'Logo Editing', '', '<p>An overview for customizing your logo with your organization or company name and logo.</p>\r\n<a class="readon" href="index.php?option=com_content&amp;view=article&amp;id=9&amp;Itemid=110"><span>Read More</span></a>', 1, 'content-top-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(169, 'Copyright Menu', '', '', 1, 'copyright-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 0, '{"menutype":"copyrightmenu","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"horizmenu nomarginall","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(170, 'Help Desk', '', '<div class="smallmarginbottom"><a href="index.php?option=com_content&amp;view=article&amp;id=7&amp;Itemid=108"><em class="bold">Tutorials &amp; Guides</em></a></div>\r\n<div class="smallmarginbottom"><a href="http://www.rockettheme.com/forum/index.php?f=653&amp;rb_v=viewforum"><em class="bold">Forum Support</em></a></div>', 1, 'footer-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"nopaddingtop hidden-phone","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(171, 'Main Menu', '', '', 1, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 1, '{"menutype":"mainmenu","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"hidden-phone","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(172, 'Feature A - Features', '', '<span class="promo1 ribbon"><span>Kirigami, August 2012 Template</span></span>', 1, 'feature-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"rt-center","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(173, 'basictitle', '', '<p>An example module using the <strong>basictitle</strong> module class suffix.</p>\r\n\r\n<p>Lorem ipsum dolor sit amet, consecetur adipiscing elit. Donec sit amet nibh.</p>', 1, 'content-bottom-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"basictitle","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(174, 'Showcase A - Features', '', '<div class="rt-center largemargintop largemarginbottom">\r\n  <span class="promo2"><strong>Responsive</strong> Layout</span><br />\r\n  <span class="promo3">A responsive design automatically adapts itself to a particular viewing environment such as desktop, tablet or mobile, without the need for separate layouts for varying platforms</span>\r\n</div>\r\n\r\n<div class="rt-image rt-center largemargintop largemarginbottom">\r\n  <img alt="image" src="images/rocketlauncher/features/responsive.png" />\r\n</div>\r\n\r\n<div class="clear"></div>\r\n\r\n<div class="rt-demo-block rt-demo-width-33">\r\n	<div class="rt-demo-spacer">\r\n		<h4 class="smallmarginbottom">Responsive Frameworks</h4>\r\n		<p>We use the responsive layout based on <a target="_blank" href="http://twitter.github.com/bootstrap/" class="external"><strong>Twitter''s Bootstrap Framework</strong></a>, with its collection of utility classes, to provide a great degree of flexibility for a responsive design.</p>\r\n		<a href="http://www.rockettheme.com/blog/team/1550-responsive-design-and-gantry4" class="readon"><span class="icon-external-link"></span><span>Read Blog</span></a>\r\n	</div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-33">\r\n	<div class="rt-demo-spacer">\r\n		<h4 class="smallmarginbottom">RocketTheme Extensions</h4>\r\n		<p>Kirigami comes with the RokSprocket and RokGallery extensions that are built to work with a responsive layout and support mobile touch events, such as <strong>''swipe''</strong>.</p>\r\n		<a href="http://www.rockettheme.com/blog/team/1555-responsive-design-rocketthemes-extensions" class="readon"><span class="icon-external-link"></span><span>Read Blog</span></a>\r\n	</div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-33">\r\n	<div class="rt-demo-spacer">\r\n		<h4 class="smallmarginbottom">Media Queries in JavaScript</h4>\r\n		<p>We have created a new helper class, <strong>RokMediaQueries.js</strong>, which provides a unified system that enables extensions to add media query listeners.</p>\r\n		<a href="http://www.rockettheme.com/blog/team/1555-responsive-design-rocketthemes-extensions" class="readon"><span class="icon-external-link"></span><span>Read Blog</span></a>\r\n	</div>\r\n</div>', 1, 'showcase-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(175, 'Extensions: RokSprocket', '', '<div class="rt-demo-block rt-demo-width-66">\r\n  <div class="rt-demo-spacer">\r\n    <span class="promo2">Rok<strong>Sprocket</strong></span><br />\r\n    <span class="promo3">A Revolutionary Content Module <span class="rt-extra-desc">with Multiple Layout Options</span></span><br />\r\n    <p class="largemargintop">RokSprocket is a revolutionary new extension for Joomla 2.5 designed to give you an incredible level of control over how you present your content. Sophisticated content filters, robust layout modes and options, integration with multiple content providers, and a streamlined no-nonsense interface all contribute to a powerful yet user friendly experience from start to finish.</p>\r\n  </div>\r\n  <div class="rt-extra-desc">\r\n    <div class="rt-demo-block rt-demo-width-50">\r\n      <div class="rt-demo-spacer">\r\n        <ul class="checkmark">\r\n          <li><span>Multiple Layout Options</span></li>\r\n          <li><span>Multiple Content Providers</span></li>\r\n          <li><span>Advanced Cumulative Filters</span></li>\r\n        </ul>\r\n      </div>\r\n    </div>\r\n    <div class="rt-demo-block rt-demo-width-50">\r\n      <div class="rt-demo-spacer">\r\n        <ul class="checkmark">\r\n          <li><span>Advanced Sorting Rules</span></li>\r\n          <li><span>Custom Article Configuration</span></li>\r\n          <li><span>RokGallery/MediaManager Support</span></li>\r\n        </ul>\r\n      </div>\r\n    </div>\r\n	<p>To learn more about the implementation details of supporting responsive design for RocketTheme''s Extensions, please visit the following link.</p>\r\n	<a href="http://www.rockettheme.com/blog/team/1555-responsive-design-rocketthemes-extensions" target="_blank" class="readon"><span class="icon-external-link"></span><span>Responsive Design: Part 3 - RocketTheme''s Extensions</span></a>        \r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-33">\r\n  <div class="rt-demo-spacer">\r\n  	<h4>Mobile Touch Events</h4>\r\n  	<p class="rt-extra-desc">From the very genesis of it''s development, <strong>RokSprocket</strong> was designed with responsive layouts in mind. We also implemented <strong>touch events</strong> to allow you to ''swipe'' to change tabs, headlines, features and lists. This makes RokSprocket an <strong>excellent solution</strong> for <strong>responsive</strong> site building.</p>\r\n    <div class="rt-image largemargintop">\r\n      <img src="images/rocketlauncher/extensions/swipe.png" alt="image" />\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<div class="clear"></div><br />\r\n\r\n<div class="rt-demo-block rt-demo-width-33">\r\n  <div class="rt-demo-spacer">\r\n    <div class="rt-image">\r\n      <img src="images/rocketlauncher/extensions/ext-roksprocket-2.png" alt="image" />\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-33">\r\n  <div class="rt-demo-spacer">\r\n    <div class="rt-image">\r\n      <img src="images/rocketlauncher/extensions/ext-roksprocket-3.png" alt="image" />\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-33">\r\n  <div class="rt-demo-spacer">\r\n    <div class="rt-image">\r\n      <img src="images/rocketlauncher/extensions/ext-roksprocket-4.png" alt="image" />\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<div class="clear"></div><br />', 1, 'showcase-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(176, 'RokGallery', '', '<p>RokGallery is a ground-up gallery extension, developed to be hugely flexible, versatile and user friendly, featured with built-in system on a custom tag-based architecture with the ability to have multiple tag-based galleries.</p>\r\n<span class="visible-desktop"><a class="readon largemarginright" rel="rokbox" href="images/rocketlauncher/extensions/ext-rokgallery.jpg" target="_blank">View: Screenshot</a></span>\r\n<a class="readon" href="http://www.rockettheme.com/extensions-joomla/rokgallery" target="_blank">Download: RokGallery</a>\r\n', 1, 'utility-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"title4","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(177, 'RokTwittie', '', '<p>RokTwittie is a highly configurable module that integrates Twitter into your Joomla site. Display tweets of any username, or even by search terms, as well as your profile information and various other elements from Twitter itself.</p>\r\n<span class="visible-desktop"><a class="readon largemarginright" rel="rokbox" href="images/rocketlauncher/extensions/ext-roktwittie.jpg" target="_blank">View: Screenshot</a></span>\r\n<a class="readon" href="http://www.rockettheme.com/extensions-joomla/roktwittie" target="_blank">Download: RokTwittie</a>', 1, 'utility-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"title4","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(178, 'RokBooster', '', '<p>Increase the speed of your site by enabling the RokBooster plug-in. RokBooster can dramatically reduce the number of HTTP calls a browser has to make, and sending those compressed files GZipped means your pages will load faster with less load on your server.</p>\r\n<a class="readon" href="http://www.rockettheme.com/extensions-joomla/rokbooster" target="_blank">Download: RokBooster</a>', 1, 'content-top-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"box2","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(179, 'RokPad', '', '<p>RokPad provides advanced functions such as an Ajax saving action, syntax highlighting, configurable themes, multiple cursors and selections, shortcut keys, and many other incredible features that traditionally would only be found in a powerful desktop editor.</p>\r\n<a class="readon" href="http://www.rockettheme.com/extensions-joomla/rokpad" target="_blank">Download: RokPad</a>', 1, 'content-top-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"box2","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(180, 'K2 (3rd Party)', '', '<div class="rt-demo-block rt-demo-width-50">\r\n  <div class="rt-demo-spacer">\r\n    <div class="rt-image">\r\n      <img src="images/rocketlauncher/extensions/ext-k2-1.png" alt="image" />\r\n    </div>\r\n  </div>\r\n</div>\r\n<div class="rt-demo-block rt-demo-width-50">\r\n  <div class="rt-demo-spacer">\r\n    <div class="rt-image">\r\n      <img src="images/rocketlauncher/extensions/ext-k2-2.png" alt="image" />\r\n    </div>\r\n  </div> \r\n</div>\r\n\r\n<div class="clear"></div>\r\n\r\n<div class="rt-demo-spacer">\r\n  <p>K2 is the popular powerful content extension for Joomla! with CCK-like features. The version used in this Demo site is <strong>2.5.7</strong>. K2 was built as a complete replacement of the default article system in Joomla!. Install it like any Joomla! extension, import your articles from the default Joomla! article system and you instantly get a host of new features for your existing content.</p>\r\n  <p class="alert">The 3rd party component K2 is NOT included in RocketLauncher. You will need to download them from <a target="_blank" href="http://getk2.org/">Get K2</a> and configure them on your site.</p>\r\n</div>', 1, 'maintop-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"box1","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(181, 'Forum Guides', '', '<div class="rt-demo-block rt-demo-width-50">\r\n	<div class="rt-demo-spacer">\r\n		<ul class="dots">\r\n			<li><a class="nobold" href="http://www.rockettheme.com/forum/index.php?f=654&amp;t=172030&amp;rb_v=viewtopic" target="_blank">Editing the Logo</a></li>\r\n			<li><a class="nobold" href="http://www.rockettheme.com/forum/index.php?f=654&amp;t=172031&amp;rb_v=viewtopic" target="_blank">Template Text</a></li>\r\n			<li><a class="nobold" href="http://www.rockettheme.com/forum/index.php?f=654&amp;t=172032&amp;rb_v=viewtopic" target="_blank">RokBox Login</a></li>\r\n			<li><a class="nobold" href="http://www.rockettheme.com/forum/index.php?f=654&amp;t=172033&amp;rb_v=viewtopic" target="_blank">Popup Module</a></li>\r\n		</ul>		\r\n	</div>\r\n</div>\r\n\r\n<div class="rt-demo-block rt-demo-width-50">\r\n	<div class="rt-demo-spacer">\r\n		<ul>\r\n			<li><a class="nobold" href="http://www.rockettheme.com/forum/index.php?f=654&amp;t=172034&amp;rb_v=viewtopic" target="_blank">Template Guide</a></li>\r\n			<li><a class="nobold" href="http://www.rockettheme.com/forum/index.php?f=654&amp;t=172035&amp;rb_v=viewtopic" target="_blank">Template FAQs</a></li>\r\n			<li><a class="nobold" href="http://www.rockettheme.com/forum/index.php?f=654&amp;t=172036&amp;rb_v=viewtopic" target="_blank">Responsive Classes</a></li>\r\n			<li><a class="nobold" href="http://www.rockettheme.com/forum/index.php?f=654&amp;t=172037&amp;rb_v=viewtopic" target="_blank">Demo Content</a></li>\r\n		</ul>		\r\n	</div>\r\n</div>\r\n\r\n<div class="clear"></div>\r\n\r\n<a class="readon largemargintop smallmarginbottom" target="_blank" href="http://www.rockettheme.com/forum/index.php?f=654&amp;rb_v=viewforum"><span>View All</span></a>', 1, 'content-bottom-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(182, 'Forum Guides', '', '<ul class="dots">\r\n  <li><a class="nobold" href="http://www.rockettheme.com/forum/index.php?f=654&amp;t=172030&amp;rb_v=viewtopic" target="_blank">Editing the Logo</a></li>\r\n  <li><a class="nobold" href="http://www.rockettheme.com/forum/index.php?f=654&amp;t=172031&amp;rb_v=viewtopic" target="_blank">Template Text</a></li>\r\n  <li><a class="nobold" href="http://www.rockettheme.com/forum/index.php?f=654&amp;t=172032&amp;rb_v=viewtopic" target="_blank">RokBox Login</a></li>\r\n  <li><a class="nobold" href="http://www.rockettheme.com/forum/index.php?f=654&amp;t=172033&amp;rb_v=viewtopic" target="_blank">Popup Module</a></li>\r\n  <li><a class="nobold" href="http://www.rockettheme.com/forum/index.php?f=654&amp;t=172034&amp;rb_v=viewtopic" target="_blank">Template Guide</a></li>\r\n  <li><a class="nobold" href="http://www.rockettheme.com/forum/index.php?f=654&amp;t=172035&amp;rb_v=viewtopic" target="_blank">Template FAQs</a></li>\r\n  <li><a class="nobold" href="http://www.rockettheme.com/forum/index.php?f=654&amp;t=172036&amp;rb_v=viewtopic" target="_blank">Responsive Classes</a></li>\r\n  <li><a class="nobold" href="http://www.rockettheme.com/forum/index.php?f=654&amp;t=172037&amp;rb_v=viewtopic" target="_blank">Demo Content</a></li>\r\n</ul>\r\n<a class="readon largemargintop smallmarginbottom" target="_blank" href="http://www.rockettheme.com/forum/index.php?f=654&amp;rb_v=viewforum"><span>View All</span></a>', 1, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"box1 hidden-phone","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(183, 'Responsive Grid Info', '', '<div class="rt-image">\r\n  <img alt="image" src="images/rocketlauncher/features/responsive-1.jpg" />\r\n</div>\r\n\r\n<br />\r\n\r\n<p>Kirigami''s responsive grid system is designed for desktop, tablet and smartphone systems, each with minor modifications to ensure compatibility in each mode. The table above shows the breakdown of screen resolutions and associated devices, and what layout characters are then applied to each.</p>', 1, 'utility-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"title4","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(184, 'Responsive Support Classes', '', '<div class="rt-image">\r\n  <img alt="image" src="images/rocketlauncher/features/responsive-2.jpg" />\r\n</div>\r\n\r\n<br />\r\n\r\n<p>Another useful feature available, via Bootstrap, is the collection of responsible utility classes that can be used to help tweak layouts by providing a simple method of showing or hiding modules. Insert the above module class suffixes into your module settings to show/hide a module for a particular mode.</p>', 1, 'utility-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"title4","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(185, 'Media Queries', '', '<p>In terms of media queries, the breakdown is:</p>\r\n<pre class="lines rt-pre-col2">\r\n/* Smartphones */\r\n@media (max-width: 480px) { ... }\r\n\r\n/* Smartphones to Tablets */\r\n@media (min-width: 481px) and (max-width: 767px) { ... }\r\n\r\n/* Tablets */\r\n@media (min-width: 768px) and (max-width: 959px) { ... }\r\n\r\n/* Desktop */\r\n@media (min-width: 960px) and (max-width: 1199px) { ... }\r\n\r\n/* Large Display */\r\n@media (min-width: 1200px) { ... }\r\n</pre>', 1, 'maintop-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"title4","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(186, 'Navigation', '', '<p class="rt-image rt-floatleft nomarginbottom">\r\n	<img src="images/rocketlauncher/features/responsive-nav.png" alt="image" />\r\n</p>\r\n\r\n<p>The menu system for a smartphone device will be that of a <strong>select-field</strong>. A select field is a great solution for this because most phones have nice native select UI elements. Using this method is necessary as to make the menu accessible on the mobile devices, as Fusion, and our other menu types, are simply too complex to render effectively on these devices. A new menu system will be created that is responsive, but will form part of Gantry</p>\r\n\r\n<p class="nomarginbottom hidden-tablet">All other sizes will use the normal menu system build on RokNavMenu, such as Fusion Menu or SplitMenu.</p>\r\n\r\n<div class="clear"></div>', 1, 'maintop-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(187, 'box1 basictitle', '', '<p>An example module using the <strong>box3 basictitle</strong> module class suffix.</p>\r\n<p>Lorem ipsum dolor sit amet, consecetur adipiscing elit. Donec sit amet nibh.</p>', 1, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"box1 basictitle","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(188, 'Who''s Online', '', '', 20, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_whosonline', 1, 1, '{"showmode":"0","layout":"_:default","moduleclass_sfx":"basictitle box1 hidden-phone","cache":"0","filter_groups":"0"}', 0, '*'),
(189, 'Member Access', '', '', 20, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_login', 1, 1, '{"pretext":"","posttext":"","login":"","logout":"","greeting":"1","name":"0","usesecure":"0","layout":"_:default","moduleclass_sfx":"hidden-phone hidden-tablet","cache":"0"}', 0, '*'),
(190, 'Newsflash', '', '', 1, 'content-bottom-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_news', 1, 1, '{"catid":["9"],"image":"0","item_title":"0","link_titles":"","item_heading":"h4","showLastSeparator":"1","readmore":"0","count":"1","ordering":"a.publish_up","layout":"_:default","moduleclass_sfx":"hidden-phone","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*');

-- --------------------------------------------------------

--
-- Table structure for table `#__modules_menu`
--

DROP TABLE IF EXISTS `#__modules_menu`;
CREATE TABLE IF NOT EXISTS `#__modules_menu` (
  `moduleid` int(11) NOT NULL DEFAULT '0',
  `menuid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`moduleid`,`menuid`)
);

--
-- Dumping data for table `#__modules_menu`
--

INSERT INTO `#__modules_menu` (`moduleid`, `menuid`) VALUES
(2, 0),
(3, 0),
(4, 0),
(6, 0),
(7, 0),
(8, 0),
(9, 0),
(10, 0),
(12, 0),
(13, 0),
(14, 0),
(15, 0),
(79, 0),
(86, 0),
(87, 0),
(88, 102),
(90, 103),
(91, 103),
(92, 103),
(93, 103),
(94, 103),
(95, 104),
(96, 105),
(97, 105),
(98, 106),
(99, 106),
(100, 106),
(101, 106),
(102, 106),
(103, 106),
(104, 106),
(105, 107),
(106, 108),
(106, 112),
(106, 120),
(106, 122),
(106, 123),
(107, 108),
(107, 112),
(107, 120),
(107, 122),
(107, 123),
(108, 108),
(108, 110),
(108, 112),
(108, 120),
(108, 121),
(108, 122),
(108, 123),
(109, 108),
(109, 110),
(109, 112),
(109, 120),
(109, 121),
(109, 122),
(109, 123),
(110, 109),
(111, 109),
(112, 109),
(113, 109),
(114, 111),
(115, 111),
(116, 111),
(117, 108),
(117, 110),
(117, 112),
(117, 120),
(117, 121),
(117, 122),
(117, 123),
(118, 106),
(118, 109),
(118, 110),
(118, 111),
(118, 112),
(119, 106),
(119, 109),
(119, 110),
(119, 111),
(119, 112),
(119, 121),
(119, 123),
(120, 108),
(121, 104),
(122, 104),
(123, 104),
(124, 104),
(125, 101),
(126, 101),
(127, 101),
(136, 120),
(139, 104),
(140, 104),
(141, 104),
(142, 104),
(144, 104),
(145, 104),
(146, 104),
(147, 104),
(148, 104),
(154, 101),
(155, 101),
(157, 101),
(158, 101),
(159, 101),
(161, 101),
(164, 112),
(164, 120),
(164, 121),
(164, 122),
(164, 123),
(165, 110),
(165, 121),
(166, 109),
(166, 110),
(167, 108),
(168, 108),
(169, 0),
(170, 101),
(171, 121),
(172, 102),
(173, 104),
(174, 102),
(175, 107),
(176, 107),
(177, 107),
(178, 107),
(179, 107),
(180, 107),
(181, 108),
(182, 122),
(183, 102),
(184, 102),
(185, 102),
(186, 102),
(187, 104),
(188, 111),
(188, 112),
(188, 120),
(188, 121),
(188, 123),
(188, 188),
(188, 189),
(188, 190),
(188, 191),
(188, 192),
(188, 193),
(188, 194),
(188, 195),
(188, 196),
(188, 197),
(189, 106),
(190, 120);

-- --------------------------------------------------------

--
-- Table structure for table `#__newsfeeds`
--

DROP TABLE IF EXISTS `#__newsfeeds`;
CREATE TABLE IF NOT EXISTS `#__newsfeeds` (
  `catid` int(11) NOT NULL DEFAULT '0',
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `link` varchar(200) NOT NULL DEFAULT '',
  `filename` varchar(200) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `numarticles` int(10) unsigned NOT NULL DEFAULT '1',
  `cache_time` int(10) unsigned NOT NULL DEFAULT '3600',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rtl` tinyint(4) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__overrider`
--

DROP TABLE IF EXISTS `#__overrider`;
CREATE TABLE IF NOT EXISTS `#__overrider` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `constant` varchar(255) NOT NULL,
  `string` text NOT NULL,
  `file` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__rokcandy`
--

DROP TABLE IF EXISTS `#__rokcandy`;
CREATE TABLE IF NOT EXISTS `#__rokcandy` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `catid` int(11) NOT NULL,
  `macro` text NOT NULL,
  `html` text NOT NULL,
  `published` tinyint(1) NOT NULL,
  `checked_out` int(11) NOT NULL,
  `checked_out_time` datetime NOT NULL,
  `ordering` int(11) NOT NULL,
  `params` text NOT NULL,
  PRIMARY KEY (`id`)
);

--
-- Dumping data for table `#__rokcandy`
--

INSERT INTO `#__rokcandy` (`id`, `catid`, `macro`, `html`, `published`, `checked_out`, `checked_out_time`, `ordering`, `params`) VALUES
(20, 16, '[h1]{text}[/h1]', '<h1>{text}</h1>', 1, 0, '0000-00-00 00:00:00', 1, ''),
(21, 16, '[h2]{text}[/h2]', '<h2>{text}</h2>', 1, 0, '0000-00-00 00:00:00', 2, ''),
(22, 16, '[h3]{text}[/h3]', '<h3>{text}</h3>', 1, 0, '0000-00-00 00:00:00', 3, ''),
(23, 16, '[h4]{text}[/h4]', '<h4>{text}</h4>', 1, 0, '0000-00-00 00:00:00', 4, ''),
(24, 16, '[h5]{text}[/h5]', '<h5>{text}</h5>', 1, 0, '0000-00-00 00:00:00', 5, ''),
(25, 16, '[b]{text}[/b]', '<strong>{text}</strong>', 1, 0, '0000-00-00 00:00:00', 6, ''),
(26, 16, '[i]{text}[/i]', '<em>{text}</em>', 1, 0, '0000-00-00 00:00:00', 7, ''),
(27, 16, '[code]{text}[/code]', '<code>{text}</code>', 1, 0, '0000-00-00 00:00:00', 8, '');

-- --------------------------------------------------------

--
-- Table structure for table `#__rokcommon_configs`
--

DROP TABLE IF EXISTS `#__rokcommon_configs`;
CREATE TABLE IF NOT EXISTS `#__rokcommon_configs` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `extension` varchar(45) NOT NULL DEFAULT '',
  `type` varchar(45) NOT NULL,
  `file` varchar(256) NOT NULL,
  `priority` int(10) NOT NULL DEFAULT '10',
  PRIMARY KEY (`id`)
);

--
-- Dumping data for table `#__rokcommon_configs`
--

INSERT INTO `#__rokcommon_configs` (`id`, `extension`, `type`, `file`, `priority`) VALUES
(9, 'rokgallery', 'container', '/components/com_rokgallery/container.xml', 10),
(10, 'rokgallery', 'library', '/components/com_rokgallery/lib', 10),
(13, 'roksprocket', 'container', '/components/com_roksprocket/container.xml', 10),
(14, 'roksprocket', 'library', '/components/com_roksprocket/lib', 10);

-- --------------------------------------------------------

--
-- Table structure for table `#__rokgallery_files`
--

DROP TABLE IF EXISTS `#__rokgallery_files`;
CREATE TABLE IF NOT EXISTS `#__rokgallery_files` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `filename` varchar(255) NOT NULL,
  `guid` char(36) NOT NULL,
  `md5` char(32) NOT NULL,
  `title` varchar(200) NOT NULL,
  `description` text,
  `license` varchar(255) DEFAULT NULL,
  `xsize` int(10) unsigned NOT NULL,
  `ysize` int(10) unsigned NOT NULL,
  `filesize` int(10) unsigned NOT NULL,
  `type` char(20) NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `created_at` datetime NOT NULL,
  `updated_at` datetime NOT NULL,
  `slug` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`),
  UNIQUE KEY `guid` (`guid`),
  UNIQUE KEY `#__files_sluggable_idx` (`slug`),
  KEY `#__rokgallery_files_published_idx` (`published`),
  KEY `#__rokgallery_files_md5_idx` (`md5`),
  KEY `#__rokgallery_files_guid_idx` (`guid`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__rokgallery_files_index`
--

DROP TABLE IF EXISTS `#__rokgallery_files_index`;
CREATE TABLE IF NOT EXISTS `#__rokgallery_files_index` (
  `keyword` varchar(200) NOT NULL DEFAULT '',
  `field` varchar(50) NOT NULL DEFAULT '',
  `position` bigint(20) NOT NULL DEFAULT '0',
  `id` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`keyword`,`field`,`position`,`id`),
  KEY `#__rokgallery_files_index_id_idx` (`id`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__rokgallery_file_loves`
--

DROP TABLE IF EXISTS `#__rokgallery_file_loves`;
CREATE TABLE IF NOT EXISTS `#__rokgallery_file_loves` (
  `file_id` int(10) unsigned NOT NULL DEFAULT '0',
  `kount` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`file_id`),
  UNIQUE KEY `file_id` (`file_id`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__rokgallery_file_tags`
--

DROP TABLE IF EXISTS `#__rokgallery_file_tags`;
CREATE TABLE IF NOT EXISTS `#__rokgallery_file_tags` (
  `file_id` int(10) unsigned NOT NULL DEFAULT '0',
  `tag` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`file_id`,`tag`),
  KEY `#__rokgallery_file_tags_file_id_idx` (`file_id`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__rokgallery_file_views`
--

DROP TABLE IF EXISTS `#__rokgallery_file_views`;
CREATE TABLE IF NOT EXISTS `#__rokgallery_file_views` (
  `file_id` int(10) unsigned NOT NULL DEFAULT '0',
  `kount` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`file_id`),
  UNIQUE KEY `file_id` (`file_id`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__rokgallery_filters`
--

DROP TABLE IF EXISTS `#__rokgallery_filters`;
CREATE TABLE IF NOT EXISTS `#__rokgallery_filters` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) NOT NULL,
  `query` text NOT NULL,
  `created_at` datetime NOT NULL,
  `updated_at` datetime NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`),
  KEY `rokgallery_profiles_name_idx` (`name`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__rokgallery_galleries`
--

DROP TABLE IF EXISTS `#__rokgallery_galleries`;
CREATE TABLE IF NOT EXISTS `#__rokgallery_galleries` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) NOT NULL,
  `filetags` longtext,
  `width` int(10) unsigned NOT NULL DEFAULT '910',
  `height` int(10) unsigned NOT NULL DEFAULT '500',
  `keep_aspect` tinyint(1) DEFAULT '0',
  `force_image_size` tinyint(1) DEFAULT '0',
  `thumb_xsize` int(10) unsigned NOT NULL DEFAULT '190',
  `thumb_ysize` int(10) unsigned NOT NULL DEFAULT '150',
  `thumb_background` varchar(12) DEFAULT NULL,
  `thumb_keep_aspect` tinyint(1) DEFAULT '0',
  `auto_publish` tinyint(1) DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`),
  KEY `#__rokgallery_galleries_auto_publish_idx` (`auto_publish`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__rokgallery_jobs`
--

DROP TABLE IF EXISTS `#__rokgallery_jobs`;
CREATE TABLE IF NOT EXISTS `#__rokgallery_jobs` (
  `id` char(36) NOT NULL DEFAULT '',
  `type` varchar(255) NOT NULL,
  `properties` text,
  `state` varchar(255) NOT NULL,
  `status` text,
  `percent` bigint(20) unsigned DEFAULT NULL,
  `sm` text NOT NULL,
  `created_at` datetime NOT NULL,
  `updated_at` datetime NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`)
);

--
-- Dumping data for table `#__rokgallery_jobs`
--

INSERT INTO `#__rokgallery_jobs` (`id`, `type`, `properties`, `state`, `status`, `percent`, `sm`, `created_at`, `updated_at`) VALUES
('00065949-593d-4fb1-b3c1-1e7381a1618e', 'Update Gallery', 'a:2:{s:9:"galleryId";s:1:"1";s:5:"files";a:4:{i:0;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"1";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:1;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"2";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:2;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"3";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:3;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"4";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}}}', 'Completed', 'Gallery Update Complete', 100, 'O:27:"RokGallery_Job_StateMachine":5:{s:9:"\0*\0_state";O:33:"RokGallery_Job_StateMap_Completed":2:{s:8:"\0*\0_name";s:33:"RokGallery_Job_StateMap.Completed";s:6:"\0*\0_id";i:8;}s:18:"\0*\0_previous_state";O:31:"RokGallery_Job_StateMap_Running":2:{s:8:"\0*\0_name";s:31:"RokGallery_Job_StateMap.Running";s:6:"\0*\0_id";i:2;}s:15:"\0*\0_state_stack";a:0:{}s:14:"\0*\0_transition";N;s:14:"\0*\0_debug_flag";b:0;}', '2012-07-10 23:15:08', '2012-07-10 23:15:09'),
('003faa1f-f26d-4bc4-b090-a8943c4d3ff5', 'Tag Addition', 'a:5:{i:0;O:32:"RokGallery_Job_Property_FileTags":5:{s:9:"\0*\0fileId";i:9;s:7:"\0*\0tags";a:1:{i:0;s:11:"fp-featured";}s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:1;O:32:"RokGallery_Job_Property_FileTags":5:{s:9:"\0*\0fileId";i:8;s:7:"\0*\0tags";a:1:{i:0;s:11:"fp-featured";}s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:2;O:32:"RokGallery_Job_Property_FileTags":5:{s:9:"\0*\0fileId";i:5;s:7:"\0*\0tags";a:1:{i:0;s:11:"fp-featured";}s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:3;O:32:"RokGallery_Job_Property_FileTags":5:{s:9:"\0*\0fileId";i:6;s:7:"\0*\0tags";a:1:{i:0;s:11:"fp-featured";}s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:4;O:32:"RokGallery_Job_Property_FileTags":5:{s:9:"\0*\0fileId";i:7;s:7:"\0*\0tags";a:1:{i:0;s:11:"fp-featured";}s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}}', 'Completed', 'Tag Addition Complete', 100, 'O:27:"RokGallery_Job_StateMachine":5:{s:9:"\0*\0_state";O:33:"RokGallery_Job_StateMap_Completed":2:{s:8:"\0*\0_name";s:33:"RokGallery_Job_StateMap.Completed";s:6:"\0*\0_id";i:8;}s:18:"\0*\0_previous_state";O:31:"RokGallery_Job_StateMap_Running":2:{s:8:"\0*\0_name";s:31:"RokGallery_Job_StateMap.Running";s:6:"\0*\0_id";i:2;}s:15:"\0*\0_state_stack";a:0:{}s:14:"\0*\0_transition";N;s:14:"\0*\0_debug_flag";b:0;}', '2012-07-11 00:10:05', '2012-07-11 00:10:06'),
('0da7bc10-6646-4bf4-cca1-1db92b6d7028', 'Import', NULL, 'Prepping', NULL, 0, 'O:27:"RokGallery_Job_StateMachine":5:{s:9:"\0*\0_state";O:32:"RokGallery_Job_StateMap_Prepping":2:{s:8:"\0*\0_name";s:32:"RokGallery_Job_StateMap.Prepping";s:6:"\0*\0_id";i:0;}s:18:"\0*\0_previous_state";N;s:15:"\0*\0_state_stack";a:0:{}s:14:"\0*\0_transition";N;s:14:"\0*\0_debug_flag";b:0;}', '2012-07-10 22:32:21', '2012-07-10 22:32:21'),
('32599bfe-96ec-4807-e5e2-f5c29c74db73', 'Update Gallery', 'a:2:{s:9:"galleryId";s:1:"1";s:5:"files";a:4:{i:0;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"1";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:1;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"2";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:2;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"3";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:3;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"4";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}}}', 'Completed', 'Gallery Update Complete', 100, 'O:27:"RokGallery_Job_StateMachine":5:{s:9:"\0*\0_state";O:33:"RokGallery_Job_StateMap_Completed":2:{s:8:"\0*\0_name";s:33:"RokGallery_Job_StateMap.Completed";s:6:"\0*\0_id";i:8;}s:18:"\0*\0_previous_state";O:31:"RokGallery_Job_StateMap_Running":2:{s:8:"\0*\0_name";s:31:"RokGallery_Job_StateMap.Running";s:6:"\0*\0_id";i:2;}s:15:"\0*\0_state_stack";a:0:{}s:14:"\0*\0_transition";N;s:14:"\0*\0_debug_flag";b:0;}', '2012-07-10 23:25:39', '2012-07-10 23:25:40'),
('340e5b1c-56c1-4572-dc0c-62a4f0386ac3', 'Update Gallery', 'a:2:{s:9:"galleryId";s:1:"1";s:5:"files";a:4:{i:0;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"1";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:1;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"2";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:2;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"3";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:3;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"4";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}}}', 'Completed', 'Gallery Update Complete', 100, 'O:27:"RokGallery_Job_StateMachine":5:{s:9:"\0*\0_state";O:33:"RokGallery_Job_StateMap_Completed":2:{s:8:"\0*\0_name";s:33:"RokGallery_Job_StateMap.Completed";s:6:"\0*\0_id";i:8;}s:18:"\0*\0_previous_state";O:31:"RokGallery_Job_StateMap_Running":2:{s:8:"\0*\0_name";s:31:"RokGallery_Job_StateMap.Running";s:6:"\0*\0_id";i:2;}s:15:"\0*\0_state_stack";a:0:{}s:14:"\0*\0_transition";N;s:14:"\0*\0_debug_flag";b:0;}', '2012-07-10 23:20:59', '2012-07-10 23:21:00'),
('35b1232d-3dee-408a-e263-464522dc789b', 'Update Gallery', 'a:2:{s:9:"galleryId";s:1:"1";s:5:"files";a:4:{i:0;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"1";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:1;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"2";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:2;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"3";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:3;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"4";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}}}', 'Completed', 'Gallery Update Complete', 100, 'O:27:"RokGallery_Job_StateMachine":5:{s:9:"\0*\0_state";O:33:"RokGallery_Job_StateMap_Completed":2:{s:8:"\0*\0_name";s:33:"RokGallery_Job_StateMap.Completed";s:6:"\0*\0_id";i:8;}s:18:"\0*\0_previous_state";O:31:"RokGallery_Job_StateMap_Running":2:{s:8:"\0*\0_name";s:31:"RokGallery_Job_StateMap.Running";s:6:"\0*\0_id";i:2;}s:15:"\0*\0_state_stack";a:0:{}s:14:"\0*\0_transition";N;s:14:"\0*\0_debug_flag";b:0;}', '2012-07-10 23:23:03', '2012-07-10 23:23:03'),
('37163164-9cfe-4f2f-e8d8-c4c593da8bb0', 'Update Gallery', 'a:2:{s:9:"galleryId";s:1:"1";s:5:"files";a:4:{i:0;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"1";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:1;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"2";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:2;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"3";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:3;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"4";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}}}', 'Completed', 'Gallery Update Complete', 100, 'O:27:"RokGallery_Job_StateMachine":5:{s:9:"\0*\0_state";O:33:"RokGallery_Job_StateMap_Completed":2:{s:8:"\0*\0_name";s:33:"RokGallery_Job_StateMap.Completed";s:6:"\0*\0_id";i:8;}s:18:"\0*\0_previous_state";O:31:"RokGallery_Job_StateMap_Running":2:{s:8:"\0*\0_name";s:31:"RokGallery_Job_StateMap.Running";s:6:"\0*\0_id";i:2;}s:15:"\0*\0_state_stack";a:0:{}s:14:"\0*\0_transition";N;s:14:"\0*\0_debug_flag";b:0;}', '2012-07-10 23:26:01', '2012-07-10 23:26:01'),
('4c801f2f-cd8e-45ae-d52c-36acf995e535', 'Import', 'a:5:{i:0;O:34:"RokGallery_Job_Property_ImportFile":6:{s:7:"\0*\0path";s:141:"/Users/FinLy/Dropbox/SyncStuffs/MAMP/LocalHost/sandbox/kirigami/tmp/4c801f2f-cd8e-45ae-d52c-36acf995e535/3501cfa5-7e96-435a-f889-8f33819df6ed";s:5:"\0*\0id";s:36:"3501cfa5-7e96-435a-f889-8f33819df6ed";s:11:"\0*\0filename";s:8:"img1.jpg";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:1;O:34:"RokGallery_Job_Property_ImportFile":6:{s:7:"\0*\0path";s:141:"/Users/FinLy/Dropbox/SyncStuffs/MAMP/LocalHost/sandbox/kirigami/tmp/4c801f2f-cd8e-45ae-d52c-36acf995e535/120b35b7-1049-475d-a427-cd6e486f40ce";s:5:"\0*\0id";s:36:"120b35b7-1049-475d-a427-cd6e486f40ce";s:11:"\0*\0filename";s:8:"img2.jpg";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:2;O:34:"RokGallery_Job_Property_ImportFile":6:{s:7:"\0*\0path";s:141:"/Users/FinLy/Dropbox/SyncStuffs/MAMP/LocalHost/sandbox/kirigami/tmp/4c801f2f-cd8e-45ae-d52c-36acf995e535/52bcc264-6aa0-4bb0-b9af-b28da5a00df3";s:5:"\0*\0id";s:36:"52bcc264-6aa0-4bb0-b9af-b28da5a00df3";s:11:"\0*\0filename";s:8:"img3.jpg";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:3;O:34:"RokGallery_Job_Property_ImportFile":6:{s:7:"\0*\0path";s:141:"/Users/FinLy/Dropbox/SyncStuffs/MAMP/LocalHost/sandbox/kirigami/tmp/4c801f2f-cd8e-45ae-d52c-36acf995e535/a597a5b2-378c-42bf-b9f2-87d7b4b92b31";s:5:"\0*\0id";s:36:"a597a5b2-378c-42bf-b9f2-87d7b4b92b31";s:11:"\0*\0filename";s:8:"img4.jpg";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:4;O:34:"RokGallery_Job_Property_ImportFile":6:{s:7:"\0*\0path";s:141:"/Users/FinLy/Dropbox/SyncStuffs/MAMP/LocalHost/sandbox/kirigami/tmp/4c801f2f-cd8e-45ae-d52c-36acf995e535/3477090e-c563-429c-b0a9-941b120a0c44";s:5:"\0*\0id";s:36:"3477090e-c563-429c-b0a9-941b120a0c44";s:11:"\0*\0filename";s:8:"img5.jpg";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}}', 'Completed', 'Importing Complete', 100, 'O:27:"RokGallery_Job_StateMachine":5:{s:9:"\0*\0_state";O:33:"RokGallery_Job_StateMap_Completed":2:{s:8:"\0*\0_name";s:33:"RokGallery_Job_StateMap.Completed";s:6:"\0*\0_id";i:8;}s:18:"\0*\0_previous_state";O:31:"RokGallery_Job_StateMap_Running":2:{s:8:"\0*\0_name";s:31:"RokGallery_Job_StateMap.Running";s:6:"\0*\0_id";i:2;}s:15:"\0*\0_state_stack";a:0:{}s:14:"\0*\0_transition";N;s:14:"\0*\0_debug_flag";b:0;}', '2012-07-11 00:09:46', '2012-07-11 00:09:48'),
('52d5ca01-fd03-4360-84f8-0dcf694c9aee', 'Import', NULL, 'Prepping', NULL, 0, 'O:27:"RokGallery_Job_StateMachine":5:{s:9:"\0*\0_state";O:32:"RokGallery_Job_StateMap_Prepping":2:{s:8:"\0*\0_name";s:32:"RokGallery_Job_StateMap.Prepping";s:6:"\0*\0_id";i:0;}s:18:"\0*\0_previous_state";N;s:15:"\0*\0_state_stack";a:0:{}s:14:"\0*\0_transition";N;s:14:"\0*\0_debug_flag";b:0;}', '2012-07-10 22:29:09', '2012-07-10 22:29:09'),
('75893031-d729-4858-b0e5-fab9aaa57e9f', 'Update Gallery', 'a:2:{s:9:"galleryId";s:1:"1";s:5:"files";a:4:{i:0;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"1";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:1;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"2";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:2;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"3";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:3;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"4";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}}}', 'Completed', 'Gallery Update Complete', 100, 'O:27:"RokGallery_Job_StateMachine":5:{s:9:"\0*\0_state";O:33:"RokGallery_Job_StateMap_Completed":2:{s:8:"\0*\0_name";s:33:"RokGallery_Job_StateMap.Completed";s:6:"\0*\0_id";i:8;}s:18:"\0*\0_previous_state";O:31:"RokGallery_Job_StateMap_Running":2:{s:8:"\0*\0_name";s:31:"RokGallery_Job_StateMap.Running";s:6:"\0*\0_id";i:2;}s:15:"\0*\0_state_stack";a:0:{}s:14:"\0*\0_transition";N;s:14:"\0*\0_debug_flag";b:0;}', '2012-07-10 23:13:02', '2012-07-10 23:13:03'),
('7f994eee-96c3-4b86-d414-bc9c0fc8ede3', 'Update Gallery', 'a:2:{s:9:"galleryId";s:1:"1";s:5:"files";a:4:{i:0;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"1";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:1;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"2";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:2;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"3";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:3;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"4";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}}}', 'Completed', 'Gallery Update Complete', 100, 'O:27:"RokGallery_Job_StateMachine":5:{s:9:"\0*\0_state";O:33:"RokGallery_Job_StateMap_Completed":2:{s:8:"\0*\0_name";s:33:"RokGallery_Job_StateMap.Completed";s:6:"\0*\0_id";i:8;}s:18:"\0*\0_previous_state";O:31:"RokGallery_Job_StateMap_Running":2:{s:8:"\0*\0_name";s:31:"RokGallery_Job_StateMap.Running";s:6:"\0*\0_id";i:2;}s:15:"\0*\0_state_stack";a:0:{}s:14:"\0*\0_transition";N;s:14:"\0*\0_debug_flag";b:0;}', '2012-07-10 23:12:28', '2012-07-10 23:12:29'),
('972be03d-2264-4656-b769-8c6f6952d400', 'Update Gallery', 'a:2:{s:9:"galleryId";s:1:"1";s:5:"files";a:4:{i:0;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"1";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:1;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"2";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:2;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"3";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:3;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"4";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}}}', 'Completed', 'Gallery Update Complete', 100, 'O:27:"RokGallery_Job_StateMachine":5:{s:9:"\0*\0_state";O:33:"RokGallery_Job_StateMap_Completed":2:{s:8:"\0*\0_name";s:33:"RokGallery_Job_StateMap.Completed";s:6:"\0*\0_id";i:8;}s:18:"\0*\0_previous_state";O:31:"RokGallery_Job_StateMap_Running":2:{s:8:"\0*\0_name";s:31:"RokGallery_Job_StateMap.Running";s:6:"\0*\0_id";i:2;}s:15:"\0*\0_state_stack";a:0:{}s:14:"\0*\0_transition";N;s:14:"\0*\0_debug_flag";b:0;}', '2012-07-10 22:57:55', '2012-07-10 22:57:55'),
('9cb3d53e-c64c-48e1-ec2a-881af0af0460', 'Update Gallery', 'a:2:{s:9:"galleryId";s:1:"1";s:5:"files";a:4:{i:0;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"1";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:1;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"2";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:2;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"3";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:3;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"4";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}}}', 'Completed', 'Gallery Update Complete', 100, 'O:27:"RokGallery_Job_StateMachine":5:{s:9:"\0*\0_state";O:33:"RokGallery_Job_StateMap_Completed":2:{s:8:"\0*\0_name";s:33:"RokGallery_Job_StateMap.Completed";s:6:"\0*\0_id";i:8;}s:18:"\0*\0_previous_state";O:31:"RokGallery_Job_StateMap_Running":2:{s:8:"\0*\0_name";s:31:"RokGallery_Job_StateMap.Running";s:6:"\0*\0_id";i:2;}s:15:"\0*\0_state_stack";a:0:{}s:14:"\0*\0_transition";N;s:14:"\0*\0_debug_flag";b:0;}', '2012-07-10 22:36:38', '2012-07-10 22:36:39'),
('a2f108a0-6539-4f76-c54e-21dbe02f93cb', 'Import', NULL, 'Prepping', NULL, 0, 'O:27:"RokGallery_Job_StateMachine":5:{s:9:"\0*\0_state";O:32:"RokGallery_Job_StateMap_Prepping":2:{s:8:"\0*\0_name";s:32:"RokGallery_Job_StateMap.Prepping";s:6:"\0*\0_id";i:0;}s:18:"\0*\0_previous_state";N;s:15:"\0*\0_state_stack";a:0:{}s:14:"\0*\0_transition";N;s:14:"\0*\0_debug_flag";b:0;}', '2012-07-10 22:29:46', '2012-07-10 22:29:46'),
('b5618d52-00a4-46f4-a153-a246dd31a358', 'Update Gallery', 'a:2:{s:9:"galleryId";s:1:"1";s:5:"files";a:4:{i:0;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"1";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:1;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"2";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:2;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"3";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:3;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"4";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}}}', 'Completed', 'Gallery Update Complete', 100, 'O:27:"RokGallery_Job_StateMachine":5:{s:9:"\0*\0_state";O:33:"RokGallery_Job_StateMap_Completed":2:{s:8:"\0*\0_name";s:33:"RokGallery_Job_StateMap.Completed";s:6:"\0*\0_id";i:8;}s:18:"\0*\0_previous_state";O:31:"RokGallery_Job_StateMap_Running":2:{s:8:"\0*\0_name";s:31:"RokGallery_Job_StateMap.Running";s:6:"\0*\0_id";i:2;}s:15:"\0*\0_state_stack";a:0:{}s:14:"\0*\0_transition";N;s:14:"\0*\0_debug_flag";b:0;}', '2012-07-10 23:19:19', '2012-07-10 23:19:19'),
('ca78a8ac-62bb-49b4-e119-eceb303520bd', 'Update Gallery', 'a:2:{s:9:"galleryId";s:1:"1";s:5:"files";a:4:{i:0;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"1";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:1;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"2";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:2;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"3";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:3;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"4";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}}}', 'Completed', 'Gallery Update Complete', 100, 'O:27:"RokGallery_Job_StateMachine":5:{s:9:"\0*\0_state";O:33:"RokGallery_Job_StateMap_Completed":2:{s:8:"\0*\0_name";s:33:"RokGallery_Job_StateMap.Completed";s:6:"\0*\0_id";i:8;}s:18:"\0*\0_previous_state";O:31:"RokGallery_Job_StateMap_Running":2:{s:8:"\0*\0_name";s:31:"RokGallery_Job_StateMap.Running";s:6:"\0*\0_id";i:2;}s:15:"\0*\0_state_stack";a:0:{}s:14:"\0*\0_transition";N;s:14:"\0*\0_debug_flag";b:0;}', '2012-07-10 23:20:01', '2012-07-10 23:20:02'),
('cd49997c-9bbb-48c6-b9b0-1637b4a5dfb9', 'Update Gallery', 'a:2:{s:9:"galleryId";s:1:"1";s:5:"files";a:4:{i:0;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"1";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:1;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"2";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:2;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"3";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:3;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"4";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}}}', 'Completed', 'Gallery Update Complete', 100, 'O:27:"RokGallery_Job_StateMachine":5:{s:9:"\0*\0_state";O:33:"RokGallery_Job_StateMap_Completed":2:{s:8:"\0*\0_name";s:33:"RokGallery_Job_StateMap.Completed";s:6:"\0*\0_id";i:8;}s:18:"\0*\0_previous_state";O:31:"RokGallery_Job_StateMap_Running":2:{s:8:"\0*\0_name";s:31:"RokGallery_Job_StateMap.Running";s:6:"\0*\0_id";i:2;}s:15:"\0*\0_state_stack";a:0:{}s:14:"\0*\0_transition";N;s:14:"\0*\0_debug_flag";b:0;}', '2012-07-10 22:53:57', '2012-07-10 22:53:57'),
('ce0dfa5e-65a9-4404-b0b4-e5633222958c', 'Update Gallery', 'a:2:{s:9:"galleryId";s:1:"2";s:5:"files";a:5:{i:0;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"5";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:1;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"6";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:2;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"7";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:3;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"8";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:4;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"9";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}}}', 'Completed', 'Gallery Update Complete', 100, 'O:27:"RokGallery_Job_StateMachine":5:{s:9:"\0*\0_state";O:33:"RokGallery_Job_StateMap_Completed":2:{s:8:"\0*\0_name";s:33:"RokGallery_Job_StateMap.Completed";s:6:"\0*\0_id";i:8;}s:18:"\0*\0_previous_state";O:31:"RokGallery_Job_StateMap_Running":2:{s:8:"\0*\0_name";s:31:"RokGallery_Job_StateMap.Running";s:6:"\0*\0_id";i:2;}s:15:"\0*\0_state_stack";a:0:{}s:14:"\0*\0_transition";N;s:14:"\0*\0_debug_flag";b:0;}', '2012-07-11 00:15:18', '2012-07-11 00:15:19'),
('cf59eda3-3828-40ec-d631-96b7f659d2ce', 'Import', 'a:4:{i:0;O:34:"RokGallery_Job_Property_ImportFile":6:{s:7:"\0*\0path";s:141:"/Users/FinLy/Dropbox/SyncStuffs/MAMP/LocalHost/sandbox/kirigami/tmp/cf59eda3-3828-40ec-d631-96b7f659d2ce/96205e62-d890-48c4-8522-e4619cec4a1b";s:5:"\0*\0id";s:36:"96205e62-d890-48c4-8522-e4619cec4a1b";s:11:"\0*\0filename";s:8:"img1.jpg";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:1;O:34:"RokGallery_Job_Property_ImportFile":6:{s:7:"\0*\0path";s:141:"/Users/FinLy/Dropbox/SyncStuffs/MAMP/LocalHost/sandbox/kirigami/tmp/cf59eda3-3828-40ec-d631-96b7f659d2ce/3a1c06fc-b4f8-4cdd-f172-de86880aa67b";s:5:"\0*\0id";s:36:"3a1c06fc-b4f8-4cdd-f172-de86880aa67b";s:11:"\0*\0filename";s:8:"img2.jpg";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:2;O:34:"RokGallery_Job_Property_ImportFile":6:{s:7:"\0*\0path";s:141:"/Users/FinLy/Dropbox/SyncStuffs/MAMP/LocalHost/sandbox/kirigami/tmp/cf59eda3-3828-40ec-d631-96b7f659d2ce/21bcc962-1d1b-4cc7-f3a3-cd829716355e";s:5:"\0*\0id";s:36:"21bcc962-1d1b-4cc7-f3a3-cd829716355e";s:11:"\0*\0filename";s:8:"img3.jpg";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:3;O:34:"RokGallery_Job_Property_ImportFile":6:{s:7:"\0*\0path";s:141:"/Users/FinLy/Dropbox/SyncStuffs/MAMP/LocalHost/sandbox/kirigami/tmp/cf59eda3-3828-40ec-d631-96b7f659d2ce/2cb28d99-dd97-448d-9571-a87004dc1e6a";s:5:"\0*\0id";s:36:"2cb28d99-dd97-448d-9571-a87004dc1e6a";s:11:"\0*\0filename";s:8:"img4.jpg";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}}', 'Completed', 'Importing Complete', 100, 'O:27:"RokGallery_Job_StateMachine":5:{s:9:"\0*\0_state";O:33:"RokGallery_Job_StateMap_Completed":2:{s:8:"\0*\0_name";s:33:"RokGallery_Job_StateMap.Completed";s:6:"\0*\0_id";i:8;}s:18:"\0*\0_previous_state";O:31:"RokGallery_Job_StateMap_Running":2:{s:8:"\0*\0_name";s:31:"RokGallery_Job_StateMap.Running";s:6:"\0*\0_id";i:2;}s:15:"\0*\0_state_stack";a:0:{}s:14:"\0*\0_transition";N;s:14:"\0*\0_debug_flag";b:0;}', '2012-07-10 22:34:39', '2012-07-10 22:34:41'),
('d93b8385-9726-424b-936f-05cfc8635dfa', 'Update Gallery', 'a:2:{s:9:"galleryId";s:1:"1";s:5:"files";a:4:{i:0;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"1";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:1;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"2";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:2;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"3";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:3;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"4";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}}}', 'Completed', 'Gallery Update Complete', 100, 'O:27:"RokGallery_Job_StateMachine":5:{s:9:"\0*\0_state";O:33:"RokGallery_Job_StateMap_Completed":2:{s:8:"\0*\0_name";s:33:"RokGallery_Job_StateMap.Completed";s:6:"\0*\0_id";i:8;}s:18:"\0*\0_previous_state";O:31:"RokGallery_Job_StateMap_Running":2:{s:8:"\0*\0_name";s:31:"RokGallery_Job_StateMap.Running";s:6:"\0*\0_id";i:2;}s:15:"\0*\0_state_stack";a:0:{}s:14:"\0*\0_transition";N;s:14:"\0*\0_debug_flag";b:0;}', '2012-07-10 23:23:21', '2012-07-10 23:23:22'),
('df75b68b-44c5-4667-9f02-b9f69ebab42a', 'Update Gallery', 'a:2:{s:9:"galleryId";s:1:"2";s:5:"files";a:5:{i:0;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"5";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:1;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"6";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:2;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"7";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:3;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"8";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:4;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"9";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}}}', 'Completed', 'Gallery Update Complete', 100, 'O:27:"RokGallery_Job_StateMachine":5:{s:9:"\0*\0_state";O:33:"RokGallery_Job_StateMap_Completed":2:{s:8:"\0*\0_name";s:33:"RokGallery_Job_StateMap.Completed";s:6:"\0*\0_id";i:8;}s:18:"\0*\0_previous_state";O:31:"RokGallery_Job_StateMap_Running":2:{s:8:"\0*\0_name";s:31:"RokGallery_Job_StateMap.Running";s:6:"\0*\0_id";i:2;}s:15:"\0*\0_state_stack";a:0:{}s:14:"\0*\0_transition";N;s:14:"\0*\0_debug_flag";b:0;}', '2012-07-11 00:32:05', '2012-07-11 00:32:06'),
('ec49f3e6-8d3c-4db4-e8d9-2d0a84e62fea', 'Update Gallery', 'a:2:{s:9:"galleryId";s:1:"2";s:5:"files";a:5:{i:0;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"5";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:1;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"6";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:2;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"7";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:3;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"8";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:4;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"9";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}}}', 'Completed', 'Gallery Update Complete', 100, 'O:27:"RokGallery_Job_StateMachine":5:{s:9:"\0*\0_state";O:33:"RokGallery_Job_StateMap_Completed":2:{s:8:"\0*\0_name";s:33:"RokGallery_Job_StateMap.Completed";s:6:"\0*\0_id";i:8;}s:18:"\0*\0_previous_state";O:31:"RokGallery_Job_StateMap_Running":2:{s:8:"\0*\0_name";s:31:"RokGallery_Job_StateMap.Running";s:6:"\0*\0_id";i:2;}s:15:"\0*\0_state_stack";a:0:{}s:14:"\0*\0_transition";N;s:14:"\0*\0_debug_flag";b:0;}', '2012-07-11 00:10:40', '2012-07-11 00:10:40'),
('f6dfc66a-c183-4394-8a7d-45a07b56d61a', 'Update Gallery', 'a:2:{s:9:"galleryId";s:1:"1";s:5:"files";a:4:{i:0;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"1";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:1;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"2";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:2;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"3";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:3;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"4";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}}}', 'Completed', 'Gallery Update Complete', 100, 'O:27:"RokGallery_Job_StateMachine":5:{s:9:"\0*\0_state";O:33:"RokGallery_Job_StateMap_Completed":2:{s:8:"\0*\0_name";s:33:"RokGallery_Job_StateMap.Completed";s:6:"\0*\0_id";i:8;}s:18:"\0*\0_previous_state";O:31:"RokGallery_Job_StateMap_Running":2:{s:8:"\0*\0_name";s:31:"RokGallery_Job_StateMap.Running";s:6:"\0*\0_id";i:2;}s:15:"\0*\0_state_stack";a:0:{}s:14:"\0*\0_transition";N;s:14:"\0*\0_debug_flag";b:0;}', '2012-07-10 22:56:19', '2012-07-10 22:56:19'),
('f7b18d2c-db8b-4e03-fff2-9aad4a52cf69', 'Update Gallery', 'a:2:{s:9:"galleryId";s:1:"1";s:5:"files";a:4:{i:0;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"1";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:1;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"2";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:2;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"3";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:3;O:35:"RokGallery_Job_Property_GalleryFile":4:{s:5:"\0*\0id";s:1:"4";s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}}}', 'Completed', 'Gallery Update Complete', 100, 'O:27:"RokGallery_Job_StateMachine":5:{s:9:"\0*\0_state";O:33:"RokGallery_Job_StateMap_Completed":2:{s:8:"\0*\0_name";s:33:"RokGallery_Job_StateMap.Completed";s:6:"\0*\0_id";i:8;}s:18:"\0*\0_previous_state";O:31:"RokGallery_Job_StateMap_Running":2:{s:8:"\0*\0_name";s:31:"RokGallery_Job_StateMap.Running";s:6:"\0*\0_id";i:2;}s:15:"\0*\0_state_stack";a:0:{}s:14:"\0*\0_transition";N;s:14:"\0*\0_debug_flag";b:0;}', '2012-07-10 22:54:36', '2012-07-10 22:54:36'),
('ffb08eac-73ef-4eb3-fb95-62080467acdf', 'Tag Addition', 'a:4:{i:0;O:32:"RokGallery_Job_Property_FileTags":5:{s:9:"\0*\0fileId";i:1;s:7:"\0*\0tags";a:1:{i:0;s:13:"fp-mainbottom";}s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:1;O:32:"RokGallery_Job_Property_FileTags":5:{s:9:"\0*\0fileId";i:4;s:7:"\0*\0tags";a:1:{i:0;s:13:"fp-mainbottom";}s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:2;O:32:"RokGallery_Job_Property_FileTags":5:{s:9:"\0*\0fileId";i:2;s:7:"\0*\0tags";a:1:{i:0;s:13:"fp-mainbottom";}s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}i:3;O:32:"RokGallery_Job_Property_FileTags":5:{s:9:"\0*\0fileId";i:3;s:7:"\0*\0tags";a:1:{i:0;s:13:"fp-mainbottom";}s:12:"\0*\0completed";b:1;s:8:"\0*\0error";b:0;s:9:"\0*\0status";N;}}', 'Completed', 'Tag Addition Complete', 100, 'O:27:"RokGallery_Job_StateMachine":5:{s:9:"\0*\0_state";O:33:"RokGallery_Job_StateMap_Completed":2:{s:8:"\0*\0_name";s:33:"RokGallery_Job_StateMap.Completed";s:6:"\0*\0_id";i:8;}s:18:"\0*\0_previous_state";O:31:"RokGallery_Job_StateMap_Running":2:{s:8:"\0*\0_name";s:31:"RokGallery_Job_StateMap.Running";s:6:"\0*\0_id";i:2;}s:15:"\0*\0_state_stack";a:0:{}s:14:"\0*\0_transition";N;s:14:"\0*\0_debug_flag";b:0;}', '2012-07-10 22:35:49', '2012-07-10 22:35:49');

-- --------------------------------------------------------

--
-- Table structure for table `#__rokgallery_profiles`
--

DROP TABLE IF EXISTS `#__rokgallery_profiles`;
CREATE TABLE IF NOT EXISTS `#__rokgallery_profiles` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) NOT NULL,
  `profile` text NOT NULL,
  `created_at` datetime NOT NULL,
  `updated_at` datetime NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`),
  KEY `#__rokgallery_profiles_name_idx` (`name`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__rokgallery_schema_version`
--

DROP TABLE IF EXISTS `#__rokgallery_schema_version`;
CREATE TABLE IF NOT EXISTS `#__rokgallery_schema_version` (
  `version` int(11) DEFAULT NULL
);

--
-- Dumping data for table `#__rokgallery_schema_version`
--

INSERT INTO `#__rokgallery_schema_version` (`version`) VALUES
(2);

-- --------------------------------------------------------

--
-- Table structure for table `#__rokgallery_slices`
--

DROP TABLE IF EXISTS `#__rokgallery_slices`;
CREATE TABLE IF NOT EXISTS `#__rokgallery_slices` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `file_id` int(10) unsigned NOT NULL,
  `gallery_id` int(10) unsigned DEFAULT NULL,
  `guid` char(36) NOT NULL,
  `title` varchar(200) DEFAULT NULL,
  `caption` text,
  `link` text,
  `filesize` int(10) unsigned NOT NULL,
  `xsize` int(10) unsigned NOT NULL,
  `ysize` int(10) unsigned NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `admin_thumb` tinyint(1) NOT NULL DEFAULT '0',
  `manipulations` longtext,
  `palette` text,
  `created_at` datetime NOT NULL,
  `updated_at` datetime NOT NULL,
  `slug` varchar(255) DEFAULT NULL,
  `thumb_xsize` int(10) unsigned NOT NULL,
  `thumb_ysize` int(10) unsigned NOT NULL,
  `thumb_keep_aspect` tinyint(1) NOT NULL DEFAULT '1',
  `thumb_background` varchar(12) DEFAULT NULL,
  `ordering` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`),
  UNIQUE KEY `guid` (`guid`),
  UNIQUE KEY `#__rokgallery_slices_sluggable_idx` (`slug`,`gallery_id`),
  KEY `rokgallery_slices_published_idx` (`published`),
  KEY `rokgallery_slices_guid_idx` (`guid`),
  KEY `file_id_idx` (`file_id`),
  KEY `gallery_id_idx` (`gallery_id`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__rokgallery_slices_index`
--

DROP TABLE IF EXISTS `#__rokgallery_slices_index`;
CREATE TABLE IF NOT EXISTS `#__rokgallery_slices_index` (
  `keyword` varchar(200) NOT NULL DEFAULT '',
  `field` varchar(50) NOT NULL DEFAULT '',
  `position` bigint(20) NOT NULL DEFAULT '0',
  `id` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`keyword`,`field`,`position`,`id`),
  KEY `rokgallery_slices_index_id_idx` (`id`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__rokgallery_slice_tags`
--

DROP TABLE IF EXISTS `#__rokgallery_slice_tags`;
CREATE TABLE IF NOT EXISTS `#__rokgallery_slice_tags` (
  `slice_id` int(10) unsigned NOT NULL DEFAULT '0',
  `tag` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`slice_id`,`tag`),
  KEY `rokgallery_slice_tags_slice_id_idx` (`slice_id`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__roksprocket_items`
--

DROP TABLE IF EXISTS `#__roksprocket_items`;
CREATE TABLE IF NOT EXISTS `#__roksprocket_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `module_id` varchar(45) NOT NULL,
  `provider` varchar(45) NOT NULL,
  `provider_id` varchar(45) NOT NULL,
  `order` int(10) unsigned NOT NULL,
  `params` text,
  PRIMARY KEY (`id`),
  KEY `idx_module` (`module_id`),
  KEY `idx_module_order` (`module_id`,`order`)
);

--
-- Dumping data for table `#__roksprocket_items`
--

INSERT INTO `#__roksprocket_items` (`id`, `module_id`, `provider`, `provider_id`, `order`, `params`) VALUES
(103, '160', 'joomla', '38', 0, '{"headlines_item_image":"-default-","headlines_item_link":"-default-","mosaic_item_title":"-default-","tabs_item_title":"-default-","lists_item_title":"-default-","tabs_item_icon":"-default-","mosaic_item_description":"-default-","mosaic_item_image":"-default-","tabs_item_link":"-default-","lists_item_image":"-default-","lists_item_link":"-default-","mosaic_item_link":"-default-","features_item_title":"-default-","mosaic_item_tags":null,"features_item_description":"-default-","features_item_image":"-default-","features_item_link":"-default-"}'),
(104, '160', 'joomla', '39', 1, '{"headlines_item_image":"-default-","headlines_item_link":"-default-","mosaic_item_title":"-default-","tabs_item_title":"-default-","lists_item_title":"-default-","tabs_item_icon":"-default-","mosaic_item_description":"-default-","mosaic_item_image":"-default-","tabs_item_link":"-default-","lists_item_image":"-default-","lists_item_link":"-default-","mosaic_item_link":"-default-","features_item_title":"-default-","mosaic_item_tags":null,"features_item_description":"-default-","features_item_image":"-default-","features_item_link":"-default-"}'),
(105, '160', 'joomla', '40', 2, '{"headlines_item_image":"-default-","headlines_item_link":"-default-","mosaic_item_title":"-default-","tabs_item_title":"-default-","lists_item_title":"-default-","tabs_item_icon":"-default-","mosaic_item_description":"-default-","mosaic_item_image":"-default-","tabs_item_link":"-default-","lists_item_image":"-default-","lists_item_link":"-default-","mosaic_item_link":"-default-","features_item_title":"-default-","mosaic_item_tags":null,"features_item_description":"-default-","features_item_image":"-default-","features_item_link":"-default-"}'),
(106, '160', 'joomla', '41', 3, '{"headlines_item_image":"-default-","headlines_item_link":"-default-","mosaic_item_title":"-default-","tabs_item_title":"-default-","lists_item_title":"-default-","tabs_item_icon":"-default-","mosaic_item_description":"-default-","mosaic_item_image":"-default-","tabs_item_link":"-default-","lists_item_image":"-default-","lists_item_link":"-default-","mosaic_item_link":"-default-","features_item_title":"-default-","mosaic_item_tags":null,"features_item_description":"-default-","features_item_image":"-default-","features_item_link":"-default-"}'),
(107, '160', 'joomla', '42', 4, '{"headlines_item_image":"-default-","headlines_item_link":"-default-","mosaic_item_title":"-default-","tabs_item_title":"-default-","lists_item_title":"-default-","tabs_item_icon":"-default-","mosaic_item_description":"-default-","mosaic_item_image":"-default-","tabs_item_link":"-default-","lists_item_image":"-default-","lists_item_link":"-default-","mosaic_item_link":"-default-","features_item_title":"-default-","mosaic_item_tags":null,"features_item_description":"-default-","features_item_image":"-default-","features_item_link":"-default-"}'),
(108, '160', 'joomla', '43', 5, '{"headlines_item_image":"-default-","headlines_item_link":"-default-","mosaic_item_title":"-default-","tabs_item_title":"-default-","lists_item_title":"-default-","tabs_item_icon":"-default-","mosaic_item_description":"-default-","mosaic_item_image":"-default-","tabs_item_link":"-default-","lists_item_image":"-default-","lists_item_link":"-default-","mosaic_item_link":"-default-","features_item_title":"-default-","mosaic_item_tags":null,"features_item_description":"-default-","features_item_image":"-default-","features_item_link":"-default-"}'),
(608, '155', 'joomla', '1', 0, '{"features_item_title":"Responsive Layout.","features_item_description":"<span>A <strong>Responsive<\\/strong> theme automatically adapts itself based on the viewing environment of the previewing device. <em class=\\"rt-extra-desc noitalic\\"> Kirigami is the first RocketTheme template to be responsive, and is built on the Gantry v3 Framework, with its standard feature set.<\\/em><\\/span>","features_item_image":"{''type'':''mediamanager'',''path'':''images\\/rocketlauncher\\/frontpage\\/roksprocket-features\\/img1.jpg'',''preview'':'''',''link'':''index.php?option=com_media&view=images&layout=default&tmpl=component&e_name=items_joomla_1__params_features_item_image&undefined''}","features_item_link":"-default-","mosaic_item_title":"-default-","tabs_item_title":"-default-","lists_item_title":"-default-","mosaic_item_description":"-default-","tabs_item_icon":"-default-","lists_item_image":"-default-","mosaic_item_image":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","mosaic_item_link":"-default-","lists_item_link":"-default-","mosaic_item_tags":null,"headlines_item_image":"-default-","lists_item_description":"-default-","headlines_item_link":"-default-","headlines_item_description":"-default-"}'),
(609, '155', 'joomla', '6', 1, '{"features_item_title":"Versatile RokSprocket.","features_item_description":"<span>The power multi-faceted content display module, <strong>RokSprocket<\\/strong>, with Kirigami integrated styling. <em class=\\"rt-extra-desc noitalic\\"> RokSprocket has support for several layout modes: Tabs, Headlines, Mosaic, Lists and Features. All are configurable from a custom, unified administrative interface.<\\/em><\\/span>","features_item_image":"{''type'':''mediamanager'',''path'':''images\\/rocketlauncher\\/frontpage\\/roksprocket-features\\/img2.jpg'',''preview'':'''',''link'':''index.php?option=com_media&view=images&layout=default&tmpl=component&e_name=items_joomla_6__params_features_item_image&undefined&undefined&undefined''}","features_item_link":"-default-","mosaic_item_title":"-default-","tabs_item_title":"-default-","lists_item_title":"-default-","mosaic_item_description":"-default-","tabs_item_icon":"-default-","lists_item_image":"-default-","mosaic_item_image":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","mosaic_item_link":"-default-","lists_item_link":"-default-","mosaic_item_tags":null,"headlines_item_image":"-default-","lists_item_description":"-default-","headlines_item_link":"-default-","headlines_item_description":"-default-"}'),
(610, '155', 'joomla', '10', 2, '{"features_item_title":"Multiple Variations.","features_item_description":"<span>An assortment of ten stunning <strong>preset<\\/strong> style variations to choose and <strong>configure<\\/strong> to your own personal tastes. <em class=\\"rt-extra-desc noitalic\\"> Additionally, there are a series of module class suffixes allowing for individual module style control, such as background style or layout characteristics.<\\/em><\\/span>","features_item_image":"{''type'':''mediamanager'',''path'':''images\\/rocketlauncher\\/frontpage\\/roksprocket-features\\/img3.jpg'',''preview'':'''',''link'':''index.php?option=com_media&view=images&layout=default&tmpl=component&e_name=items_joomla_10__params_features_item_image''}","features_item_link":"-default-","mosaic_item_title":"-default-","tabs_item_title":"-default-","lists_item_title":"-default-","mosaic_item_description":"-default-","tabs_item_icon":"-default-","lists_item_image":"-default-","mosaic_item_image":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","mosaic_item_link":"-default-","lists_item_link":"-default-","mosaic_item_tags":null,"headlines_item_image":"-default-","lists_item_description":"-default-","headlines_item_link":"-default-","headlines_item_description":"-default-"}'),
(700, '159', 'joomla', '44', 0, '{"lists_item_title":"-default-","lists_item_image":"-default-","lists_item_link":"-default-","lists_item_description":"-default-","mosaic_item_title":"-default-","tabs_item_title":"-default-","mosaic_item_description":"-default-","tabs_item_icon":"-default-","mosaic_item_image":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","mosaic_item_link":"-default-","mosaic_item_tags":null,"features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}'),
(701, '159', 'joomla', '45', 1, '{"lists_item_title":"-default-","lists_item_image":"-default-","lists_item_link":"-default-","lists_item_description":"-default-","mosaic_item_title":"-default-","tabs_item_title":"-default-","mosaic_item_description":"-default-","tabs_item_icon":"-default-","mosaic_item_image":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","mosaic_item_link":"-default-","mosaic_item_tags":null,"features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}'),
(702, '159', 'joomla', '46', 2, '{"lists_item_title":"-default-","lists_item_image":"-default-","lists_item_link":"-default-","lists_item_description":"-default-","mosaic_item_title":"-default-","tabs_item_title":"-default-","mosaic_item_description":"-default-","tabs_item_icon":"-default-","mosaic_item_image":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","mosaic_item_link":"-default-","mosaic_item_tags":null,"features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}'),
(703, '159', 'joomla', '48', 3, '{"lists_item_title":"-default-","lists_item_image":"-default-","lists_item_link":"-default-","lists_item_description":"-default-","mosaic_item_title":"-default-","tabs_item_title":"-default-","mosaic_item_description":"-default-","tabs_item_icon":"-default-","mosaic_item_image":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","mosaic_item_link":"-default-","mosaic_item_tags":null,"features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}'),
(704, '159', 'joomla', '47', 4, '{"lists_item_title":"-default-","lists_item_image":"-default-","lists_item_link":"-default-","lists_item_description":"-default-","mosaic_item_title":"-default-","tabs_item_title":"-default-","mosaic_item_description":"-default-","tabs_item_icon":"-default-","mosaic_item_image":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","mosaic_item_link":"-default-","mosaic_item_tags":null,"features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}'),
(705, '159', 'joomla', '49', 5, '{"lists_item_title":"-default-","lists_item_image":"-default-","lists_item_link":"-default-","lists_item_description":"-default-","mosaic_item_title":"-default-","tabs_item_title":"-default-","mosaic_item_description":"-default-","tabs_item_icon":"-default-","mosaic_item_image":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","mosaic_item_link":"-default-","mosaic_item_tags":null,"features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}'),
(706, '159', 'joomla', '50', 6, '{"lists_item_title":"-default-","lists_item_image":"-default-","lists_item_link":"-default-","lists_item_description":"-default-","mosaic_item_title":"-default-","tabs_item_title":"-default-","mosaic_item_description":"-default-","tabs_item_icon":"-default-","mosaic_item_image":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","mosaic_item_link":"-default-","mosaic_item_tags":null,"features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}'),
(707, '157', 'joomla', '22', 0, '{"tabs_item_title":"-default-","tabs_item_icon":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","mosaic_item_title":"-default-","lists_item_title":"-default-","mosaic_item_description":"-default-","lists_item_image":"-default-","mosaic_item_image":"-default-","mosaic_item_link":"-default-","lists_item_link":"-default-","mosaic_item_tags":null,"features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","lists_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}'),
(708, '157', 'joomla', '23', 1, '{"tabs_item_title":"-default-","tabs_item_icon":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","mosaic_item_title":"-default-","lists_item_title":"-default-","mosaic_item_description":"-default-","lists_item_image":"-default-","mosaic_item_image":"-default-","mosaic_item_link":"-default-","lists_item_link":"-default-","mosaic_item_tags":null,"features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","lists_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}'),
(709, '157', 'joomla', '24', 2, '{"tabs_item_title":"-default-","tabs_item_icon":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","mosaic_item_title":"-default-","lists_item_title":"-default-","mosaic_item_description":"-default-","lists_item_image":"-default-","mosaic_item_image":"-default-","mosaic_item_link":"-default-","lists_item_link":"-default-","mosaic_item_tags":null,"features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","lists_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}'),
(710, '157', 'joomla', '54', 3, '{"tabs_item_title":"-default-","tabs_item_icon":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","mosaic_item_title":"-default-","lists_item_title":"-default-","mosaic_item_description":"-default-","lists_item_image":"-default-","mosaic_item_image":"-default-","mosaic_item_link":"-default-","lists_item_link":"-default-","mosaic_item_tags":null,"features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","lists_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}'),
(711, '158', 'joomla', '25', 0, '{"mosaic_item_title":"-default-","mosaic_item_description":"-default-","mosaic_item_image":"{''type'':''mediamanager'',''path'':''images\\/rocketlauncher\\/frontpage\\/roksprocket-mosaic\\/img1.jpg'',''preview'':'''',''link'':''index.php?option=com_media&view=images&layout=default&tmpl=component&e_name=items_joomla_25__params_mosaic_item_image''}","mosaic_item_link":"-default-","mosaic_item_tags":"Portfolio, Videos","tabs_item_title":"-default-","lists_item_title":"-default-","tabs_item_icon":"-default-","lists_item_image":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","lists_item_link":"-default-","features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","lists_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}'),
(712, '158', 'joomla', '26', 1, '{"mosaic_item_title":"-default-","mosaic_item_description":"-default-","mosaic_item_image":"{''type'':''mediamanager'',''path'':''images\\/rocketlauncher\\/frontpage\\/roksprocket-mosaic\\/img2.jpg'',''preview'':'''',''link'':''index.php?option=com_media&view=images&layout=default&tmpl=component&e_name=items_joomla_26__params_mosaic_item_image''}","mosaic_item_link":"-default-","mosaic_item_tags":"Videos, Blog","tabs_item_title":"-default-","lists_item_title":"-default-","tabs_item_icon":"-default-","lists_item_image":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","lists_item_link":"-default-","features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","lists_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}'),
(713, '158', 'joomla', '27', 2, '{"mosaic_item_title":"-default-","mosaic_item_description":"-default-","mosaic_item_image":"{''type'':''mediamanager'',''path'':''images\\/rocketlauncher\\/frontpage\\/roksprocket-mosaic\\/img3.jpg'',''preview'':'''',''link'':''index.php?option=com_media&view=images&layout=default&tmpl=component&e_name=items_joomla_27__params_mosaic_item_image''}","mosaic_item_link":"-default-","mosaic_item_tags":"Blog, Portfolio","tabs_item_title":"-default-","lists_item_title":"-default-","tabs_item_icon":"-default-","lists_item_image":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","lists_item_link":"-default-","features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","lists_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}'),
(714, '158', 'joomla', '28', 3, '{"mosaic_item_title":"-default-","mosaic_item_description":"-default-","mosaic_item_image":"{''type'':''mediamanager'',''path'':''images\\/rocketlauncher\\/frontpage\\/roksprocket-mosaic\\/img4.jpg'',''preview'':'''',''link'':''index.php?option=com_media&view=images&layout=default&tmpl=component&e_name=items_joomla_28__params_mosaic_item_image''}","mosaic_item_link":"-default-","mosaic_item_tags":"Portfolio, Videos","tabs_item_title":"-default-","lists_item_title":"-default-","tabs_item_icon":"-default-","lists_item_image":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","lists_item_link":"-default-","features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","lists_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}'),
(715, '158', 'joomla', '29', 4, '{"mosaic_item_title":"-default-","mosaic_item_description":"-default-","mosaic_item_image":"{''type'':''mediamanager'',''path'':''images\\/rocketlauncher\\/frontpage\\/roksprocket-mosaic\\/img5.jpg'',''preview'':'''',''link'':''index.php?option=com_media&view=images&layout=default&tmpl=component&e_name=items_joomla_29__params_mosaic_item_image''}","mosaic_item_link":"-default-","mosaic_item_tags":"Videos, Blog","tabs_item_title":"-default-","lists_item_title":"-default-","tabs_item_icon":"-default-","lists_item_image":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","lists_item_link":"-default-","features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","lists_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}'),
(716, '158', 'joomla', '30', 5, '{"mosaic_item_title":"-default-","mosaic_item_description":"-default-","mosaic_item_image":"{''type'':''mediamanager'',''path'':''images\\/rocketlauncher\\/frontpage\\/roksprocket-mosaic\\/img6.jpg'',''preview'':'''',''link'':''index.php?option=com_media&view=images&layout=default&tmpl=component&e_name=items_joomla_30__params_mosaic_item_image''}","mosaic_item_link":"-default-","mosaic_item_tags":"Blog, Portfolio","tabs_item_title":"-default-","lists_item_title":"-default-","tabs_item_icon":"-default-","lists_item_image":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","lists_item_link":"-default-","features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","lists_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}'),
(717, '158', 'joomla', '31', 6, '{"mosaic_item_title":"-default-","mosaic_item_description":"-default-","mosaic_item_image":"{''type'':''mediamanager'',''path'':''images\\/rocketlauncher\\/frontpage\\/roksprocket-mosaic\\/img7.jpg'',''preview'':'''',''link'':''index.php?option=com_media&view=images&layout=default&tmpl=component&e_name=items_joomla_31__params_mosaic_item_image''}","mosaic_item_link":"-default-","mosaic_item_tags":"Portfolio, Videos","tabs_item_title":"-default-","lists_item_title":"-default-","tabs_item_icon":"-default-","lists_item_image":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","lists_item_link":"-default-","features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","lists_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}'),
(718, '158', 'joomla', '53', 7, '{"mosaic_item_title":"-default-","mosaic_item_description":"-default-","mosaic_item_image":"{''type'':''mediamanager'',''path'':''images\\/rocketlauncher\\/frontpage\\/roksprocket-mosaic\\/img8.jpg'',''preview'':'''',''link'':''index.php?option=com_media&view=images&layout=default&tmpl=component&e_name=items_joomla_53__params_mosaic_item_image''}","mosaic_item_link":"-default-","mosaic_item_tags":"Videos,Blog","tabs_item_title":"-default-","lists_item_title":"-default-","tabs_item_icon":"-default-","lists_item_image":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","lists_item_link":"-default-","features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","lists_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}'),
(719, '158', 'joomla', '33', 8, '{"mosaic_item_title":"-default-","mosaic_item_description":"-default-","mosaic_item_image":"{''type'':''mediamanager'',''path'':''images\\/rocketlauncher\\/frontpage\\/roksprocket-mosaic\\/img9.jpg'',''preview'':'''',''link'':''index.php?option=com_media&view=images&layout=default&tmpl=component&e_name=items_joomla_33__params_mosaic_item_image''}","mosaic_item_link":"-default-","mosaic_item_tags":"Blog, Portfolio","tabs_item_title":"-default-","lists_item_title":"-default-","tabs_item_icon":"-default-","lists_item_image":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","lists_item_link":"-default-","features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","lists_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}'),
(720, '158', 'joomla', '34', 9, '{"mosaic_item_title":"-default-","mosaic_item_description":"-default-","mosaic_item_image":"{''type'':''mediamanager'',''path'':''images\\/rocketlauncher\\/frontpage\\/roksprocket-mosaic\\/img10.jpg'',''preview'':'''',''link'':''index.php?option=com_media&view=images&layout=default&tmpl=component&e_name=items_joomla_34__params_mosaic_item_image''}","mosaic_item_link":"-default-","mosaic_item_tags":"Portfolio, Videos","tabs_item_title":"-default-","lists_item_title":"-default-","tabs_item_icon":"-default-","lists_item_image":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","lists_item_link":"-default-","features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","lists_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}'),
(721, '158', 'joomla', '35', 10, '{"mosaic_item_title":"-default-","mosaic_item_description":"-default-","mosaic_item_image":"{''type'':''mediamanager'',''path'':''images\\/rocketlauncher\\/frontpage\\/roksprocket-mosaic\\/img11.jpg'',''preview'':'''',''link'':''index.php?option=com_media&view=images&layout=default&tmpl=component&e_name=items_joomla_35__params_mosaic_item_image''}","mosaic_item_link":"-default-","mosaic_item_tags":"Videos, Blog","tabs_item_title":"-default-","lists_item_title":"-default-","tabs_item_icon":"-default-","lists_item_image":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","lists_item_link":"-default-","features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","lists_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}'),
(722, '158', 'joomla', '36', 11, '{"mosaic_item_title":"-default-","mosaic_item_description":"-default-","mosaic_item_image":"{''type'':''mediamanager'',''path'':''images\\/rocketlauncher\\/frontpage\\/roksprocket-mosaic\\/img12.jpg'',''preview'':'''',''link'':''index.php?option=com_media&view=images&layout=default&tmpl=component&e_name=items_joomla_36__params_mosaic_item_image''}","mosaic_item_link":"-default-","mosaic_item_tags":"Blog, Portfolio","tabs_item_title":"-default-","lists_item_title":"-default-","tabs_item_icon":"-default-","lists_item_image":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","lists_item_link":"-default-","features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","lists_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}'),
(723, '158', 'joomla', '37', 12, '{"mosaic_item_title":"-default-","mosaic_item_description":"-default-","mosaic_item_image":"{''type'':''mediamanager'',''path'':''images\\/rocketlauncher\\/frontpage\\/roksprocket-mosaic\\/img13.jpg'',''preview'':'''',''link'':''index.php?option=com_media&view=images&layout=default&tmpl=component&e_name=items_joomla_37__params_mosaic_item_image''}","mosaic_item_link":"-default-","mosaic_item_tags":"Portfolio, Blog, Videos","tabs_item_title":"-default-","lists_item_title":"-default-","tabs_item_icon":"-default-","lists_item_image":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","lists_item_link":"-default-","features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","lists_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}'),
(724, '158', 'joomla', '51', 13, '{"mosaic_item_title":"-default-","mosaic_item_description":"-default-","mosaic_item_image":"{''type'':''mediamanager'',''path'':''images\\/rocketlauncher\\/frontpage\\/roksprocket-mosaic\\/img14.jpg'',''preview'':'''',''link'':''index.php?option=com_media&view=images&layout=default&tmpl=component&e_name=items_joomla_51__params_mosaic_item_image''}","mosaic_item_link":"-default-","mosaic_item_tags":"Videos, Portfolio, Blog","tabs_item_title":"-default-","lists_item_title":"-default-","tabs_item_icon":"-default-","lists_item_image":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","lists_item_link":"-default-","features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","lists_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}'),
(725, '158', 'joomla', '52', 14, '{"mosaic_item_title":"-default-","mosaic_item_description":"-default-","mosaic_item_image":"{''type'':''mediamanager'',''path'':''images\\/rocketlauncher\\/frontpage\\/roksprocket-mosaic\\/img15.jpg'',''preview'':'''',''link'':''index.php?option=com_media&view=images&layout=default&tmpl=component&e_name=items_joomla_52__params_mosaic_item_image''}","mosaic_item_link":"-default-","mosaic_item_tags":"Blog, Portfolio, Videos","tabs_item_title":"-default-","lists_item_title":"-default-","tabs_item_icon":"-default-","lists_item_image":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","lists_item_link":"-default-","features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","lists_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}'),
(726, '158', 'joomla', '32', 15, '{"mosaic_item_title":"-default-","mosaic_item_description":"-default-","mosaic_item_image":"{''type'':''mediamanager'',''path'':''images\\/rocketlauncher\\/frontpage\\/roksprocket-mosaic\\/img16.jpg'',''preview'':'''',''link'':''index.php?option=com_media&view=images&layout=default&tmpl=component&e_name=items_joomla_32__params_mosaic_item_image''}","mosaic_item_link":"-default-","mosaic_item_tags":"Portfolio,Videos,Blog","tabs_item_title":"-default-","lists_item_title":"-default-","tabs_item_icon":"-default-","lists_item_image":"-default-","tabs_item_link":"-default-","tabs_item_description":"-default-","lists_item_link":"-default-","features_item_title":"-default-","headlines_item_image":"-default-","features_item_description":"-default-","lists_item_description":"-default-","headlines_item_link":"-default-","features_item_image":"-default-","headlines_item_description":"-default-","features_item_link":"-default-"}');

-- --------------------------------------------------------

--
-- Table structure for table `#__schemas`
--

DROP TABLE IF EXISTS `#__schemas`;
CREATE TABLE IF NOT EXISTS `#__schemas` (
  `extension_id` int(11) NOT NULL,
  `version_id` varchar(20) NOT NULL,
  PRIMARY KEY (`extension_id`,`version_id`)
);

--
-- Dumping data for table `#__schemas`
--

INSERT INTO `#__schemas` (`extension_id`, `version_id`) VALUES
(700, '2.5.6');

-- --------------------------------------------------------

--
-- Table structure for table `#__template_styles`
--

DROP TABLE IF EXISTS `#__template_styles`;
CREATE TABLE IF NOT EXISTS `#__template_styles` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `template` varchar(50) NOT NULL DEFAULT '',
  `client_id` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `home` char(7) NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_template` (`template`),
  KEY `idx_home` (`home`)
);

--
-- Dumping data for table `#__template_styles`
--

INSERT INTO `#__template_styles` (`id`, `template`, `client_id`, `home`, `title`, `params`) VALUES
(2, 'bluestork', 1, '1', 'Bluestork - Default', '{"useRoundedCorners":"1","showSiteName":"0"}'),
(3, 'atomic', 0, '0', 'Atomic - Default', '{}'),
(4, 'beez_20', 0, '0', 'Beez2 - Default', '{"wrapperSmall":"53","wrapperLarge":"72","logo":"images\\/joomla_black.gif","sitetitle":"Joomla!","sitedescription":"Open Source Content Management","navposition":"left","templatecolor":"personal","html5":"0"}'),
(5, 'hathor', 1, '0', 'Hathor - Default', '{"showSiteName":"0","colourChoice":"","boldText":"0"}'),
(6, 'beez5', 0, '0', 'Beez5 - Default', '{"wrapperSmall":"53","wrapperLarge":"72","logo":"images\\/sampledata\\/fruitshop\\/fruits.gif","sitetitle":"Joomla!","sitedescription":"Open Source Content Management","navposition":"left","html5":"0"}'),
(7, 'rt_kirigami', 0, '1', 'rt_kirigami - Default', '{"master":"true","current_id":"7","template_full_name":"Kirigami","grid_system":"12","template_prefix":"kirigami-","cookie_time":"31536000","name":"Preset1","copy_lang_files_if_diff":"1","main":{"body":"light","accent":"#76a226","bg":"paper"},"loadtransition":"0","webfonts":{"enabled":"0","source":"google"},"font":{"family":"kirigami","size":"default","size-is":"default"},"viewswitcher-priority":"1","logo-priority":"2","copyright-priority":"3","styledeclaration-priority":"4","date-priority":"6","fontsizer-priority":"7","totop-priority":"8","systemmessages-priority":"9","morearticles-priority":"12","smartload-priority":"13","pagesuffix-priority":"14","resetsettings-priority":"15","analytics-priority":"16","fusionmenu-priority":"18","jstools-priority":"21","moduleoverlays-priority":"22","rtl-priority":"23","splitmenu-priority":"24","webfonts-priority":"27","styledeclaration-enabled":"1","logo":{"enabled":"1","position":"header-a","type":"kirigami","kirigami":{"logostyle":"style1"},"custom":{"image":""}},"social":{"enabled":"1","position":"social","twitter":"https:\\/\\/twitter.com\\/rockettheme","facebook":"http:\\/\\/www.facebook.com\\/RocketTheme","google":"https:\\/\\/plus.google.com\\/114430407008695950828\\/posts","rss":"http:\\/\\/www.rockettheme.com\\/blog?format=feed&amp;type=rss"},"date":{"enabled":"0","position":"utility-a","clientside":"0","formats":"%A, %B %d, %Y"},"fontsizer":{"enabled":"0","position":"utility-b"},"login":{"enabled":"0","position":"utility-c","text":"Member Login","logouttext":"Logout"},"popup":{"enabled":"0","position":"utility-d","text":"Popup Module","width":"250","height":"235"},"branding":{"enabled":"0","position":"copyright-c"},"copyright":{"enabled":"1","position":"copyright-a","text":"Designed by RocketTheme","layout":"a:1:{i:12;a:2:{i:2;a:2:{i:0;i:6;i:1;i:6;}i:3;a:3:{i:0;i:4;i:1;i:6;i:2;i:2;}}}","showall":"0","showmax":"6"},"smartload":{"enabled":"0","text":"200","ignores":"com_community,com_contact,com_k2,com_tienda,com_weblinks","exclusion":""},"morearticles":{"enabled":"0","text":"Load More Articles","pagination":"1"},"totop":{"enabled":"1","position":"copyright-c"},"systemmessages":{"enabled":"1","position":"drawer"},"resetsettings":{"enabled":"0","position":"footer-b","text":"Reset Settings"},"analytics":{"enabled":"0","code":"","position":"analytics"},"menu":{"enabled":"1","type":"fusionmenu","fusionmenu":{"menutype":"mainmenu","position":"header-b","enable_js":"1","opacity":"1","effect":"slidefade","hidedelay":"500","menu-animation":"Circ.easeOut","menu-duration":"300","centered-offset":"0","tweak-initial-x":"-8","tweak-initial-y":"-8","tweak-subsequent-x":"-8","tweak-subsequent-y":"-11","tweak-width":"18","tweak-height":"20","enable-current-id":"0","theme":"gantry-fusion","limit_levels":"0","startLevel":"0","showAllChildren":"1","class_sfx":"top","cache":"0","module_cache":"1"},"splitmenu":{"roknavmenu_fusion_enable-current-id":"0","menutype":"mainmenu","theme":"gantry-splitmenu","mainmenu-position":"header-b","mainmenu-limit_levels":"1","mainmenu-startLevel":"0","mainmenu-endLevel":"0","mainmenu-class_sfx":"top","submenu-position":"sidebar-a","submenu-title":"1","submenu-limit_levels":"1","submenu-startLevel":"1","submenu-endLevel":"9","submenu-module_sfx":"box3","submenu-class_sfx":"","cache":"0","module_cache":"1"}},"top":{"layout":"3,3,3,3","showall":"0","showmax":"6"},"header":{"layout":"a:1:{i:12;a:1:{i:2;a:2:{i:0;i:3;i:1;i:9;}}}","showall":"0","showmax":"6"},"feature":{"layout":"3,3,3,3","showall":"0","showmax":"6"},"showcase":{"layout":"3,3,3,3","showall":"0","showmax":"6"},"utility":{"layout":"3,3,3,3","showall":"0","showmax":"6"},"maintop":{"layout":"3,3,3,3","showall":"0","showmax":"6"},"mainbodyPosition":"6,3,3","mainbottom":{"layout":"3,3,3,3","showall":"0","showmax":"6"},"extension":{"layout":"3,3,3,3","showall":"0","showmax":"6"},"bottom":{"layout":"3,3,3,3","showall":"0","showmax":"6"},"footer":{"layout":"3,3,3,3","showall":"0","showmax":"6"},"cache":{"enabled":"0","time":"900"},"component-enabled":"1","mainbody-enabled":"1","rtl-enabled":"1","moduleoverlays-enabled":"1","pagesuffix-enabled":"1","typography":{"enabled":"1","style":"light"},"k2":"1"}'),
(8, 'rt_kirigami', 0, '0', 'rt_kirigami - Module Positions', '{"master":"7","current_id":"8","mainbodyPosition":"a:1:{i:12;a:2:{i:1;a:1:{s:2:\\"mb\\";i:12;}i:2;a:2:{s:2:\\"mb\\";i:6;s:2:\\"sa\\";i:6;}}}"}'),
(9, 'rt_kirigami', 0, '0', 'rt_kirigami - Module Variations', '{"master":"7","current_id":"9","mainbodyPosition":"a:1:{i:12;a:1:{i:2;a:2:{s:2:\\"mb\\";i:8;s:2:\\"sa\\";i:4;}}}"}');

-- --------------------------------------------------------

--
-- Table structure for table `#__updates`
--

DROP TABLE IF EXISTS `#__updates`;
CREATE TABLE IF NOT EXISTS `#__updates` (
  `update_id` int(11) NOT NULL AUTO_INCREMENT,
  `update_site_id` int(11) DEFAULT '0',
  `extension_id` int(11) DEFAULT '0',
  `categoryid` int(11) DEFAULT '0',
  `name` varchar(100) DEFAULT '',
  `description` text NOT NULL,
  `element` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `folder` varchar(20) DEFAULT '',
  `client_id` tinyint(3) DEFAULT '0',
  `version` varchar(10) DEFAULT '',
  `data` text NOT NULL,
  `detailsurl` text NOT NULL,
  `infourl` text NOT NULL,
  PRIMARY KEY (`update_id`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__update_categories`
--

DROP TABLE IF EXISTS `#__update_categories`;
CREATE TABLE IF NOT EXISTS `#__update_categories` (
  `categoryid` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(20) DEFAULT '',
  `description` text NOT NULL,
  `parent` int(11) DEFAULT '0',
  `updatesite` int(11) DEFAULT '0',
  PRIMARY KEY (`categoryid`)
);

-- --------------------------------------------------------

--
-- Table structure for table `#__update_sites`
--

DROP TABLE IF EXISTS `#__update_sites`;
CREATE TABLE IF NOT EXISTS `#__update_sites` (
  `update_site_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `location` text NOT NULL,
  `enabled` int(11) DEFAULT '0',
  `last_check_timestamp` bigint(20) DEFAULT '0',
  PRIMARY KEY (`update_site_id`)
);

--
-- Dumping data for table `#__update_sites`
--

INSERT INTO `#__update_sites` (`update_site_id`, `name`, `type`, `location`, `enabled`, `last_check_timestamp`) VALUES
(1, 'Joomla Core', 'collection', 'http://update.joomla.org/core/list.xml', 1, 1343745354),
(2, 'Joomla Extension Directory', 'collection', 'http://update.joomla.org/jed/list.xml', 1, 1343745354),
(3, 'Gantry Framework Update Site', 'extension', 'http://www.gantry-framework.org/updates/joomla16/gantry.xml', 1, 1343745354),
(4, 'RocketTheme Update Directory', 'collection', 'http://updates.rockettheme.com/joomla/updates.xml', 1, 1343745354);

-- --------------------------------------------------------

--
-- Table structure for table `#__update_sites_extensions`
--

DROP TABLE IF EXISTS `#__update_sites_extensions`;
CREATE TABLE IF NOT EXISTS `#__update_sites_extensions` (
  `update_site_id` int(11) NOT NULL DEFAULT '0',
  `extension_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`update_site_id`,`extension_id`)
);

--
-- Dumping data for table `#__update_sites_extensions`
--

INSERT INTO `#__update_sites_extensions` (`update_site_id`, `extension_id`) VALUES
(1, 700),
(2, 700),
(3, 803),
(4, 810),
(4, 824),
(4, 833),
(4, 853);

-- --------------------------------------------------------

--
-- Table structure for table `#__viewlevels`
--

DROP TABLE IF EXISTS `#__viewlevels`;
CREATE TABLE IF NOT EXISTS `#__viewlevels` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `title` varchar(100) NOT NULL DEFAULT '',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_assetgroup_title_lookup` (`title`)
);

--
-- Dumping data for table `#__viewlevels`
--

INSERT INTO `#__viewlevels` (`id`, `title`, `ordering`, `rules`) VALUES
(1, 'Public', 0, '[1]'),
(2, 'Registered', 1, '[6,2,8]'),
(3, 'Special', 2, '[6,3,8]');

-- --------------------------------------------------------

--
-- Table structure for table `#__weblinks`
--

DROP TABLE IF EXISTS `#__weblinks`;
CREATE TABLE IF NOT EXISTS `#__weblinks` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `catid` int(11) NOT NULL DEFAULT '0',
  `sid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `url` varchar(250) NOT NULL DEFAULT '',
  `description` text NOT NULL,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(11) NOT NULL DEFAULT '0',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `archived` tinyint(1) NOT NULL DEFAULT '0',
  `approved` tinyint(1) NOT NULL DEFAULT '1',
  `access` int(11) NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if link is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
);

--
-- Dumping data for table `#__weblinks`
--

INSERT INTO `#__weblinks` (`id`, `catid`, `sid`, `title`, `alias`, `url`, `description`, `date`, `hits`, `state`, `checked_out`, `checked_out_time`, `ordering`, `archived`, `approved`, `access`, `params`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`) VALUES
(1, 10, 0, 'Joomla Template', 'joomla-template', 'http://www.rockettheme.com/joomla', '', '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 1, 0, 1, 1, '{"target":"","width":"","height":"","count_clicks":""}', '*', '2012-07-09 11:41:54', 535, '', '0000-00-00 00:00:00', 0, '', '', '{"robots":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(2, 10, 0, 'Wordpress Theme', 'wordpress-theme', 'http://www.rockettheme.com/wordpress', '', '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 2, 0, 1, 1, '{"target":"","width":"","height":"","count_clicks":""}', '*', '2012-07-09 11:42:01', 535, '', '0000-00-00 00:00:00', 0, '', '', '{"robots":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(3, 10, 0, 'phpBB3 Style', 'phpbb3-style', 'http://www.rockettheme.com/phpbb3', '', '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 3, 0, 1, 1, '{"target":"","width":"","height":"","count_clicks":""}', '*', '2012-07-09 11:42:18', 535, '', '2012-07-09 11:42:31', 890, '', '', '{"robots":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(4, 10, 0, 'Magento Template', 'magento-template', 'http://www.rockettheme.com/magento', '', '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 4, 0, 1, 1, '{"target":"","width":"","height":"","count_clicks":""}', '*', '2012-07-09 11:42:25', 535, '', '0000-00-00 00:00:00', 0, '', '', '{"robots":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00');

--
-- Constraints for dumped tables
--

--
-- Constraints for table `#__rokgallery_files_index`
--
ALTER TABLE `#__rokgallery_files_index`
  ADD CONSTRAINT `#__rokgallery_files_index_id_idx` FOREIGN KEY (`id`) REFERENCES `#__rokgallery_files` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Constraints for table `#__rokgallery_file_loves`
--
ALTER TABLE `#__rokgallery_file_loves`
  ADD CONSTRAINT `#__file_loves_file_id_files_id` FOREIGN KEY (`file_id`) REFERENCES `#__rokgallery_files` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Constraints for table `#__rokgallery_file_tags`
--
ALTER TABLE `#__rokgallery_file_tags`
  ADD CONSTRAINT `#__file_tags_file_id_files_id` FOREIGN KEY (`file_id`) REFERENCES `#__rokgallery_files` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Constraints for table `#__rokgallery_file_views`
--
ALTER TABLE `#__rokgallery_file_views`
  ADD CONSTRAINT `#__file_views_file_id__files_id` FOREIGN KEY (`file_id`) REFERENCES `#__rokgallery_files` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Constraints for table `#__rokgallery_slices`
--
ALTER TABLE `#__rokgallery_slices`
  ADD CONSTRAINT `#__slices_file_id_files_id` FOREIGN KEY (`file_id`) REFERENCES `#__rokgallery_files` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `#__slices_gallery_id_galleries_id` FOREIGN KEY (`gallery_id`) REFERENCES `#__rokgallery_galleries` (`id`) ON DELETE SET NULL ON UPDATE CASCADE;

--
-- Constraints for table `#__rokgallery_slices_index`
--
ALTER TABLE `#__rokgallery_slices_index`
  ADD CONSTRAINT `#__rokgallery_slices_index_id_idx` FOREIGN KEY (`id`) REFERENCES `#__rokgallery_slices` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Constraints for table `#__rokgallery_slice_tags`
--
ALTER TABLE `#__rokgallery_slice_tags`
  ADD CONSTRAINT `#__slice_tags_slice_id_slices_id` FOREIGN KEY (`slice_id`) REFERENCES `#__rokgallery_slices` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;